ROUND2 equ 10


;  Procedure calculate slices horizontal line -> buffer, wich ------
;  describes depth history of each screen pixel. each pixel 4 float
;  dwords lowest z coords. -----------------------------------------

stencil_slices_line:
;----------------------------------------------------
;-------------in xmm0 - lo -> hi z1, z2 -------------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- esi - pointer to buff --------------


.dz equ  [ebp-4]
.z2 equ  [ebp-8]
.z1 equ  [ebp-12]
.x2 equ  [ebp-16]
.x1 equ  [ebp-20]
.s_buf	equ [ebp-24]
;.ptr_buff equ	[ebp-28]

     push	ebp
     mov	ebp,esp
     sub	esp,64
     or 	cx,cx
     jle	.l_quit

     cmp	cx,[yres_var]
     jge	.l_quit

     movzx	ecx,cx
     mov	.s_buf,esi  ;edi
;     mov	 .ptr_buff,edi
     cmp	eax,ebx
     je 	.l_quit
     jl 	.l_ok

     xchg	eax,ebx
     shufps	xmm0,xmm0,11100001b
   .l_ok:

     cmp	ax,[xres_var]
     jge	.l_quit
     cmp	bx,0
     jle	.l_quit
 ;    mov	 edi,esi
     movlps	.z1,xmm0
     mov	.x1,eax
     mov	.x2,ebx

     sub	ebx,eax
     movss	xmm0,.z2
     cvtsi2ss	xmm1,ebx
     subss	xmm0,.z1
     divss	xmm0,xmm1
     movss	.dz,xmm0

     movzx	edx,word[xres_var]
     cmp	eax,1
     jge	@f
     mov	eax,.x1
     neg	eax
     cvtsi2ss	xmm2,eax
     mulss	xmm2,.dz
     addss	xmm2,.z1
     movss	.z1,xmm2
     mov	dword .x1,0
     movzx	edx,word[xres_var]
     sub	edx,1
   @@:
     cmp	.x2,edx
     jl 	@f
     mov	.x2,edx

    @@:
     movzx	edx,word[xres_var]
     mov	edi,.s_buf
     mov	eax,ecx  ; y
     mul	edx
     mov	edx,ecx ; edx - y
     add	eax,.x1

     shl	eax,4
     add	edi,eax

     mov	ecx,.x2
     sub	ecx,.x1
     movss	xmm2,.z1   ; cz
   .ccalc:

     shufps    xmm2,xmm2,0
     movaps    xmm1,xmm2
     movaps    xmm3,[edi]
     cmpltps   xmm1,[edi]
     pmovmskb	eax,xmm1
  ;   or	eax,eax      ; impossible
  ;   jz	.update_counters
     cmp       eax,0xffff
     jnz       @f
     shufps    xmm3,xmm3,10010000b
     movaps    [edi],xmm3
     movss     [edi],xmm2
     jmp       .update_counters
  @@:
     cmp	eax,0xfff0
     jnz	@f
     shufps	xmm3,xmm3,10010000b
     movaps	[edi],xmm3
     movss	[edi+4],xmm2
     jmp	.update_counters
  @@:
     cmp	eax,0xff00
     jnz	@f
     shufps	xmm3,xmm3,10000100b
     movaps	[edi],xmm3
     movss	[edi+8],xmm2
     jmp	.update_counters
  @@:
     cmp	eax,0xf000
     jnz	@f
     movss	[edi+12],xmm2
  @@:
 .update_counters:
     add       edi,16
     addss     xmm2,.dz
 ;    sub	ecx,1
 ;    jnz	.ccalc
     loop	.ccalc
  .l_quit:
     mov       esp,ebp
     pop       ebp
ret
