
draw_thread:	    ; in: eax - thread number; 0 - first thread
    push   ebp
    mov    ebp,esp
    sub    esp,300
    and    ebp,-16
    sub    ebp,128  ; to make shorter locals adresses




    .thread_no	    equ dword[ebp-4]
    .x_min	    equ word[ebp-6]
    .x_max	    equ word[ebp-8]
    .y_min	    equ [ebp-10]
    .y_max	    equ [ebp-12]
    .third_p_index  equ dword[ebp-16]
    .second_p_index equ dword[ebp-20]
    .first_p_index  equ dword[ebp-24]
    .zz3f	    equ dword[ebp-28]
    .zz2f	    equ dword[ebp-32]
    .zz1f	    equ [ebp-36]
   .xy3 	    equ ebp-40
   .xy2 	    equ ebp-44
   .xy1 	    equ ebp-48
   .zz3 	    equ [ebp-52]
   .zz2 	    equ [ebp-54]
   .zz1 	    equ [ebp-56]
   .i12 	    equ dword[ebp-60]
   .scr 	    equ dword[ebp-64]
   .zbuf	    equ dword[ebp-68]
   .in1 	    equ [ebp-72]
   .in2 	    equ [ebp-76]
   .in3 	    equ [ebp-80]
   .por 	    equ dword[ebp-84]
   .pnr 	    equ dword[ebp-88]
   .tex_pts	    equ dword[ebp-92]
   .cur_tri	    equ dword[ebp-96]
   .zer_hgst	    equ [ebp-112]
   .last_ptr	    equ [ebp-128-32]  ; needed for ray shd
   .pack1	    equ [ebp-128]     ; min max compare
   .tri_proc	     equ dword	[ebp]
   .r_phg_bf_line_z    equ dword  [ebp+20]
   .glass_tex_line_sl  equ dword  [ebp+24]
   .glass_tex_line     equ dword  [ebp+28]
   .glass_line	       equ dword  [ebp+32]
   .real_phg_line_col  equ dword  [ebp+36]
   .draw_flag	       equ dword  [ebp+40]
   .tx_line	       equ dword  [ebp+44]
   .correct_texf       equ	  [ebp+48]
   .tx_esi	       equ dword  [ebp+64]
   .tex_points_f_ptr   equ dword  [ebp+68]
   .slices_ptrs_buff_ptr equ dword[ebp+72]
   .env_hint		equ dword[ebp+76]
   .xres		equ	 [ebp+80]
   .yres		equ word [ebp+82]
   .pack2		equ	 [ebp+96]
;   .env_hint		  equ	   [ebp+100]


    mov    .thread_no,ebx



    push   dword r_phg_bf_line_z
    pop    .r_phg_bf_line_z
    push   dword glass_tex_line_sl
    pop    .glass_tex_line_sl
    push   dword glass_tex_line
    pop    .glass_tex_line
    push   dword real_phg_line_col
    pop    .real_phg_line_col

    push   dword glass_line
    pop    .glass_line
    movaps xmm0,[correct_texf]
    movaps .correct_texf,xmm0
    push   [points_rotated_ptr]
    pop    .por
    push   [points_normals_rotated_ptr]
    pop    .pnr
    movaps xmm0,[zero_hgst_dd]
    movaps .zer_hgst,xmm0
    push   [i12]
    pop    .i12
    push   [tex_points_ptr]
    pop    .tex_pts
    push   [screen_ptr]
    pop    .scr
    push   [Zbuffer_ptr]
    pop    .zbuf
    push   [tex_points_f_ptr]
    pop    .tex_points_f_ptr
    push   [slices_ptrs_buff_ptr]
    pop    .slices_ptrs_buff_ptr
    push   dword [xres_vard]
    pop    dword .xres

    movzx   edx,[draw_flag]
    mov    .draw_flag,edx


	xor	   eax,eax
	mov	   edi,1
	cmp	   dl,3
	cmove	   eax,edi
   ;	 mov	    .env_hint,eax    ; env mapping
	cmove	   ebx,[tlz]  ;textured_line_z

	cmp	   dl,4
	cmove	   ebx,[blz]  ;bump_line_z

	cmp	   dl,5
	cmove	   ebx,[tlz]  ;textured_line_z

	cmp	   dl,7
	cmove	   ebx,[t2lz] ;two_tex_line

   ;	 xor	    eax,eax
   ;	 mov	    edi,1
	cmp	   dl,8
   ;	 cmove	    eax,.i12  ;edi
   ;	 mov	    .env_hint,eax
	cmove	   ebx,[blt]  ;bump_tex_line_z
	mov	   .tx_line,ebx
	mov	   .tx_esi,esi
	mov	   .env_hint,eax


    mov    eax,.thread_no

    cmp    dl,9
    jl	   @f
    cmp    dl,10  ; flat draw float cause
    je	   @f
    cmp    dl,15  ; phong shd
    jge    .ph

    cmp    .draw_flag,14
    je	   .draw_vertices
    push   .yres
    pop    word .y_max
    mov    .y_min,word 0
    push   word .xres
    pop    .x_max
    mov    .x_min,word 0
    jmp    .draw_edges
  @@:
    movzx  ebx,.yres
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    mov    .x_min,word 0
    push   word .xres
    pop    .x_max
    jmp    .skip_div
  .ph:
    movzx  ebx,.yres
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    movzx  edx,word .xres
    shr    edx,1
    cmp    eax,0
    jne    @f
    mov    .y_min,word 0
    mov    .x_min,word 0
    mov    .y_max,bx
    mov    .x_max,dx
    jmp    .skip_div
   @@:
    cmp    eax,1
    jne    @f
    mov    .y_min,word 0
    mov    .x_min,dx
    push   word .xres
    pop    .x_max
    mov    .y_max,bx
    jmp    .skip_div
   @@:
    cmp    eax,2
    jne    @f
    push   .yres
    pop    word .y_max
    mov    .y_min,bx
    mov    .x_min,0
    mov    .x_max,dx
    jmp    .skip_div
  @@:
    cmp    eax,3
    jne    @f
    push   .yres
    pop    word .y_max
    mov    .y_min,bx
    mov    .x_min,dx
    push   word .xres
    pop    .x_max

  @@:

  .skip_div:


       movq	xmm1,.y_max
       movq	xmm2,.y_min
       pand	xmm1,[draw_thread_mask]
       pand	xmm2,[draw_thread_mask]
       packssdw xmm1,xmm1
       packssdw xmm2,xmm2

       pshufd	xmm1,xmm1,0
       pshufd	xmm2,xmm2,0
       movdqa	.pack1,xmm1
       movdqa	.pack2,xmm2


    mov   esi,[triangles_ptr]		 ; draw triangles
    xor   ecx,ecx
  .draw_triangle:
    push  ecx
    push  esi
    pushad
    mov      .cur_tri,ecx

    cmp      [culling_flag],1
    je	     @f
    imul     ecx,.i12
    add      ecx,[triangles_normals_rotated_ptr]
    bt	     dword[ecx+8],31
    jnc      .end_draw

  @@:
    mov     edx,dword[esi]
    mov     eax,dword[esi+4]
    mov     ebx,dword[esi+8]
    shl     edx,2
    shl     eax,2
    shl     ebx,2
    mov     .in1,edx
    mov     .in2,eax
    mov     .in3,ebx

    lea    edx,[edx*3]
    lea    eax,[eax*3]
    lea    ebx,[ebx*3]
    mov    .first_p_index,edx
    mov    .second_p_index,eax
    mov    .third_p_index,ebx
    add    edx,.por
    add    eax,.por
    add    ebx,.por
    movups xmm0,[edx]
    movups xmm1,[eax]
    movups xmm2,[ebx]
    shufps xmm0,xmm0,11100001b
    shufps xmm1,xmm1,11100001b
    shufps xmm2,xmm2,11100001b

    movaps    xmm4,xmm0
    movhlps   xmm4,xmm1
    shufps    xmm4,xmm4,10000010b
    movhlps   xmm5,xmm2
    movlhps   xmm4,xmm5
    andps     xmm4,.zer_hgst

    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1
    cvtps2dq xmm2,xmm2
    packssdw xmm0,xmm0
    packssdw xmm1,xmm1
    packssdw xmm2,xmm2
    movd     [.xy1],xmm0
    movd     [.xy2],xmm1
    movd     [.xy3],xmm2


	movdqu	 xmm0,[.xy1]   ; check if at last only fragment
	movdqa	 xmm3,xmm0     ; is visable

	pcmpgtw  xmm0,.pack1   ;max
	pcmpgtw  xmm3,.pack2   ;min
	pmovmskb ecx,xmm0
	pmovmskb eax,xmm3
	and	 ecx,0xfff
	and	 eax,0xfff
	cmp	 ecx,0xfff
	jz	 .end_draw
	or	 eax,eax
	jz	 .end_draw

    mov       eax,.draw_flag
    mov       ecx,22
    cmp       eax,ecx  ;23
    cmovge    eax,ecx
    add       eax,eax
    add       eax,render_optss
    movzx     edi,byte[eax]
    bt	      edi,6  ; z float
    jc	      @f
    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4
    movq      .zz1,xmm4

 @@:

    bt	       edi,0
    jnc        @f

	mov	   ecx,.pnr	   ; col
	mov	   eax,.first_p_index
	mov	   ebx,.second_p_index
	mov	   edx,.third_p_index
	add	   eax,ecx
	add	   ebx,ecx
	add	   edx,ecx
	movaps	   xmm5,.correct_texf
	movlps	   xmm7,[eax]
	movhps	   xmm7,[ebx]
	movlps	   xmm2,[edx]
	mulps	   xmm7,xmm5
	mulps	   xmm2,xmm5
	addps	   xmm7,xmm5
	addps	   xmm2,xmm5

	cvtps2dq   xmm7,xmm7
	cvtps2dq   xmm2,xmm2
	pslld	   xmm7,2
	pslld	   xmm2,2

	movd	   eax,xmm2
	mov	   edx,color_map
	psrldq	   xmm2,4
	movd	   ebx,xmm2
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm2,[eax+edx]

	movd	   eax,xmm7
	psrldq	   xmm7,4
	movd	   ebx,xmm7
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm0,[eax+edx]

	psrldq	   xmm7,4
	movd	   eax,xmm7
	psrldq	   xmm7,4
	movd	   ebx,xmm7
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm1,[eax+edx]

	pxor	   xmm3,xmm3
	punpcklbw  xmm0,xmm3  ; colors - words in xmm0
	punpcklbw  xmm1,xmm3  ; colors - words in xmm0
	punpcklbw  xmm2,xmm3  ; and xmm2
	movlhps    xmm0,xmm1

	bt	   edi,3
	jc	   @f

	  mov	   eax,0x55555555  ; flat cause
	  movhlps  xmm3,xmm0
	  paddw    xmm2,xmm0
	  paddw    xmm2,xmm3
	  movd	   xmm3,eax
	  pshufd   xmm3,xmm3,0
	  pmulhuw  xmm3,xmm2
	  packuswb xmm3,xmm3  ; flat in xmm3


    @@:
       bt	  edi,5
       jnc	  @f

	pxor	   xmm7,xmm7
	movq	   xmm5,.y_max
	punpcklwd  xmm5,xmm7
	pshufd	   xmm5,xmm5,10110001b

     @@:

       bt	 edi,1	 ; env map
       jnc	 .texx

	movaps	  xmm7,.correct_texf
	mov	  ecx,.pnr
	mov	  eax,.first_p_index
	mov	  ebx,.second_p_index
	mov	  edx,.third_p_index
	add	  eax,ecx
	add	  ebx,ecx
	add	  edx,ecx
	movlps	  xmm2,[eax]
	movhps	  xmm2,[ebx]
	movlps	  xmm1,[edx]
	mulps	  xmm2,xmm7
	addps	  xmm2,xmm7
	mulps	  xmm1,xmm7
	addps	  xmm1,xmm7
	cvttps2dq xmm2,xmm2
	cvttps2dq xmm1,xmm1
    ;	 bt	   edi,9   ; bump
    ;	 jc	   .texx;
	packssdw  xmm2,xmm2
	packssdw  xmm1,xmm1
	movlhps   xmm1,xmm2
	pshufd	  xmm1,xmm1,00001110b

     .texx:

	bt     edi,2  ; tex
	jnc    .norm

	mov    edx,.tex_pts
	mov    eax,.in3
	mov    ebx,.in2
	mov    ecx,.in1
	add    eax,edx
	push   dword[eax]
	add    ebx,edx
	push   dword[ebx]
	add    ecx,edx
	push   dword[ecx]
	movdqu xmm6,[esp]
	add    esp,12

	mov    eax,.draw_flag
	cmp    al,16
	je     @f
	cmp    al,18
	je     @f
	cmp    al,19
	jne   .norm
       @@:
  
	
	mov    edx,.tex_points_f_ptr
	mov    eax,.in3
	mov    ebx,.in2
	mov    ecx,.in1
	add    eax,eax
	add    ebx,ebx
	add    ecx,ecx
	add    eax,edx
	add    ebx,edx
	add    ecx,edx
	movlps xmm6,[ecx]
	movhps xmm6,[ebx]
	movlps xmm3,[eax]

      .norm:
	bt     edi,7  ; normals
	jnc    @f
	movaps xmm7,.zer_hgst
	mov    esi,.first_p_index
	add    esi,.pnr
	movups xmm0,[esi]
	andps  xmm0,xmm7
	mov    eax,.second_p_index
	add    eax,.pnr
	movups xmm1,[eax]
	andps  xmm1,xmm7
	mov    ebx,.third_p_index
	add    ebx,.pnr
	movups xmm2,[ebx]
	andps  xmm2,xmm7
     @@:
	bt	  edi,3    ; grd col - mixed with z
	jnc	  @f	   ; xmm0 - xmm2
	movzx	  eax,word .zz1
	movzx	  ebx,word .zz2
	movzx	  ecx,word .zz3
	pinsrw	  xmm0,eax,3
	pinsrw	  xmm0,ebx,7
	pinsrw	  xmm2,ecx,3
     @@:

   .no_opts:
    mov   eax,.draw_flag
    cmp   al,1
    je	  .flat_draw
    cmp   al,3
    je	  .bump_tex_mapping
    cmp   al,4
    je	  .bump_tex_mapping
    cmp   al,5
    je	  .bump_tex_mapping ;			   .tex_mapping
    cmp   al,8
    je	  .bump_tex_mapping
    cmp   al,7
    je	  .bump_tex_mapping  ; .two_tex
    cmp   al,6
    je	  .grd_tex
    cmp   al,10
    je	  .flat_draw_float
    cmp   al,0
    je	  .point_light

    cmp   al,21
    je	  .fur
    cmp   al,100  ; ray shadow mark
    je	  .ray_s
  ;  cmp   al,15
  ;  jge   .glass_tex


     .grd_draw: 	       ;****Gouraud shading****
	push	  word .y_max
	push	  word .y_min
	sub	  esp,24
	movups	  [esp],xmm0
	movq	  [esp+16],xmm2
	mov	  eax,[.xy1]
	mov	  ebx,[.xy2]
	mov	  ecx,[.xy3]
	mov	  esi,.zbuf
	mov	  edi,.scr
	call	  gouraud_triangle_z
	jmp	  .end_draw

  if 0
   .glass_tex:	     ; all but fur and peel real phg based models

       ; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
       ; xmm3, xmm6 - tex coords as floats

	mov	   ebx,[.xy2]
	mov	   ecx,[.xy3]
	mov	   edx,texmap
	mov	   edi,.scr
	mov	   eax,0x00aa3333
	movd	   mm0,eax     ; r phg col
	mov	   eax,.tx_line
	mov	   esi,.tx_esi

	cmp	   .draw_flag,17
	cmove	   edx,esi
	movd	   xmm7,eax
	mov	   eax,[.xy1]
	call	   glass_tex_tri
	jmp	   .end_draw

  end if
    .grd_tex:
	push	  word .y_max
	push	  word .y_min
	sub	  esp,16
	pslldq	  xmm6,4
	movups	  [esp],xmm6
	sub	  esp,20
	movups	  [esp],xmm0
	movq	  [esp+16],xmm2
	mov	  eax,[.xy1]
	mov	  ebx,[.xy2]
	mov	  ecx,[.xy3]
	mov	  edi,.scr   ; screen buffer
	mov	  esi,.zbuf
	mov	  edx,texmap
	call	  tex_plus_grd_triangle
	jmp	  .end_draw

     .flat_draw:
	  movd	   edx,xmm3
	  or	   edx,0xff000000   ; edx - color
	  mov	   eax,[.xy1]
	  mov	   ebx,[.xy2]
	  mov	   ecx,[.xy3]
	  mov	   edi,.scr
	  mov	   esi,.zbuf
	  push	   word .y_min
	  push	   word .y_max
	  push	   word .zz3
	  push	   word .zz2
	  push	   word .zz1
	  call	   flat_triangle_z
	  jmp	.end_draw



    .flat_draw_float:
	  mov	   edx,.y_max
     ;	   ror	    edx,16
	  movd	   xmm5,edx  ;.y_min
	  movzx    eax,word [xres_var]	;.xres
	  push	   eax
	  movaps   xmm0,xmm4  ; z
	  movd	   edx,xmm3
	  or	   edx,0xff000000   ; edx - color
	  mov	   eax,[.xy1]
	  mov	   ebx,[.xy2]
	  mov	   ecx,[.xy3]
	  mov	   esi,.zbuf
	  mov	   edi,.scr
	  call	   flat_triangle_z_float
	  jmp	  .end_draw




    .bump_tex_mapping:
	mov	ebx,texmap
	cmp	.env_hint,0
	je	@f
	movaps	xmm6,xmm1
;	 mov	 ebx,envmap
;	 cmp	 .env_hint,12
;	 je	 @f
	mov	ebx,envmap
      @@:
	movd	xmm7,.tx_line
	push	word .y_max
	push	word .y_min
	sub	esp,16
	pslldq	xmm6,4
	movups	[esp],xmm6
	pop	eax
	push	ebx
	push	.zbuf
	push	word  .zz3
	push	word  .zz2
	push	word  .zz1
	sub	esp,16
	pslldq	xmm1,4
	movups	[esp],xmm1
	sub	esp,12
	movups	[esp],xmm6
	pop	eax
	mov	eax,[.xy1]
	mov	ebx,[.xy2]
	mov	ecx,[.xy3]
	mov	edi,.scr
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING
	call	bump_tex_triangle_z
	jmp	.end_draw

     .fur:
	pxor	   xmm3,xmm3
	movaps	   xmm0,xmm6
	movaps	   xmm1,xmm6
	movhlps    xmm2,xmm6
	psrldq	   xmm1,4


	punpcklwd  xmm0,xmm3
	punpcklwd  xmm1,xmm3
	punpcklwd  xmm2,xmm3
	cvtdq2ps   xmm0,xmm0
	cvtdq2ps   xmm1,xmm1
	cvtdq2ps   xmm2,xmm2
	shufps	   xmm0,xmm0,11100001b
	shufps	   xmm1,xmm1,11100001b
	shufps	   xmm2,xmm2,11100001b
	sub	   esp,50
	mov	   edx,esp
	add	   edx,16
	and	   edx,-16
	movlps [edx],xmm2
	movlps [edx+8],xmm1
	movlps [edx+16],xmm0
	movlps [edx+24],xmm2

	mov    esi,.first_p_index
	add    esi,.pnr
	movups xmm0,[esi]
	andps  xmm0,.zer_hgst
	mov    eax,.second_p_index
	add    eax,.pnr
	movups xmm1,[eax]
	andps  xmm1,.zer_hgst
	mov    ebx,.third_p_index
	add    ebx,.pnr
	movups xmm2,[ebx]
	andps  xmm2,.zer_hgst
      ;  int3
	movd	 xmm6,[furs_ptr]
	mov	 eax,[.xy1]
	mov	 ebx,[.xy2]
	mov	 ecx,[.xy3]

	mov	 esi,.zbuf
	mov	 edi,.scr
	call	 fur_phong_tri_z
	add	 esp,50
	jmp	.end_draw

     .ray_s:
	emms
	lea	eax,.last_ptr
	movd	mm6,eax
	mov	eax,[.xy1]
	mov	ebx,[.xy2]		;  Zbuffer_ptr]
	mov	ecx,[.xy3]
	mov	esi,[slices_ptrs_buff_ptr] ;.slices_ptrs_buff_ptr    ;.zbuf
	mov	edi,.scr
	movd	mm7,.cur_tri
	call	ray_shd

	jmp   .end_draw


  .point_light:

    push     word .y_max
    push     word .y_min
    movups   xmm5,[ppoint_light_coords]
    xor      eax,eax
    lea      esi,.first_p_index
  .next_vertex:
    movaps   xmm1,xmm5
    mov      ebx,[esi+2*eax]

    mov      edx,ebx
    add      ebx,.por
    movups   xmm2,[ebx]
    andps    xmm2,.zer_hgst
    subps    xmm1,xmm2

    andps    xmm1,.zer_hgst
    movaps   xmm7,xmm1
    mulps    xmm7,xmm7
    haddps   xmm7,xmm7
    haddps   xmm7,xmm7
    rsqrtps  xmm7,xmm7
    mulps    xmm1,xmm7

    add      edx,.pnr
    movups   xmm3,[edx]
    mulps    xmm3,xmm1
    haddps   xmm3,xmm3	   ; sse3 required
    haddps   xmm3,xmm3	   ; xmm3 - dot product
    xorps    xmm4,xmm4
    maxps    xmm3,xmm4
    shufps   xmm3,xmm3,11000000b
    movaps   xmm4,xmm3
    mov      ecx,5
  @@:
    mulps    xmm4,xmm4
    loop     @b

;    imul     eax,[i38]     ; 38 - one light parameter size
    movq      xmm0,[p_light_max]    ;+eax
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    mulps     xmm4,xmm2     ; xmm4 reflection(emmisive?) component of light

    movq      xmm0,[p_light_o] ;+ eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm4,xmm2

    movq      xmm0,[p_light_min] ; + eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0

    mulps     xmm2,xmm3
    addps     xmm4,xmm2
    minps     xmm4,[mask_255f]

    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4

    movd      edx,xmm4
    lea       edi,.zz1
    push      word[edi+eax]
    push      edx
    psrldq    xmm4,4
    movd      edx,xmm4
    push      dx

    add       eax,2
    cmp       eax,6
    jnz       .next_vertex

    mov     eax,[.xy3]
    mov     ebx,[.xy2]
    mov     ecx,[.xy1]
    mov     esi,.zbuf
    mov     edi,.scr
    call    gouraud_triangle_z



  .end_draw:

    popad
    pop    esi
    add    esi,12
    pop    ecx
    inc    ecx
    cmp    ecx,[triangles_count_var]
    jnz    .draw_triangle
    jmp    .the_end

 .draw_edges:

    mov   ecx,.draw_flag
    cmp   cl,9
    je	  .grd_line
    cmp   cl,11
    je	  .env_line
    cmp   cl,12
    je	  .tex_line
    cmp   cl,13
    je	  .flat_line

 ;   int3


  .flat_line:
    mov   ecx,[edges_count]
    mov   esi,[edges_ptr]
  .dr_edge:
    push  ecx
    push  esi
    mov   ebx,dword[esi]
    mov   eax,dword[esi+4]
    imul  ebx,.i12
    imul  eax,.i12
    mov   ecx,eax
    mov   edx,ebx
    add   ebx,.por
    add   eax,.por
    movups   xmm0,[ebx]
    movups   xmm1,[eax]
    shufps   xmm0,xmm0,11100001b
    shufps   xmm1,xmm1,11100001b
    movlhps  xmm0,xmm1
    cvtps2dq xmm0,xmm0
    packssdw xmm0,xmm0
    movdqa   xmm7,xmm0

    ; check if line is in visable area
    pxor     xmm3,xmm3
    movd     xmm4,dword .xres
    pshuflw  xmm4,xmm4,11110001b
    pshufd   xmm4,xmm4,11110000b
    pcmpgtw  xmm4,xmm0
    pcmpgtw  xmm3,xmm0
    pxor     xmm3,xmm4
    pmovmskb eax,xmm3
    and      eax,0x000000ff
    cmp      eax,0xff
    jne     .end_dr_ed


     mov      ebx,0x0000ff00
     movd     mm3,ebx	 ; color
     movd     eax,xmm7
     movzx    ebx,ax
     shr      eax,16
     psrldq   xmm7,4
     movd     ecx,xmm7
     movzx    edx,cx
     shr      ecx,16
     pxor     xmm6,xmm6
     movd     mm1,.scr
     movd     mm0,.zbuf
     movzx    esi,word .xres
     movd     mm2,esi
     movd     xmm7,dword .xres
     punpcklwd xmm7,xmm6
     pshufd   xmm7,xmm7,0
     call     linea1	      ; line grd trans
   .end_dr_ed:
     pop  esi
     pop  ecx
     add  esi,8
     dec  ecx
     jnz .dr_edge

     jmp  .the_end


     .env_line:

	mov   ecx,[edges_count]
	mov   esi,[edges_ptr]
    .edge_env_loop:
	push  ecx
	push  esi
	push  ebp
	mov   ebx,dword[esi]
	mov   eax,dword[esi+4]
	imul  ebx,.i12
	imul  eax,.i12
	add   ebx,.pnr
	add   eax,.pnr
	sub   esp,4
	movlps	xmm0,[ebx]
	movhps	xmm0,[eax]
	movzx	ecx,[correct_tex]
	cvtsi2ss xmm3,ecx
	shufps	xmm3,xmm3,0
	mulps	xmm0,xmm3
	addps	xmm0,xmm3
	cvtps2dq xmm0,xmm0
	packssdw xmm0,xmm0
	movd	 [esp],xmm0  ; tex env coords
	mov	 eax,dword[esi]
	mov	 ebx,dword[esi+4]
	imul	 eax,.i12
	imul	 ebx,.i12
	add	 eax,.por
	add	 ebx,.por
	movups	 xmm1,[eax]
	movups	 xmm2,[ebx]
	shufps	 xmm1,xmm1,11001001b
	shufps	 xmm2,xmm2,11001001b
	cvtps2dq xmm1,xmm1
	cvtps2dq xmm2,xmm2
	packssdw xmm1,xmm1
	packssdw xmm2,xmm2

	movd	 eax,xmm1
	push	 eax
	psrldq	 xmm1,4
	movd	 eax,xmm1
	push	 ax

	sub	 esp,4
	psrldq	 xmm0,8
	movd	 [esp],xmm0
	movd	 ebx,xmm2
	push	 ebx
	psrldq	 xmm2,4
	movd	 ebx,xmm2
	push	 bx

	mov	edi,.scr
	mov	esi,.zbuf
	mov	edx,envmap
	call	tex_line     ; draw only one edge

	pop	ebp
	pop	esi
	pop	ecx
	add	esi,8
	dec	ecx
	jnz	.edge_env_loop

	jmp	.the_end


    .tex_line:
	mov    ecx,[edges_count]
	mov    esi,[edges_ptr]
     .tex_loop:
	push   ecx
	push   esi
	push   ebp
	mov    eax,dword[esi]
	mov    ebx,dword[esi+4]
	shl    eax,2
	shl    ebx,2
	add    eax,.tex_pts
	add    ebx,.tex_pts
	push   dword[eax]
	mov    eax,dword[esi]
	imul   eax,.i12
	add    eax,.por
	movups xmm0,[eax]
	cvtps2dq xmm0,xmm0
	packssdw xmm0,xmm0
	movd   eax,xmm0
	pshufd xmm0,xmm0,00000001b
	movd   ecx,xmm0
	push   cx
	push   eax
	push   dword[ebx]
	mov    ebx,dword[esi+4]
	imul   ebx,.i12
	add    ebx,.por
	movups xmm0,[ebx]
	cvtps2dq xmm0,xmm0
	packssdw xmm0,xmm0
	movd   ebx,xmm0
	pshufd xmm0,xmm0,00000001b
	movd   edx,xmm0
	push   dx
	push   ebx
	mov	edi,.scr
	mov	esi,.zbuf
	mov	edx,texmap
     @@:
	call	tex_line     ; draw only one edge
	pop	ebp
	pop	esi
	pop	ecx
	add	esi,8
	dec	ecx
	jnz	.tex_loop
	jmp    .the_end

 .grd_line:		   ;****Gouraud line****

    mov   ecx,[edges_count]
    mov   esi,[edges_ptr]
  .dr_grd:

    push  ecx
    push  esi
    cmp      [culling_flag],1
    je	     @f
    mov      ebx,[esi]
    imul     ebx,.i12
    add      ebx,.pnr
    bt	     dword[ebx+8],31
    jnc      .end_dr_grd
  @@:
    mov   ebx,dword[esi]
    mov   eax,dword[esi+4]
    imul  ebx,.i12
    imul  eax,.i12
    mov   ecx,eax
    mov   edx,ebx
    add   ebx,.por
    add   eax,.por
    movups   xmm0,[ebx]
    movups   xmm1,[eax]
    shufps   xmm0,xmm0,11100001b
    shufps   xmm1,xmm1,11100001b
    movlhps  xmm0,xmm1
    cvtps2dq xmm0,xmm0
    packssdw xmm0,xmm0
    movdqa   xmm7,xmm0

    ; check if line is in visable area
    pxor     xmm3,xmm3
    movd     xmm4,dword .xres
    pshuflw  xmm4,xmm4,11110001b
    pshufd   xmm4,xmm4,11110000b
    pcmpgtw  xmm4,xmm0
    pcmpgtw  xmm3,xmm0
    pxor     xmm3,xmm4
    pmovmskb eax,xmm3
    and      eax,0x000000ff
    cmp      eax,0xff
    jne     .end_dr_grd

	add    ecx,.pnr
	add    edx,.pnr
	movlps xmm6,[ecx]
	movhps xmm6,[edx]

	mulps	 xmm6,[correct_tex_x4f]
	addps	 xmm6,[correct_tex_x4f]
	cvtps2dq xmm6,xmm6
	movd	 eax,xmm6
	psrldq	 xmm6,4
	movd	 ebx,xmm6
	shl	 eax,TEX_SHIFT
	add	 eax,ebx
	psrldq	 xmm6,4
	lea	 eax,[4*eax+color_map]
	movd	 xmm0,[eax]  ; col1

	movd	 eax,xmm6
	psrldq	 xmm6,4
	movd	 ebx,xmm6
	shl	 ebx,TEX_SHIFT
	add	 ebx,eax
	lea	 ebx,[4*ebx+color_map]
	movd	 xmm1,[ebx]  ;col2

	pxor	   xmm6,xmm6
	punpcklbw  xmm0,xmm6
	punpcklbw  xmm1,xmm6
	punpcklwd  xmm0,xmm6
	punpcklwd  xmm1,xmm6
	cvtdq2ps   xmm0,xmm0
	cvtdq2ps   xmm1,xmm1
	andps	   xmm0,.zer_hgst
	andps	   xmm1,.zer_hgst
	mov	   eax,1.0
	movd	   xmm6,eax
	shufps	   xmm6,xmm6,00111111b
	orps	   xmm0,xmm6
	orps	   xmm1,xmm6

     movd     eax,xmm7
     movzx    ebx,ax
     shr      eax,16
     psrldq   xmm7,4
     movd     ecx,xmm7
     movzx    edx,cx
     shr      ecx,16
     movd     mm1,.scr
     movd     mm0,.zbuf
     movzx    esi,word .xres
     movd     mm2,esi
     call     line_grd	  ; linea
   .end_dr_grd:
     pop  esi
     pop  ecx
     add  esi,8
     dec  ecx
     jnz  .dr_grd

	jmp   .the_end

    .draw_vertices:
	mov	  esi,.por
	mov	  ecx,[points_count_var]
	movzx	  edx,word .xres
	or	  eax,-1
	pxor	  xmm3,xmm3
	movd	  xmm5,.xres
	punpcklwd xmm5,xmm3
	cld
      .again_vert:
	movups	  xmm0,[esi]
	cvtps2dq  xmm0,xmm0
	pxor	  xmm3,xmm3
	movaps	  xmm4,xmm5
	pcmpgtd   xmm4,xmm0
	pcmpgtd   xmm3,xmm0
	pxor	  xmm3,xmm4
	pmovmskb  ebx,xmm3
	cmp	  bl,0xff
	jne	  @f

	movd	 ebx,xmm0
	psrldq	 xmm0,4
	movd	 edi,xmm0
	imul	 edi,edx
	add	 edi,ebx
	shl	 edi,2
	add	 edi,.scr
	stosd
      @@:			  ;  skip vertex
	add	 esi,12
	loop	 .again_vert


  .the_end:

  add esp,300
  pop ebp
ret
