edit_submit:
;in ->	eax = coords y shl 16 + x
; only submit !!
;	esi - src
;	edi - dst

    .x_coord		   equ ebp-4
    .y_coord		   equ ebp-2
    .mx 		   equ ebp-40
    .points		   equ ebp-80
    .points_rotated_dst    equ ebp-130
    .points_src 	   equ ebp-134
    .index1		   equ ebp-138
    .index2		   equ ebp-142
    .index3		   equ ebp-146

	push  ebp
	mov   ebp,esp
	sub   esp,150
	; store both x and y coordinates
	mov    [.points_src],esi
	mov    [.points_rotated_dst],edi

	mov    esi,matrix_scaled
	lea    edi,[.mx]
	call   reverse_mx_3x3


      .edit_submit:

	; submit both causes long pipe and vertices  edition

	mov	 esi,dword[edit_particle_no]
	mov	 edi,esi
	dec	 esi
	mov	 edi,esi
	imul	 esi,12
	add	 esi,[.points_rotated_dst]
	movups	 xmm0,[esi]
	movdqu	 xmm7,[xxadd]
	cvtdq2ps xmm7,xmm7
	subps	 xmm0,xmm7
	movups	  [.points],xmm0

	lea   esi,[.points]
      ;  mov   edi,[edit_particle_no]
   ;	 dec   edi	 ; prevent long pipe cause ?
	imul  edi,12
	add   edi,[.points_src]
	lea   ebx,[.mx]
	mov   ecx,1
	call  rotary


   .end:
	mov    esp,ebp
	pop    ebp
ret

;=================================================================
write_edit_bars:
    push     ebp
    mov      ebp,esp

    .counter	 equ ebp-4
    .x_res4m24	 equ ebp-8
    .xresm4	 equ ebp-12
    .yresm4	 equ ebp-16
    .tri_counter equ ebp-20
    .ed_counter  equ ebp-24
    .cnst6	 equ ebp-28
    .scr	 equ ebp-32
    .edit	 equ ebp-36
    .xres	 equ dword [ebp-40]

    xor      edx,edx

    push     edx
    movzx    eax,word[xres_var]
    mov      ebx,eax
    shl      eax,2
    sub      eax,24
    push     eax	;  .x_res4m24

    movzx    eax,word[yres_var]
    sub      eax,4
    sub      ebx,4
    push     ebx	; .xresm4
    push     eax	; .yresm4
    xor      edx,edx

    push     edx       ; init counters
    push     edx
    mov      edi,[screen_ptr]
    mov      ebx,[edit_buf_ptr]
    movzx    edx,[xres_var]
    push     dword 6
    push     edi
    push     ebx
    push     edx


    cmp      [edit_flag],2
    je	     .edit_face
    cmp      [edit_flag],3
    je	     .edit_edge

    mov      esi,[points_rotated_ptr]
    cld
  .loop:		; edit vertex
    push     esi


    cmp      [culling_flag],1
    je	     @f
    mov      ebx,[.counter]
    imul     ebx,12  ;[i12]
    add      ebx,[points_normals_rotated_ptr]
    bt	     dword[ebx+8],31
    jnc       .skip
  @@:

    movups   xmm0,[esi]
    cvtps2dq xmm0,xmm0
    movd     ebx,xmm0
    psrldq   xmm0,4
    movd     eax,xmm0
    cmp      eax,4
    jle      .skip
    cmp      ebx,4
    jle      .skip
    cmp      eax,[.yresm4]
    jge      .skip
    cmp      ebx,[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    mul      .xres

    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[.scr]
    add      ebx,[.edit]
  ;  draw bar 6x6
  @@:
    mov      eax,0x00ffff00
    mov      ecx,[.cnst6]
    mov      edx,dword[.counter]
 .oop:
    push     ecx
    mov      ecx,[.cnst6]
  @@:
    stosd
    mov      dword[ebx],edx
    add      ebx,4
    loop     @b
    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]
    pop      ecx
    loop     .oop

  .skip:
    pop     esi
    add     esi,12
    inc     dword[.counter]
    mov     ecx,[.counter]
    cmp     ecx,[points_count_var]
    jng     .loop
    jmp     .end


 .edit_face:
    mov      esi,[triangles_ptr]
    xor      ecx,ecx
    mov      eax,0.33333333
    movd     xmm6,eax
    shufps   xmm6,xmm6,0

  .loop_face:
;    push   esi
    push   ecx
    lodsd
    mov    edx,[points_rotated_ptr]
    imul   eax,12
    add    eax,edx
    movups xmm0,[eax]
    lodsd
    imul   eax,12
    add    eax,edx
    movups xmm1,[eax]
    lodsd
    imul   eax,12
    add    eax,edx
    movups xmm2,[eax]
    addps  xmm0,xmm1
    addps  xmm0,xmm2
    mulps  xmm0,xmm6

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip_face
    cmp      ebx,4
    jle      .skip_face
    cmp      ebx,[.yresm4]
    jge      .skip_face
    cmp      eax,[.xresm4]
    jge      .skip_face

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    mul      .xres
    add      ebx,eax
    shl      ebx,2
    lea      edi,[ebx]
    add      edi,[.scr]
    add      ebx,[.edit]
    mov      eax,0x00ffff00

  ;  draw bar 6x6
    mov      edx,ecx  ;[.tri_counter]	;edx -> triangle index
  @@:
    mov      ecx,[.cnst6]
 .oop_f:
    push     ecx
    mov      ecx,[.cnst6]
  @@:
    stosd
    mov      [ebx],edx
    add      ebx,4
    loop     @b

    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]
    pop      ecx
    loop     .oop_f

  .skip_face:
    pop     ecx
 ;   pop     esi
    inc      ecx
    cmp      ecx,[triangles_count_var]
    jnz     .loop_face
    jmp     .end

  .edit_edge:

    mov    esi,[edges_ptr]  ; each edge 2 dwords
    mov    ecx,[edges_count]
  .loop_edge:
    push   ecx
    lodsd
    imul   eax,12
    add    eax,[points_rotated_ptr]
    movups xmm0,[eax]
    lodsd
    imul   eax,12
    push   esi
    add    eax,[points_rotated_ptr]
    movups xmm1,[eax]

    addps  xmm0,xmm1
    mulps  xmm0,[f05x3];    [f2x4]


    mov      ecx,[.ed_counter] ;[.edge1]
    mov      edx,[.xresm4]
    mov      esi,[.yresm4]
    mov      eax,0x00ffff00

    call     bar_edge

    pop     esi
    pop     ecx
    inc     dword [.ed_counter]
    loop    .loop_edge

  .end:
    mov     esp,ebp
    pop     ebp
ret
;==================================================================
bar_edge:
 ;  ecx - edge index; signature
 ;  xmm0 - coordinates
 ;  eax - color
 ;  edx  - xresm4
 ;  esi  - yresm4
    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .col      equ ebp-16
    .add      equ ebp-20


    push     edx
    push     esi
    push     ecx
    push     eax
    movzx    eax,[xres_var]
    sub      eax,6
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    mov      eax,5
    movdqa   xmm1,xmm0
    movdqa   xmm2,xmm0
    movdqu   xmm3,[.yresm4]
    movd     xmm4,eax
    pshufd   xmm3,xmm3,11100001b
    pshufd   xmm4,xmm4,0
    pcmpgtd  xmm1,xmm3
    pcmpgtd  xmm2,xmm4
    pxor     xmm1,xmm2
    pmovmskb eax,xmm1
    cmp      al,-1
    jne      .skip

    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
    mov      edx,dword[.ed]
    cld
  ;  draw bar 6x6
    mov      ecx,6
    mov      eax,[.col]
 .oop_ed:
    push     ecx
    mov      ecx,6
  @@:
    stosd
    mov      [ebx],edx
    add      ebx,4
    loop     @b

    add      edi,[.add]
    add      ebx,[.add]
    pop      ecx
    loop     .oop_ed

  .skip:
   mov	     esp,ebp
   pop	     ebp
ret


write_edit_bars_vert:
; this proc used for vertices edit module and for closed
; series Bezier curves edit module (many "sticked" pipes).
;in:
;   eax - x resolution of image
;   ebx - y resolution of image
;   esi - ptr vertices to display
;   ecx - count vertices to display
;   edi - ptr to edit buffer
;   edx - ptr to screen buffer normal
;   xmm0 = 1 - bezier patch bars cause, otherwise - normal vert

    push      ebp
    mov       ebp,esp


    .yres	 equ ebp-4
    .xres	 equ ebp-8
    .vert_ptr	 equ ebp-12
    .vert_count  equ ebp-16
    .edit_b_ptr  equ ebp-20
    .scr_ptr	 equ ebp-24
    .x_res4m24	 equ ebp-28
    .yresm4	 equ ebp-32
    .xresm4	 equ ebp-36


    push	ebx
    push	eax
    push	esi
    push	ecx
    push	edi
    push	edx



    shl      eax,2
    sub      eax,24
    push     eax
    mov      eax,[.xres]
    sub      eax,4
    sub      ebx,4
    push     ebx
    push     eax


    mov      esi,[.vert_ptr]
    xor      ecx,ecx
  .loop:
    push     ecx
    push     esi
    movups   xmm0,[esi]
    movapd   xmm1,[i4x4]
    cvtps2dq xmm0,xmm0
    movq     xmm2,[.xresm4]
    pcmpgtd  xmm1,xmm0
    pcmpgtd  xmm2,xmm0
    pxor     xmm1,xmm2
    pmovmskb eax,xmm1
    cmp      al,0xff
    jnz       .skip
    movd      ebx,xmm0
    psrldq    xmm0,4
    movd      eax,xmm0

    sub      eax,3
    sub      ebx,3
    mul      dword[.xres]
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[.scr_ptr]
    add      ebx,[.edit_b_ptr]
    mov      eax,0x00ffff00
    mov      edx,ecx  ;dword[.counter
  ;  draw bar 6x6
    cld
    mov      ecx,6
 .oop:
    push     ecx
    mov      ecx,6
  @@:
    stosd
;    mov      dword[edi],0x00ffff00
    mov      dword[ebx],edx
    add      ebx,4   ;2
    loop      @b

    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]  ; .x_res2m12
    pop      ecx
    loop     .oop

  .skip:
    pop     esi
    add     esi,12
    pop     ecx
    inc     ecx
    cmp     ecx,[.vert_count]
    jng     .loop

    mov     esp,ebp
    pop     ebp
ret