macro malloc  arg1
{
      invoke  VirtualAlloc,NULL,arg1,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
      or       eax,eax
      jnz      @f
      invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
     @@:
}
;macro imul arg1,[i12]
;{
;  shl   arg1,2
;  lea   arg1,[arg1*3]
;}


macro dbg_ptr arg1
{
   push     ebx
   push     ecx
   mov      ebx,arg1
   mov      ecx,3
 @@:
   vmovups  ymm0,[ebx]
   vmovups  ymm1,[ebx+32]
   vmovups  ymm2,[ebx+64]
   vmovups  ymm3,[ebx+96]
   int3
   add      ebx,128
   loop     @b
   pop      ecx
   pop      ebx
}


macro display_buff wid, hei, buff
{


    mov   [bmi1.biSize],sizeof.BITMAPINFOHEADER
    mov   eax,wid
    mov   [bmi1.biWidth],eax  ;XRES
    mov   edx,hei

;    add   edx,30
    neg   edx

    mov [bmi1.biHeight],edx ;-YRES-30
    mov [bmi1.biPlanes],1
    mov [bmi1.biBitCount],32
    mov [bmi1.biCompression],BI_RGB

    mov [bmi1.biSizeImage],0
    mov [bmi1.biXPelsPerMeter],0
    mov [bmi1.biYPelsPerMeter],0
    mov [bmi1.biClrUsed],0
    mov [bmi1.biClrImportant],0

    invoke  StretchDIBits,[hdc],0,30,wid,hei,0,0,wid,hei,buff,bmi1,0,SRCCOPY
    invoke  Sleep,3333
}





