
;triangle_shd:
;  procedure draws shadowed triangle - saturated substraction in
;  every pixel ----------------------------------------------------
;  ----------------in - eax - x1 shl 16 + y1 ----------------------
;  -------------------- ebx - x2 shl 16 + y2 ----------------------
;  -------------------- ecx - x3 shl 16 + y3 ----------------------
;  -------------------- edx - shadow substracted color 0x00RRGGBB--
;  -------------------- edi - pointer to screen buffer-------------
; --------------------- esi - shadow buffer -----------------------
; first stage sorting coord, cal deltas, two calling loops -
;  - see  3stencil.inc file...

shadow_line:
;----------------
;-------------in edi - pointer to screen buffer ----------------------------------

.x_res	equ word[ebp-2]
.y_res	equ [ebp-4]
.x1	equ [ebp-8]
.x2	equ [ebp-12]
.z2	equ [ebp-16]
.z1	equ [ebp-20]




     push	ebp
     mov	ebp,esp
     push	edx
     or 	ecx,ecx
     jle	.l_quit

     cmp	cx,dx  ;.y_res
     jge	.l_quit

     cmp	eax,ebx
     je 	.l_quit
     jl 	.l_ok

     xchg	eax,ebx

  .l_ok:
     xor	edx,edx
     cmp	ax,.x_res
     jge	.l_quit
     cmp	bx,dx
     jle	.l_quit
     cmp	eax,edx
     cmovb	eax,edx
     movzx	edx,.x_res
     cmp	ebx,edx
     cmova	ebx,edx
     push	eax
     push	ebx
     sub	esp,8

;     movzx	 edx,[xres_var]
     mov	eax,ecx
     mul	edx		     ; edi = edi + (SIZE_X * y + x1)*4
     add	eax,.x1
     add	esi,eax
     shl	eax,2
     add	edi,eax

     mov	ecx,ebx ;.x2
     sub	ecx,.x1

     mov	eax,0x00444444
     movd	xmm0,eax  ;.col
     
   ;  pshufd	 xmm0,xmm0,0
   ;  shr	 ecx,1
   ;  jnc	 @f
   ;  movd	 xmm1,[edi]
   ;  psubusb	 xmm1,xmm0
   ;  movd	 [edi],xmm1
   ;  add	  edi,4
   ;  jecxz	 .fl_quit
   .ddraw:
     cmp       byte[esi],0
     jne       @f
     movd      xmm1,[edi]
     psubusb   xmm1,xmm0
     movd      [edi],xmm1
     mov       byte[esi],1
    @@:
     add       edi,4
     inc       esi
     loop     .ddraw

   .l_quit:

     mov   esp,ebp
     pop   ebp
ret
