ROUND2 equ 10

;  Procedure counts slices of overlapped transparent triangles, each
;  counter as byte, each pixel have own counter.--------------------
;  Horizontal line is processed. First triangle calling two loops --
;  file 3stencil.inc -----------------------------------------------

counter_slices_line:
;----------------------------------------------------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- esi - pointer to buff --------------

.scl_x2 equ  [ebp-4]
.scl_x1 equ  [ebp-8]
.scl_s_buf  equ [ebp-12]
.scl_y	    equ [ebp-16]


     push	ebp
     mov	ebp,esp
     or 	cx,cx
     jle	.scl_l_quit
  ;   mov	 edi,edx
  ;   ror	 edx,16
     cmp	cx,[yres_var]
     jge	.scl_l_quit

     movzx	ecx,cx
     cmp	eax,ebx
     je 	.scl_l_quit
     jl 	.scl_l_ok
     xchg	eax,ebx

   .scl_l_ok:

     cmp	ax,[xres_var]
     jge	.scl_l_quit
     cmp	bx,0
     jle	.scl_l_quit

     push	ebx
     push	eax
     push	esi

     sub	ebx,eax

     movzx	edx,word[xres_var]
     cmp	eax,1
     jge	@f
     mov	dword .scl_x1,0
   @@:
     cmp	.scl_x2,edx
     jl 	@f
     mov	.scl_x2,edx

    @@:

     mov	edi,.scl_s_buf
     mov	eax,ecx  ; y
     mul	edx
     add	eax,.scl_x1
     add	edi,eax
     movaps	xmm2,[sli_cnt_const]
     mov	ecx,.scl_x2
     sub	ecx,.scl_x1
     shr	ecx,1
     jnc	@f
     movd    xmm0,[edi]
     paddusb xmm0,xmm2	;[sli_cnt_const]
     movd    eax,xmm0
     mov     [edi],al
     inc     edi
     jecxz   .scl_l_quit
   @@:
   ;  shr     ecx,1
   ;  jnc     @f
     movd    xmm0,[edi]
     paddusb xmm0,xmm2 ;[sli_cnt_const]
     movd    eax,xmm0
     mov     [edi],ax
     add     edi,2
 ;    jecxz   .scl_l_quit
 ;  @@:
 ;    shr     ecx,1
 ;    jnc     @f
 ;    movd    xmm0,[edi]
 ;    paddusb xmm0,[sli_cnt_const]
 ;    movd    [edi],xmm0
 ;    add     edi,4
 ;    jecxz   .scl_l_quit
 ;  @@:
 ;    movq    xmm0,[edi]
 ;    paddusb xmm0,[sli_cnt_const]  ; broadcasted db 1
 ;    movq    [edi],xmm0
 ;    add     edi,8
 ;    ; for large triangles
     loop     @b

  .scl_l_quit:
     mov       esp,ebp
     pop       ebp
ret
