; manifold chunks routines


if 0
opt_chunks:

  ; optimize chunks
  ; proc should do:
  ; every chunk has only its own coninous fragment of vertices list
  ; localised in standard chunks order (like triangles list)


  push	 ebp
  mov	 ebp,esp

  .points1_ptr equ dword[ebp-4]
  .new_normals equ dword[ebp-8]
  .new_ptsI2   equ dword[ebp-12]
  .new_ptsI    equ dword[ebp-16]
  .pts_r       equ dword[ebp-20]
  .nor_cur_ptr equ dword[ebp-24]
  .cur_ch      equ dword[ebp-28]

  .tri_in_ch   equ dword[ebp-40]
  .tri_offset  equ dword[ebp-44]
  .skip_val    equ dword[ebp-48]
  .c_vert_cnt  equ dword[ebp-32]
  .a_vert_cnt  equ dword[ebp-36]


  cmp	 [chunks_count],1
  je	 .end_och

  mov	 ebx,[points_count_var]
  add	 ebx,100
  imul	 ebx,12
  malloc ebx
  push	 eax  ;     .points1_ptr,  new points - vertices

  mov	 ebx,[triangles_count_var]
  add	 ebx,100
  imul	 ebx,12
  malloc ebx
  push	 eax   ;     new normals

  ; find greatest in size chunk

  mov	esi,[chunks_ptr]
  mov	ecx,[triangles_count_var]
  cld
  xor	edx,edx
  xor	ebx,ebx
 .lab1:
  lodsw
  cmp	ax,[esi]
  je	@f
  cmp	ebx,edx
  cmovb ebx,edx
  xor	edx,edx
  loop	.lab1
  jmp	.en1
 @@:
  inc	edx
  loop	.lab1

 .en1:

  add	 ebx,30
  imul	 ebx,12

  malloc ebx	; 2 pointers at once
  push	 eax


;  add	  eax,ebx
;  add	  eax,0x1f

  malloc ebx
  push	 eax	; new ptsi2

  push	 [points_r_ptr]
  mov	 eax,.new_normals
  push	 eax   ; cur nor ptr

  sub	 esp,48

  xor	 eax,eax
  mov	 ebx,1
  mov	 .a_vert_cnt,eax      ; vertex count accumulator
  mov	 .cur_ch,ebx ;eax
  mov	  edi,[chunks_ptr]
  mov	  dx,[edi]
  or	  dx,dx
  cmove   dx,bx
  mov	  [edi],bx

 .Chunks_LOOP:
   cld
   mov	  ebx,.cur_ch
   mov	  edi,[chunks_ptr]
   mov	  ecx,[triangles_count_var]
   mov	  eax,ebx ;.cur_ch ;ebx
   repne  scasw

   sub	  edi,2
   mov	  esi,edi	      ; edi - start of curr chunk

   push   edi
   sub	  esi,[chunks_ptr]

 ;  (esi-2)/2 - tris cnt to skip

;   dbg_ptr edi  ;.new_ptsI

   add	  esi,esi
   lea	  esi,[esi*3]
   add	  esi,[triangles_ptr]
   mov	  .tri_offset,esi


;   cmp   .cur_ch,0
;   je	  .llac
;
;   dbg_ptr edi  ;.new_ptsI
;
;   esi - val to skip
;   mov   .skip_val,esi
   add	  edi,2
   or	  ecx,-1
   mov	  eax,.cur_ch
   repe   scasw
   pop	  ebx
   sub	  edi,ebx

   sub	  edi,2

   shr	  edi,1
   ; edi tri in curr ch
   mov	  .tri_in_ch,edi

   ; esi - cur tri offset

   cld
   mov	  ecx,edi ;.tri_in_ch
   mov	  esi,.tri_offset
   mov	  edi,.new_ptsI2
   lea	  ecx,[ecx*3]
   push   ecx
   rep	  movsd

   mov	  esi,.new_ptsI2
   mov	  edi,.new_ptsI
   pop	  ecx
   call   sort_hybrid_dd

 ;  dbg_ptr .new_ptsI
 ;  dbg_ptr .new_ptsI2

   ; calc distinc verts count in curr chun
   mov	    esi,.new_ptsI2
   mov	    edi,.new_ptsI
   mov	    ecx,.tri_in_ch
   lea	    ecx,[ecx*3]
   xor	    edx,edx
;   mov      edx,1  ; 0
   cld
  .bb1a:
   lodsd
   mov	    ebx,[esi]
   cmp	    ebx,eax
   jne	    @f
   loop     .bb1a
   jmp	    .fin1a
  @@:
   stosd
   inc	    edx
   loop     .bb1a
 .fin1a:

   or	    eax,-1
   stosd    ; end mark
   mov	    .c_vert_cnt,edx  ; curr


 ;  edx - uniqe verts count in curr chunk
 ; .new_ptsI - sorted uniqe verts

   cld
   ;compute new tri list, fill new verts list with new positions
   mov	  esi,.tri_offset
   mov	  ecx,.tri_in_ch
 ;  xor    ecx,ecx
   mov	  edi,.new_ptsI2
   mov	  eax,0.1
   movd   xmm7,eax
   shufps xmm7,xmm7,0

  .bbb:
   push   ecx
   mov	  edx,esi ;ecx
   mov	  ecx,3
   sub	  edx,[triangles_ptr]
   add	  edx,[triangles_normals_ptr]
   movups xmm4,[edx]

  .bbc:
   push    ecx
   lodsd
;   cmp    eax,  ;[points_count_var]
;   jnbe   .nxc
   push    edi
   mov	   edx,eax	    ; eax - old index
   imul    edx,12
   add	   edx,.pts_r	    ;[points_r_ptr] ; vert  with old index
   movups  xmm0,[edx]
   mov	   edi,.new_ptsI
   mov	   ecx,.c_vert_cnt
   repne   scasd
   sub	   edi,.new_ptsI
   shr	   edi,2
   dec	   edi
   mov	   eax,edi	; edi new index
   pop	   edi		; i must accumulate all
		       ; previous verts count
   add	   eax,.a_vert_cnt
   mov	   edx,eax
   imul    edx,12
   add	   edx,.points1_ptr ; .new_vert
   movlps  [edx],xmm0	    ; new vertex in new_vert lst
   movhlps xmm0,xmm0
   movss   [edx+8],xmm0
   stosd		   ; new vert index in .new_ptsI2 list
 .nxc:
   pop	   ecx

   loop    .bbc

   mov	   ebx,.points1_ptr ;.pts_r  ;[points_r_ptr]
   mov	   eax,[edi-4]
   imul    eax,12
   add	   eax,ebx  ;[points_r_ptr]
   movups  xmm0,[eax]
   mov	   eax,[edi-8]
   imul    eax,12
   add	   eax,ebx ;[points_r_ptr]
   movups  xmm1,[eax]
   mov	   eax,[edi-12]
   imul    eax,12
   add	   eax,ebx ;[points_r_ptr]
   movups  xmm5,[eax]
   subps   xmm1,xmm5
   subps   xmm0,xmm5

 ;  movaps xmm0,xmm5
 ;  movaps  xmm1,xmm5
 ;  movaps xmm0,xmm7

   call    cross_reg  ; destroys xm0 - xm3
   movaps  xmm1,xmm0
   andps   xmm0,[zero_hgst]
   mulps   xmm0,xmm0
   haddps  xmm0,xmm0
   haddps  xmm0,xmm0

;   movhlps xmm3,xmm0
;   haddps  xmm0,xmm0
;   addps   xmm0,xmm3
;   shufps  xmm0,xmm0,0

   mulps   xmm0,xmm1
   movaps  xmm1,xmm0

   addps   xmm1,xmm7
   subps   xmm0,xmm7
   cmpps   xmm0,xmm4,1
   cmpps   xmm1,xmm4,1


   xorps    xmm0,xmm1
   movmskps eax,xmm0
   and	    eax,111b
   cmp	    eax,111b
   jne	    @f
   mov	    eax,[edi-4]
   mov	    ebx,[edi-8]
   mov	    [edi-4],ebx
   mov	    [edi-8],eax
  @@:

   mov	  edx,esi ;ecx
   sub	  edx,[triangles_ptr]
   add	  edx,.new_normals ;[triangles_normals_ptr]
   movups [edx],xmm4


   mov	    ebx,.nor_cur_ptr
   movups   [ebx],xmm4
   add	    ebx,12
   mov	    .nor_cur_ptr,ebx

   pop	    ecx
 ;  inc      ecx
 ;  cmp      ecx,.tri_in_ch
   dec	    ecx
   jnz	    .bbb
;   pop      ecx
;   loop     .bbb





   mov	  edi,.tri_offset
   mov	  ecx,.tri_in_ch
   lea	  ecx,[ecx*3]
   mov	  esi,.new_ptsI2
   rep	  movsd 	       ; renew triangles indexes list in curr chunk
   mov	  ecx,.a_vert_cnt      ; offset
   mov	  edx,.c_vert_cnt      ; curr
   add	  .a_vert_cnt,edx      ; accum


   mov	  eax,.cur_ch
   mov	  ebx,eax
   shl	  ebx,4
   add	  ebx,[chunks_desc_ptr]
   mov	  [ebx+4],edx	       ; fill aprpopiate filed data in chunks_desc  struct
   mov	  [ebx+8],ecx	       ; verts offset

   inc	  eax
   mov	  .cur_ch,eax
   cmp	  eax,[chunks_count]
   jle	  .Chunks_LOOP

      dbg_ptr [chunks_desc_ptr]

   ;   xor     eax,eax
   ;   mov     edi,[chunks_ptr]
   ;   mov     [edi],ax

    ; corr
      mov     ebx,[chunks_desc_ptr]
      mov     edi,ebx
    .agg_c:
      mov     eax,[ebx+4]
      and     eax,[ebx]
      jnz     @f
      add     ebx,16
      jmp     .agg_c

    @@:



;      cmp     [ebx],eax
;      jne     .skp ; skip fix


      mov     ecx,[chunks_count]
      mov     eax,1
      movd    xmm1,eax
      pshufd  xmm1,xmm1,00111111b
      add     ebx,16
    @@:
      movdqu  xmm0,[ebx]
      psubd   xmm0,xmm1
      movdqu  [edi],xmm0
      add     ebx,16
      add     edi,16
      loop    @b

    .skp:

       dbg_ptr [chunks_desc_ptr]



    ;	[chunks_desc_ptr] -  struct should have
    ;				  + 0 - count of tris in chunk
    ;				  + 4 - count of vertices in chunk
    ;				  + 8 - vertices offset
    ;				  + 12 - triangles_offset

   mov	  ebx,.a_vert_cnt
   mov	  [points_count_var],ebx

   invoke  VirtualFree, .new_ptsI2, 0,	MEM_RELEASE
   invoke  VirtualFree, .new_ptsI, 0,  MEM_RELEASE
   invoke  VirtualFree, [points_r_ptr], 0,  MEM_RELEASE
   invoke  VirtualFree, [triangles_normals_ptr], 0,  MEM_RELEASE

   push   .points1_ptr
   pop	  [points_r_ptr]
   push   .new_normals
   pop	  [triangles_normals_ptr]

 .end_och:


   mov	esp,ebp
   pop	ebp
ret

end if

;======================================================================

sort_chunks:

   ; sort chunks, sort triangles, triangles normal vectors

   push   ebp
   mov	  ebp,esp

   .ptr1     equ [ebp-4]
   .ptr2     equ [ebp-8]
   .points_r equ [ebp-12]
   .tcv      equ [ebp-16]
   .tptr     equ dword[ebp-20]
   .chunks_struct   equ dword [ebp-24]
   .chunks_structEx equ [ebp-28]
   .was_used	    equ [ebp-32]
   .cnt 	    equ [ebp-36]
   .accum_tris	    equ [ebp-40]

    pushad
    call     remove_dead_tri
    popad



;    invoke  VirtualFree ,[chunks_desc_ptr],0, MEM_RELEASE
    invoke  VirtualFree ,[chunk_descEx_ptr],0, MEM_RELEASE

    mov      ebx,[triangles_count_var]
    add      ebx,15
    imul     ebx,12

    malloc   ebx
    push     eax
    malloc   ebx
    push     eax


    push     [points_r_ptr]
    push     [triangles_count_var]   ; .tcv
    push     [triangles_ptr]

    mov    esi,[chunks_ptr]
    mov    edi,.ptr1
    xor    ecx,ecx
    cld
  @@:
	     ;make pivot table
    lodsw
    movzx  eax,ax
    stosd
    mov    eax,ecx
    stosd
    inc    ecx	; tri no
    cmp    ecx,.tcv  ;[triangles_count_var]
    jnz    @b

    mov      esi,.ptr1
    mov      edi,.ptr2
    mov      ecx,.tcv ;[triangles_count_var]
    call     sort_hybrid1


    mov      esi,.ptr1
    mov      edi,.ptr2
    mov      ebx,[chunks_ptr]
    mov      ecx,.tcv ;[triangles_count_var]
    cld
   @@:
    lodsd
    mov      [ebx],ax	      ; renew chunks, triangles lists
    lodsd
    push     esi
    imul     eax,12
    add      eax,.tptr ;[triangles_ptr]
    mov      esi,eax
    movsd
    movsd
    movsd
    pop      esi
    add      ebx,2
    loop     @b


    mov      esi,.ptr1		      ; renew tri normals list
    mov      edi,.tptr ;[triangles_ptr]
    mov      ebx,[triangles_normals_ptr]
    mov      ecx,.tcv ;[triangles_count_var]
    cld
   @@:
    lodsd
    lodsd
    imul     eax,12
    add      eax,ebx
    xchg     esi,eax
    movsd
    movsd
    movsd
    xchg     esi,eax
    loop     @b


   ; do chunks struct, renew points, triangles list, so -
   ; -	vert indexes/indices in tri list and rearange vertices list,
   ; sort according to every chunk..   not yet!!

   or	  eax,-1
   mov	  .chunks_struct,eax
   mov	  ebx,[chunks_count]
   cmp	  ebx,1
   je	  .end

   shl	  ebx,4
   add	  ebx,200
   malloc ebx
   push   eax
 ;  mov    .chunks_struct,eax

   shl	  ebx,2
   malloc ebx
   push   eax
 ;  mov    .chunks_structEx,eax     ; max, min, avg vertices
				   ; in chunk

   mov	  ebx,[points_count_var]
   add	  ebx,300
   malloc ebx
   push   eax
;   mov    .was_used,eax


   mov	  edi,eax
   xor	  eax,eax
   push   eax	    ;	 .cnt
   push   eax	    ;	 .tri accumul
   mov	  ecx,ebx
   sub	  ecx,3
   shr	  ecx,2
   rep	  stosd


   mov	  edi,.chunks_struct	   ; make chunks stuct
   mov	  esi,[chunks_ptr]	   ; every dword - triangles count in chunk
   mov	  ecx,.tcv   ;[triangles_count_var]
   mov	  edx,.ptr2  ;[triangles_ptr]

   cld
   lodsw
   inc	  dword[edi]
   dec	  ecx
   jz	 .lab2
   mov	  bx,ax
   xorps  xmm0,xmm0
   xorps  xmm1,xmm1
;   movss  .cnt,xmm0

 .lab1:
   lodsw
   cmp	  bx,ax
   jne	  .nx_1
   inc	  dword[edi]
   push   eax
   push   ebx
   push   ecx
   mov	  ecx,3
  .tri_lab:
   mov	  eax,[edx]
   mov	  ebx,eax
   add	  ebx,.was_used
   cmp	  byte [ebx],0
   jne	  .f_1
   mov	  byte [ebx],1
   imul   eax,12
   add	  eax,.points_r
   movups xmm1,[eax]
   maxps  xmm0,xmm1
   minps  xmm2,xmm1
  .f_1:
   add	  edx,4
   loop   .tri_lab

   pop	  ecx
   pop	  ebx
   pop	  eax
   loop   .lab1

   or	  ecx,ecx
   jz	  .lab2
 ;  jmp    .lab2

 .nx_1:
   push    edx
   mov	   edx,.cnt
   shl	   edx,6
   add	   edx,.chunks_structEx

   movups  [edx],xmm0  ; max
   movups  [edx+12],xmm2 ; min
   subps   xmm0,xmm2
   mulps   xmm0,[f05x3]
   addps   xmm0,xmm2
   movups  [edx+24],xmm0

;   pop     edx
   xorps   xmm0,xmm0
   xorps   xmm2,xmm2
   mov	   edx,.accum_tris
   mov	   [edi+12],edx   ; tri offset
   add	   edx,[edi]
   mov	   .accum_tris,edx
   pop	   edx
   add	   edi,16
   inc	   dword .cnt
   xchg    ebx,eax
   loop    .lab1

  .lab2:

    ;	[chunks_desc_ptr]	  + 0 - count of tris in chunk
    ;	struct should have:	  + 4 - count of vertices in chunk
    ;				  + 8 - vertices offset
    ;				  + 12 - triangles_offset




  .end:
   invoke  VirtualFree , .was_used   ,0 , MEM_RELEASE
   invoke  VirtualFree ,[triangles_normals_ptr],0 , MEM_RELEASE
   invoke  VirtualFree ,.ptr1,0 , MEM_RELEASE

  ; invoke  VirtualFree ,[points_r_ptr],0 , MEM_RELEASE

   push   .chunks_struct
   pop	  [chunks_desc_ptr]
   push   dword .chunks_structEx
   pop	  [chunk_descEx_ptr]

   push    [triangles_ptr]
   pop	   [triangles_normals_ptr]

   push    dword .ptr2
   pop	   [triangles_ptr]
;   call    opt_chunks

   mov	   esp,ebp
   pop	   ebp

ret
;================================================================================

delete_chunk:
; in eax - chunks No to delete
; Need perform remove dead triangles and remove
; unused vertices at the end of process.
  mov	 esi,[chunks_ptr]
  mov	 ecx,[triangles_count_var]
  mov	 edi,[triangles_ptr]
  pxor	 xmm0,xmm0
  mov	 bx,ax
  cld
 .nxx:
  lodsw
  cmp	 bx,ax
  jne	 @f
  movq	 [edi],xmm0
  movd	 [edi+8],xmm0
 @@:
  add	 edi,12
  loop	 .nxx
ret

;============================================================

invert_normals_ch:
; invert sense of normal vectors of selected chunk;
; in eax - index number of selected chunk

  mov	 esi,[chunks_ptr]
  mov	 ecx,[triangles_count_var]
  mov	 edi,[triangles_ptr]
  mov	 bx,ax
  cld
 .nxx:
  lodsw
  cmp	  bx,ax
  jne	  @f
  movlps  xmm0,[edi]
  shufps  xmm0,xmm0,11100001b
  movlps  [edi],xmm0
 @@:
  add	  edi,12
  loop	  .nxx
ret


;=========================================================================
detect_chunks:
; make pivot table, sort, remove unused vertices, find chunks...
; in  - some global variables and
;   eax = 0 or 1 - export or non export some lists
;   ebx = 0x33333333  -> make only pivot table
; out:

; if eax = 0
;      ebx - chunks list ptr
;      ecx - chunks number
; if eax = 1 above and -
;      esi - tri_ch    ; vertices with triangles list
;      edi - t_ptr     ; pointers to tri_ch list

    push ebp
    mov  ebp,esp
    sub  esp,68


   .tri_ch	   equ	dword[ebp-4]	; tri chunks list ptr
   .chunks	   equ	dword[ebp-8]	; chunks ptreach tri chunk No. as word
   .endt	   equ	dword[ebp-12]	;
   .t_ptr	   equ	dword[ebp-16]	; pointers list
   .tri_ch1	   equ	dword[ebp-20]	;
   .up		   equ	dword[ebp-24]	; upload ptr
   .chmr	   equ	dword[ebp-28]	; bit mark list if tri stored
   .str 	   equ	dword[ebp-32]	; store ptr
   .ltch1	   equ	dword[ebp-36]	; end of tri_ch1 ptr
   .ch_cnt	   equ	dword[ebp-40]
   .cntt	   equ	dword[ebp-44]
   .cc		   equ	dword[ebp-48]
   .lsparam	   equ	dword[ebp-52]
   .fix_mark	   equ	dword[ebp-56]
   .endVptr	   equ	dword[ebp-60]
   .pivot	   equ	dword[ebp-64]
   .old_esp	   equ	dword[ebp-68]


    mov     .lsparam,eax
    mov     .pivot,ebx
    call    remove_dead_tri

    mov     .fix_mark,0

if 1

   ;  push    [points_count_var]
     mov     eax,[triangles_ptr]
     mov     ebx,[points_r_ptr]
     mov     ecx,[triangles_count_var]
     mov     edx,[points_count_var]
     call    remove_unused_vertices
     mov     [points_count_var],ecx
    ; pop     ebx
   ;  cmp     ebx,ecx
   ;  jne     .ag
end if

   prompt  prompt_det_chunks1 ; macro

   mov	   ebx,[triangles_count_var]
   shl	   ebx,3
   lea	   ebx,[ebx*3]	  ; 8 * 3 - 24 bytes ?
   add	   ebx,65536

   malloc  ebx
   mov	   .tri_ch,eax

   malloc  ebx
   mov	   .tri_ch1,eax



   mov	   ebx,[triangles_count_var]
   shl	   ebx,2
   add	   ebx,30
   malloc  ebx
   mov	   .t_ptr,eax
   mov	  ebx,.pivot
   cmp	  ebx,0x33333333
   je	  .no_a
   cmp	  ebx,0x33
   je	  .no_a


   mov	   ebx,[triangles_count_var]
   shl	   ebx,1
   add	   ebx,20
   malloc  ebx
   mov	   .chunks,eax	   ; each tri chunk No. as word


   shr	   ebx,4
   malloc  ebx
   mov	   .chmr,eax	 ; chunks mark if bit is set - tri was used



; .ag: ; again
;   mov     .fix_mark,0
 .ag:

   call    remove_dead_tri

   mov	   edi,.chmr
   xor	   eax,eax
   mov	   ecx,[triangles_count_var]
   cld

   shr	   ecx,2 + 3
   inc	   ecx
   rep	   stosd

 .no_a:


   mov	  eax,[points_count_var]
   imul   eax,12
   add	  eax,[points_r_ptr]
   mov	  .endVptr,eax

; make pivot table

   mov	     edi,.tri_ch
   mov	     esi,[triangles_ptr]
   xor	     ecx,ecx
   cld
  @@:
   movsd
   mov	     eax,ecx
   stosd
   movsd
   stosd
   movsd
   stosd
   inc	     ecx
   cmp	     ecx,[triangles_count_var]
   jnz	     @b

; qsort


   mov	    esi,.tri_ch
   mov	    edi,.tri_ch1
   mov	    ecx,[triangles_count_var]
   lea	    ecx,[ecx*3]
   call     sort_hybrid1

   mov	     esi,.tri_ch
   mov	     edi,esi
;   sub       edi,2;  ??
if 0

     push    [points_count_var]
     mov     eax,[triangles_ptr]
     mov     ebx,[points_r_ptr]
     mov     ecx,[triangles_count_var]
     mov     edx,[points_count_var]
     call    remove_unused_vertices
     mov     [points_count_var],ecx
     pop     ebx

   ;  cmp     ebx,ecx
   ;  jne     .ag
end if


   mov	  ecx,[triangles_count_var]
   lea	  ecx,[ecx*3]

   mov	  esi,ecx
   shl	  esi,3
   add	  esi,.tri_ch
   mov	 .endt,esi

   cmp	 .pivot,0x33
   je	 .dnC

;check if remove unused vert must be done
  mov	  esi,.tri_ch
  cld
 .ptC:
  lodsd
    ; esi - vert index
  add	  esi,4
; .ptCff:
  cmp	  esi,.endt
  jae	  .dnC
  cmp	  eax,[esi]
  je	  .ptC
  lea	  ebx,[eax+1]
  cmp	  ebx,[esi]
  je	  .ptC
       ; check done


 .movt:


  push	  esi
  movd	  xmm7,ebx	; vert index + 1
  mov	  edi,[esi]	; edi - ver index
  sub	  edi,ebx
  movd	  xmm6,edi

 @@:
  cmp	  esi,.endt
  jnb	   @f
  sub	  [esi],edi    ; fix .tri_ch pivot table list
  add	  esi,8
  jmp	  @b

 @@:

  ;shrink vert
  lea	  ebx,[ebx*3]
  shl	  ebx,2
  add	  ebx,[points_r_ptr]
  imul	  edi,12
  add	  edi,ebx

  cmp	  edi,.endVptr		 ; fix points_r  list
  ja	  .dnV
 @@:
  movq	  xmm0,[edi]
  movd	  xmm1,[edi+8]
  movq	  [ebx],xmm0
  movd	  [ebx+8],xmm1
  add	  edi,12
  add	  ebx,12
  cmp	  edi,.endVptr		 ; fix point_r	list
  jna	  @b

 .dnV:

; recalc tri  all indices above ebx - sub edi
;  push   ecx

  mov	 esi,[triangles_ptr]
  mov	 ecx,[triangles_count_var]
  lea	 ecx,[ecx*3]
  movd	 edi,xmm6
  movd	 ebx,xmm7
 .agT:
  cmp	 [esi],ebx  ; eax
  jb	 @f
  sub	 [esi],edi
 @@:
  add	esi,4
  loop	.agT


  pop	 esi

  sub	 [points_count_var],edi


  jmp	.ptC  ;ff	    ; again check sth found


 .dnC:	    ; check done


   prompt  prompt_det_chunks ; sec stage

 .do_ch:

;make t_ptr  - table with pointers/adresses

  mov	 ecx,[points_count_var]
  mov	 esi,.tri_ch
  mov	 edi,.t_ptr
  mov	 ebx,ecx

  mov	 [edi],esi
  add	 edi,4
  dec	 ecx
  jz	 .dn
 .pt:
  mov	 eax,[esi]	  ; [esi]   - vert ind
  add	 esi,8
  cmp	 eax,[esi]	  ; [esi+4] - tri ind
  je	 @f
  mov	 [edi],esi
  add	 edi,4
  dec	 ecx
  jz	 .dn
 @@:
  cmp	esi,.endt
  jb	.pt

 .dn:
  mov	 ebx,.pivot
  cmp	 ebx,0x33333333
  je	 .end2_piv
  cmp	 ebx,0x33
  je	 .end2_piv

	  mov	  edi,.t_ptr
	  mov	  ecx,[triangles_count_var]

      ;    mov	   ebx,ecx
      ;    imul    ebx,12
      ;    add	   edi,ebx
      ;    or	   eax,-1
      ;    cld
      ;    stosd    ; mark



   ; each dword position in .t_ptr list - adress of corresponding
   ; triangles indexes, each triangles from such index contains this vertice

  ; search for chunks
	mov	eax,ecx ;[triangles_count_var]
	mov	.cntt,eax   ; temp help cnt
	xor	ecx,ecx
	mov	.cc,ecx
	mov	esi,[triangles_ptr]
	mov	edi,.tri_ch1
	imul	eax,12
	shl	eax,3
	add	eax,edi
	mov	.ltch1,eax    ; last

	mov	.up,esi
	mov	.str,edi
    .lb1:

     ;	 mov	 edi,.str  ;	       ; nx chunk
	cmp	edi,.ltch1
	jnb	.endl	       ;nb
	mov	.str,edi
	mov	eax,.cc
	mov	edx,.cc
	inc	.cc
	cmp	edx,[triangles_count_var]
	jz	.endl
	shr	eax,3
	and	edx,111b
	add	eax,.chmr

	xor	ebx,ebx
	bt	[eax],edx	    ; mark
	jc	@f		    ; tri was stored
	inc	ecx
	or	ebx,1b
	mov	esi,.up
	movdqu	xmm0,[esi]
	movdqu	[edi],xmm0
	add	.str,12
      @@:
	add	.up,12
	or	ebx,ebx
	jz	.lb1

    .lb2:
	mov	eax,[edi]
	mov	edx,[edi] ; edx - vert ind
	shl	eax,2
	add	eax,.t_ptr
	mov	eax,[eax]	    ; [eax] -	t ptr
	or	eax,eax
	jz	.endl
    .nxt:

	mov	esi,[eax+4]
	mov	ebx,[eax+4]
	shr	esi,3
	and	ebx,111b
	add	esi,.chmr
	bts	[esi],ebx	    ; mark
	jc	@f		    ; tri was stored
	dec	.cntt
	je	.endl
	mov	esi,[eax+4]	    ; [eax+4] - tri ind
	add	esi,esi
	add	esi,.chunks
	mov	[esi],cx
	mov	esi,[eax+4]

	imul	esi,12
	add	esi,[triangles_ptr]
	movups	xmm0,[esi]
	mov	esi,.str
	movups	[esi],xmm0
	add	.str,12
      @@:
	add	eax,8
	cmp	edx,[eax]
	je	.nxt
	add	edi,4

	cmp	edi,.str
	jne	.lb2
	jmp	.lb1

    .endl:

     ;	 dbg_ptr .chunks


	mov	.ch_cnt,ecx


 .end:
   cmp	   .lsparam,1
   je	   @f
   invoke  VirtualFree ,.t_ptr,0 , MEM_RELEASE
   invoke  VirtualFree ,.tri_ch,0 , MEM_RELEASE
 @@:
   invoke  VirtualFree ,.chmr,0 , MEM_RELEASE
   mov	  ebx,.chunks
  .end2_piv:
   invoke  VirtualFree, .tri_ch1,0 , MEM_RELEASE

   cmp	  .pivot,0x33333333

   or	  eax,-1
   cmovne ebx,.chunks
   cmovne ecx,.ch_cnt
   cmove  ebx,eax
   cmove  ecx,eax

   mov	  esi,.tri_ch
   mov	  edi,.t_ptr

   cls	  ; macro

   mov	  esp,ebp
   pop	  ebp
ret

;--------------------------------------------------------------------------

