draw_vertices_normals:
    mov    eax,'vert'
draw_triangles_normals:
    push    ebp
    mov     ebp,esp
    sub     esp,120
    and     ebp,-16
  .scr	    equ [ebp-4]
  .col	    equ dword[ebp-8]
  .up_res   equ [ebp-32]
  .4x	    equ [ebp-32-16]
  .xress    equ [ebp-64]
  .f03	    equ [ebp-80]
  .f30	    equ [ebp-96]

    pxor      xmm3,xmm3
    movd      xmm4,[xres_vard]
    movdqa    xmm7,xmm4
    punpcklwd xmm4,xmm3 ;[the_zero]
    pshufd    xmm4,xmm4,01000100b
    movdqa    xmm5,[i4x4]
    psubd     xmm4,xmm5
    movdqa    .up_res,xmm4
    movdqa    .4x,xmm5
;    movq      xmm7,[xres_vard]
    punpcklwd xmm7,xmm6
    movdqa    .xress,xmm7
    mov       esi,[screen_ptr]
    mov       .scr,esi
    mov       ebx,30.0
    movd      xmm2,ebx
    mov       edx,0.33333333
    movd      xmm3,edx
    shufps    xmm2,xmm2,0
    shufps    xmm3,xmm3,0
    movaps    .f03,xmm3
    movaps    .f30,xmm2
    mov       .col,0x0000ffff
    cmp       eax,'vert'
    je	      .vert


    mov     ecx,[triangles_count_var]
    mov     esi,[triangles_ptr]
    mov     edi,[triangles_normals_rotated_ptr]
    mov     edx,[points_rotated_ptr]
    cld
    emms
  .next:
    push    edx
    push    ecx
    push    edi

    lodsd
    lea     eax,[eax*3]
    shl     eax,2
    add     eax,edx
    movups  xmm0,[eax]

    lodsd
    lea     eax,[eax*3]
    shl     eax,2
    add     eax,edx
    movups  xmm1,[eax]

    lodsd
    lea     eax,[eax*3]
    shl     eax,2
    add     eax,edx
    movups  xmm2,[eax]
    push    esi

    addps   xmm0,xmm1
    addps   xmm0,xmm2
    mulps   xmm0,.f03


    movups  xmm1,[edi]
    mulps   xmm1,.f30
    addps   xmm1,xmm0
    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1


    movdqa  xmm5,xmm0	; is in screen area ?
    movlhps xmm5,xmm1
    movaps  xmm6,xmm5
    pcmpgtd xmm5,.up_res
    pcmpgtd xmm6,.4x  ;[i4x4]
    pxor    xmm5,xmm6
    movmskps eax,xmm5
    cmp     eax,00001111b
    jnz     @f

    movd    eax,xmm0
    movd    ecx,xmm1
    pxor    xmm6,xmm6
    psrldq  xmm0,4
    psrldq  xmm1,4
    movd    ebx,xmm0
    movd    edx,xmm1
    movd    mm3,.col
    movd    mm1,.scr
    movzx   esi,word .xress
    movd    mm2,esi  ;.xres  ;esi
    movd    xmm7,.xress  ;[xres_vard]
    punpcklwd xmm7,xmm6

    call    linea1
  @@:
    pop     esi
    pop     edi
    pop     ecx
    pop     edx
    add     edi,12
    dec     ecx
    jnz     .next


    jmp     .end

  .vert:

    mov     ecx,[points_count_var]
    mov     edi,[points_normals_rotated_ptr]
    mov     esi,[points_rotated_ptr]
    mov     eax,.col

  .again:
    push     esi
    push     edi
    push     ecx
    push     eax


    movups   xmm0,[edi]
    movups   xmm1,[esi]
    mulps    xmm0,.f30
    addps    xmm0,xmm1
    movd     mm3,eax

    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1

    movdqa  xmm5,xmm0
    movlhps xmm5,xmm1
    movaps  xmm6,xmm5
    pcmpgtd xmm5,.up_res
    pcmpgtd xmm6,.4x
    pxor    xmm5,xmm6
    movmskps eax,xmm5
    cmp     eax,00001111b
    jnz     @f

    movd    eax,xmm0
    movd    ecx,xmm1
    pxor    xmm6,xmm6
    psrldq  xmm0,4
    psrldq  xmm1,4
    movd    ebx,xmm0
    movd    edx,xmm1
    movd    mm1,.scr
    movzx   esi,word .xress
    movd    mm2,esi
    movd    xmm7,.xress
    punpcklwd xmm7,xmm6
    call    linea1
  @@:
    pop     eax
    pop     ecx
    pop     edi
    pop     esi
    add     edi,12
    add     esi,12
    loop    .again

   .end:


    add     esp,120
    pop     ebp
ret
