


;=======================================================================
rm_inner_faces:
;  remove inside faces, whole face must reside
;  in closed volume of object
   push    ebp
   mov	   ebp,esp
   sub	   esp,12

   .trii_count equ dword[ebp-4]
   .trii       equ dword[ebp-8]
   .mem_start  equ dword[ebp-12]



   xor	   ebx,ebx
  .alloc:

   mov	   eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   [thread_params+ebx],eax

   mov	    eax,1050*1050*4+65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   call     mem_error
  @@:
   mov	   [thread_params+ebx+4],eax

   mov	   eax,[triangles_count_var]
   add	   eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   [thread_params+ebx+8],eax

   mov	    eax,[points_count_var]
   imul     eax,12
   add	    eax,30
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   call     mem_error
  @@:
   mov	    [thread_params+ebx+12],eax

   add	    ebx,16
   cmp	    ebx,16*4
   jne	   .alloc




if 0

   mov	   ebx,1050*1050*8+150
   mov	   edx,[points_count_var]
   imul    edx,12
   add	   edx,128
   push    edx
   mov	   eax,edx
   add	   eax,ebx
   add	   eax,[triangles_count_var]
   shl	   eax,2
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE

   mov	   .mem_start,eax

   pop	   edx


     xor     ebx,ebx
    .alloc2:
      mov   [thread_params+ebx],eax
      add   eax,1050*1050*4+128
      mov   [thread_params+ebx+4],eax
      add   eax,1050*1050*4+128
      mov   [thread_params+ebx+8],eax
      add   eax,[triangles_count_var]
      add   eax,128
      mov   [thread_params+ebx+12],eax
      add   eax,edx
      add   ebx,16
      cmp   ebx,16*4
      jne   .alloc2

end if



    mov        eax,rm_inner_faces_th
    xor        edx,edx
    mov        ecx,-1
    call       call_thread1



   mov	  ebx,16      ; merge visable triangles list
  .nx_tri_p:	      ; next tri list params
   mov	  edi,[thread_params+8]
   mov	  esi,[thread_params+8+ebx]
   mov	  ecx,[triangles_count_var]
  .mv:
   cmp	  byte[esi],1
   jne	  @f
   mov	  al,[esi]
   mov	  [edi],al
  @@:
   inc	  esi
   inc	  edi
   loop   .mv
   add	  ebx,16
   cmp	  ebx,64
   jne	  .nx_tri_p

   mov	  esi,[thread_params+8]    ; count visable tris
   mov	  ecx,[triangles_count_var]
   xor	  ebx,ebx
  .cnt:
   cmp	  byte[esi],1
   jne	  @f
   inc	  ebx
  @@:
   inc	  esi
   loop   .cnt
   or	  ebx,ebx
   jz	  .free_all
   mov	  .trii_count,ebx
   imul   ebx,12
   add	  ebx,1024


   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   .trii,eax

   mov	  ebx,[thread_params+8] ; renew triangles list
   mov	  esi,[triangles_ptr]
   mov	  edi,.trii
   mov	  ecx,[triangles_count_var]
 .move:
   cmp	  byte[ebx],1
   jne	  @f
   movsd
   movsd
   movsd
   inc	   ebx
   loop   .move
   jmp	  .enm
  @@:
   add	  esi,12
   inc	  ebx
   loop   .move
 .enm:

   invoke VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE
   push   .trii
   pop	  [triangles_ptr]
   push   .trii_count
   pop	  [triangles_count_var]

 .free_all:
  xor	  ebx,ebx
 @@:
  invoke  VirtualFree,[thread_params+ebx],0,MEM_RELEASE
  add	  ebx,4
  cmp	  ebx,64
  jne	  @b

;  invoke  VirtualFree,.mem_start,0,MEM_RELEASE

   cls
   mov	 esp,ebp
   pop	 ebp
ret

;======================================================================

rm_inner_faces_th:
;  Remove inside faces.
; in:
;  ebx = -1 -> leave only front, otherwise ->
;   -> ebx = thread No
;  edi -> vertices to project
;  in threaded cause :
;   dword[thread_params]    -  .z_buff	   - zbuffer
;   dword[thread_params+4]  -  .prj_buff   - project buffer
;   dword[thread_params+8]  -  .tri_buff   - triangles buffer
;   dword[thread_params+12] -  .points_rot - vertices rotated buffer

   push  ebp
   mov	 ebp,esp
   and	 ebp,-16
   sub	 ebp,128   ; to increase shorter adresses amount
   sub	 esp,200

   .z_buff     equ dword[ebp+4]
   .prj_buff   equ dword[ebp+8]
   .tri_buff   equ dword[ebp+12]
   .side0      equ dword[ebp+16]
   .tri_count  equ dword[ebp+20]
   .tri        equ dword[ebp+24]
   .sinx       equ dword[ebp+28]
   .cosx       equ dword[ebp+32]
   .siny       equ dword[ebp+36]
   .cosy       equ dword[ebp+40]
   .sinz       equ dword[ebp+44]
   .cosz       equ dword[ebp+48]
   .points_rot equ dword[ebp+52]
   .side1      equ dword[ebp+56]
   .side2      equ dword[ebp+60]
   .matrix     equ [ebp+64]
   .tri_buffe  equ [ebp+100]
   .only_front equ dword[ebp+104]
   .vert_to_prj equ dword[ebp+108]
   .start0     equ dword[ebp+112]
   .start1     equ dword[ebp+116]
   .start2     equ dword[ebp+120]
   .end0       equ dword[ebp]
   .end1       equ dword[ebp-4]
   .end2       equ dword[ebp-8]
   .step       equ dword[ebp-12]
   .i12        equ dword[ebp-16]
   .f500x3	equ [ebp-32]
   .f490x3	equ [ebp-48]
   .mln 	equ [ebp-52]


   mov	   .only_front,ebx	; th_no
   mov	   .vert_to_prj,edi

   movaps    xmm0,[f500x3]
   movaps    xmm1,[f490x3]
   movaps    .f500x3,xmm0
   movaps    .f490x3,xmm1
   mov	     .i12,12
   mov	     eax,1000 * 1000
   mov	     .mln,eax

   prompt  prompt_inside_fac

   cmp	   ebx,-1
   jne	   .no_crop_front
   mov	   ebx,-17
   mov	   .start0,ebx
   mov	   .start1,ebx
   mov	   .start2,ebx
   mov	   ebx,17
   mov	   .end0,ebx
   mov	   .end1,ebx
   mov	   .end2,ebx
   mov	   .step,16
; Alloc 1000x1000  buffs
   mov	   ebx,1050*1050*4+65536
   malloc  ebx
   mov	   .z_buff,eax

   malloc  ebx
   mov	   .prj_buff,eax

   mov	   eax,[triangles_count_var]
   add	   eax,65536
   malloc  eax
   mov	   .tri_buff,eax

   mov	   eax,[points_count_var]
   imul    eax,12  ;.i12
   add	   eax,30
   malloc  eax
   mov	   .points_rot,eax

   jmp	   .ff


  .no_crop_front:
   mov	   ecx,64
   mov	   eax,.only_front   ; th no
   imul    ecx,eax

   xor	   ebx,ebx
   mov	   .start0,ecx
   mov	   .start1,ebx
   mov	   .start2,ebx
   mov	   ebx,257
   add	   ecx,64
   inc	   ecx
   mov	   .end0,ecx
   mov	   .end1,ebx
   mov	   .end2,ebx
   mov	   .step,32

   shl	   eax,4
   add	   eax,thread_params
   push    dword[eax]
   pop	   .z_buff
   push    dword[eax+4]
   pop	   .prj_buff
   push    dword[eax+8]
   pop	   .tri_buff
   push    dword[eax+12]
   pop	   .points_rot
  .ff:
   mov	   edi,[points_r_ptr]
   mov	   .vert_to_prj,edi

   cld
   mov	   ecx,[triangles_count_var]
   mov	   edi,.tri_buff
   xor	   eax,eax
   shr	   ecx,2
   add	   ecx,3000
   rep	   stosd


; Do paralell projection.
; Render faces with index of face as a color.
  push	  .start0
  pop	  .side0
 .next_side0:
  push	  .start1
  pop	  .side1
 .next_side1:
  push	  .start2
  pop	  .side2
 .next_side2:

   mov	   eax,.side0
   mov	   ebx,.side1
   mov	   edx,.side2
   lea	   edi,.matrix
   call    make_matrixX


   push   ebp
   mov	  esi,.vert_to_prj   ; vertices to project
   mov	  edi,.points_rot
   mov	  ecx,[points_count_var]
   lea	  ebx,.matrix
   call   rotary
   pop	  ebp

   cld
   mov	   ecx,.mln ;1000*1000
   mov	   edi,.prj_buff
   mov	   eax,-1
   rep	   stosd

   mov	   ecx,.mln ;1000*1000
   mov	   edi,.z_buff
   mov	   eax,60000.1
   rep	   stosd

   mov	  esi,[triangles_ptr]
   xor	  edx,edx
  .rd:	; render

   push   edx
   push   ebp
   lodsd
   xchg   eax,ecx
   lodsd
   xchg   ebx,eax
   lodsd
   xchg   eax,ecx
   push   esi
   imul   eax,12 ;.i12
   imul   ebx,12 ;.i12
   imul   ecx,12 ;.i12
   add	  eax,.points_rot
   add	  ebx,.points_rot
   add	  ecx,.points_rot

   push   dword 1000	 ; x res
   movups xmm0,[eax]
   movups xmm1,[ebx]
   movups xmm2,[ecx]

   mulps  xmm0,.f490x3
   mulps  xmm1,.f490x3
   mulps  xmm2,.f490x3
   addps  xmm0,.f500x3
   addps  xmm1,.f500x3
   addps  xmm2,.f500x3
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   movd   ecx,xmm3
   movd   ebx,xmm4
   movd   eax,xmm5
   push   eax
   push   ebx
   push   ecx

   pxor xmm6,xmm6
   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   cvtps2dq xmm2,xmm2
   packssdw xmm0,xmm6
   packssdw xmm1,xmm6
   packssdw xmm2,xmm6

   movd     eax,xmm0
   movd     ebx,xmm1
   movd     ecx,xmm2
   ror	    eax,16
   ror	    ebx,16
   ror	    ecx,16
   movups   xmm0,[esp]
   add	    esp,12
   mov	    esi,1000	  ; max y
   movd     xmm5,esi
   mov	    esi,.z_buff
   mov	    edi,.prj_buff

   call   flat_triangle_z_float
   pop	  esi
   pop	  ebp
   pop	  edx
   inc	  edx
   cmp	  edx,[triangles_count_var]
   jne	  .rd

; check if tri index in buff
   mov	  esi,.prj_buff
   mov	  ecx,.mln ;1000*1000
   cld
 .chck:
   lodsd
   cmp	  eax,[triangles_count_var]
   jae	  @f
   cmp	  eax,-1
   je	  @f
   add	  eax,.tri_buff
   mov	  byte[eax],1	 ; 1 - tri outside, 0 - inside
  @@:
   loop   .chck

   mov	   ecx,.step
   add	  .side2,ecx
   mov	   ebx,.end2
   cmp	  .side2,ebx
   jng	  .next_side2

   add	  .side1,ecx
   mov	   ebx,.end1
   cmp	  .side1,ebx
   jng	  .next_side1

   add	  .side0,ecx
   mov	   ebx,.end0
   cmp	  .side0,ebx
   jng	  .next_side0

   cmp	  .only_front,-1   ; only front faces ?
   jne	  .end		   ; end if no front

 ;  count triangles outside
   mov	  esi,.tri_buff
   mov	  ecx,[triangles_count_var]
   xor	  ebx,ebx

  .cnt:
   cmp	  byte[esi],1
   jne	  @f
   inc	  ebx
  @@:
   inc	  esi
   loop   .cnt
   mov	  .tri_count,ebx
   or	  ebx,ebx
   jz	  .no_ch
   imul   ebx,12 ;.i12
   add	  ebx,1024

   malloc ebx
   mov	  .tri,eax

   mov	  ebx,.tri_buff  ; renew triangles list
   mov	  esi,[triangles_ptr]
   mov	  edi,.tri
   mov	  ecx,[triangles_count_var]
 .move:
   cmp	  byte[ebx],1
   jne	  @f
   movsd
   movsd
   movsd
   inc	  ebx
   loop   .move
   jecxz  .fr
  @@:
   add	  esi,12
   inc	  ebx

   loop   .move

  .fr:

   invoke   VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE
   push    .tri
   pop	   [triangles_ptr]
   push    .tri_count
   pop	   [triangles_count_var]

 .no_ch:  ;  no change ion tri list

   invoke   VirtualFree ,.tri_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.prj_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE

   cls
  .end:
   add	  esp,200
   pop	  ebp

ret


;===============================================================

rem_cracks:

; remove cracks after only part of object tris teslation
; 'part' - triangles with positiv norm vect and/or from selected area


       push   ebp
       mov    ebp,esp
       sub    esp,200
       and    ebp,-16


     .f03	       equ dword[ebp]
     .cur_vi	       equ dword[ebp-4]
     .ed_no	       equ dword[ebp-8]
     .sec_vi	       equ dword[ebp-12]
     .fst_vi	       equ [ebp-16]
     .eps	       equ xword[ebp-32]
     .endt	       equ dword[ebp-36]
     .t_ptr	       equ dword[ebp-40]
     .curp	       equ dword[ebp-44]
     .piv2	       equ dword[ebp-48]
     .n_tri_cnt        equ dword[ebp-52]
     .i12	       equ dword[ebp-56]
     .points_r	       equ dword[ebp-60]
     .edges	       equ dword[ebp-64]
     .normVV	       equ xword[ebp-80]
     .veca	       equ xword[ebp-80-16]
     .vecb	       equ xword[ebp-80-32]
   ;  .dir		equ [ebp-80-64]
   ;  .f03		eqq [ebp-144]
     .cur_new_tri_ptr  equ dword[ebp-116]
     .piv	       equ dword[ebp-120]
     .len	       equ dword[ebp-124]




     prompt prompt_rm_cracks

     mov    .i12,12
     mov    ebx,[points_r_ptr]
     mov    eax,[edges_ptr]
     mov    .points_r,ebx
     mov    .edges,eax
     mov    .f03,dword 0.13
     mov    eax,0.0002
     movd   xmm0,eax
     pshufd xmm0,xmm0,0
     movdqa .eps,xmm0





  mov	  ebx,[edges_count]
  shl	  ebx,2
  add	  ebx,1024
  malloc  ebx
  mov	 .t_ptr,eax



  shl	  ebx,2
  malloc  ebx
  mov	  .piv,eax

  malloc  ebx

  mov	 .piv2,eax
				    ; do pivot list
    xor     ecx,ecx
    mov     edi,eax
    mov     esi,.edges
  @@:
    mov     eax,ecx
    movsd
    stosd
    movsd
    stosd
    inc     ecx
    cmp     ecx,[edges_count]
    jnz     @b

       mov	esi,.piv2
       mov	edi,.piv
       mov	ecx,[edges_count]
       add	ecx,ecx
       call	sort_hybrid1

;    sort_hybrid  calling conv
; in:  esi - 1st table
;      edi - sec table
;      ecx - tables_units count - unit 4 bytes
; out:
;      sorted first table

     invoke	VirtualFree,.piv,0 , MEM_RELEASE

     mov	ecx,[triangles_count_var]
     mov	ebx,[edges_d_count]
     sub	ebx,[edges_count]  ; ebx - single edes numb
     add	ecx,ebx
     imul	ecx,12 ;.i12
     add	ecx,1024
     invoke	VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or 	eax,eax
     jnz	@f
     call	mem_error
   @@:
     ; new triangles
     mov    .piv,eax
     mov     edi,eax
     mov     esi,[triangles_ptr]
     mov     ecx,[triangles_count_var]
     lea     ecx,[ecx*3]
     cld
     rep     movsd
     mov     .cur_new_tri_ptr,edi

 ;    invoke  VirtualFree,[triangles_ptr],0 , MEM_RELEASE


     xor      eax,eax
     mov      ebx,.piv
  ;   mov      [triangles_ptr],ebx
     mov      .n_tri_cnt,eax

      ; place for new tris
  mov	 ecx,[edges_count]
  add	 ecx,ecx
  mov	 esi,.piv2
  mov	 eax,ecx
  shl	 eax,2
  add	 eax,esi
  mov	 ebx,eax
  add	 ebx,8

  mov	 edi,.t_ptr	  ; table of pointers/adresses

  cld
  mov	 [edi],esi
  add	 edi,4
  dec	 ecx
  jz	 .dn
 .pt:
  lodsd 		  ; [esi]   - vert ind
  add	 esi,4
  cmp	 eax,[esi]	  ; [esi+4] - tri ind
  je	 @f
  mov	 eax,esi
  stosd 		  ; ptr to piv table
  dec	 ecx
  jz	 .dn
 @@:
  cmp	esi,ebx  ;.endt
  jb	.pt

  .dn:	 ; done

     cld
     mov	ecx,[edges_count]
     mov	.endt,ecx
     mov	esi,.edges
     xor	ecx,ecx

  .nxx_edge:			    ; search for cracks/slits
     push	ecx
     mov	.ed_no,ecx
     lodsd			    ; ed first
     mov	.fst_vi,eax	    ; 1 vertex
     mov	ebx,eax
     lodsd
     push	esi		    ; 2vert
     mov	.sec_vi,eax	    ; ed sec
;     mov	 esi,ecx
;     and	 ecx,111b
;     shr	 esi,3
;     add	 esi,[edge_s_d_ptr]
;     bt	 word[esi],cx	; is single?
;     jc	 .nx_ed 	; is double!

     imul	eax,12 ;.i12
     imul	ebx,12 ;.i12
     add	eax,.points_r
     add	ebx,.points_r
     movups	xmm7,[eax]
     movups	xmm6,[ebx]
     movaps	.veca,xmm7
     movaps	.vecb,xmm6
     subps	xmm6,xmm7      ; I tried more general calculations
			       ; direction dependend, I abandon coz numerical
     mulps	xmm6,xmm6
     movhlps	xmm4,xmm6
     haddps	xmm6,xmm6
     addps	xmm6,xmm4

 ;    dpps	 xmm4,xmm4,01110111b	   ; errors - values near zero fight
     sqrtps	xmm6,xmm6
     movss	.len,xmm6

   ;  rsqrtps	 xmm4,xmm4
   ;  mulps	 xmm4,xmm6    ;xm4 - direction vect of cur edge
   ;  movaps	 .dir,xmm4

     mov	eax,.fst_vi  ;xmm0    ; 1st vert ind
     mov	.cur_vi,eax
   .sec:	; sec v index
     shl	eax,2
     add	eax,.t_ptr
     mov	esi,eax      ; esi - addr in piv tab
     lodsd		     ; vert index  ;search for other ed
     or 	eax,eax
     jz 	.nx_ed
     mov	.curp,eax
   .nx:
     mov	esi,.curp
     lodsd		     ; piv
     xchg	ebx,eax
     lodsd
     mov	.curp,esi    ; cur ptr
     cmp	ebx,.cur_vi  ; still the same vert index?
     jne	.nx_ed_in
     cmp	eax,.ed_no   ;	the same ed?
     je 	.nx
     mov	esi,eax
     shl	esi,3
     add	esi,.edges
     movq	xmm7,[esi]
     lodsd
     xchg	ebx,eax
     lodsd
     jmp       .check

   .nx_ed_in:
     mov	 ebx,.cur_vi
     mov	 eax,.sec_vi
     mov	 .cur_vi,eax
     cmp	 ebx,eax
     jne	 .sec
    ; sec index of cur ed
   .nx_ed:

     pop	esi
     pop	ecx
     inc	ecx
     cmp	ecx,.endt  ;[edges_count]
     jnz       .nxx_edge
     jmp       .end


   .check:

  ; .check_deeper:
     ;	  .fst_vi,  .sec_vi - cur ed v indexes - dir .dir
     ;	   verts: xm6, xm5 [ebx], [eax]
     ;	   xmm7 - 2 ed v indexes - dir the same
     movd    edx,xmm7
     cmp     edx,.cur_vi
     jne     @f
     shufps  xmm7,xmm7,00010001b
  @@:
     movd    edx,xmm7
     ; lowest dd xmm7 -  significant index
     movaps  xmm1,.veca ;xmm6  ;[ebx]
     movaps  xmm2,.vecb ;xmm5  ;[eax]
     ; calc margin
     movss   xmm0,.f03
     mulss   xmm0,.len
     shufps  xmm0,xmm0,0
     addps   xmm2,xmm1
     mulps   xmm2,[f05x3]
     movaps  xmm1,xmm2
     subps   xmm2,xmm0 ;.eps
     addps   xmm1,xmm0 ;.eps

     imul    edx,12 ;.i12
     add     edx,.points_r

     movups  xmm3,[edx]
     movaps  xmm4,xmm3
     cmpltps xmm3,xmm1
     cmpltps xmm4,xmm2
     xorps   xmm3,xmm4
     movmskps edx,xmm3
     and      edx,111b
     cmp      edx,111b
     jne      .nx	  ; next index from pivot lst edge

     movq     xmm1,.fst_vi		  ; fix tri list
     movaps   xmm2,xmm1
     pshufd   xmm1,xmm1,0
     pshufd   xmm2,xmm2,01010101b

     mov      esi,.piv	;[triangles_ptr]
     xor      ecx,ecx
     mov      ebx,[triangles_count_var]
  .lllv:
     movups   xmm3,[esi]
     movaps   xmm4,xmm1
     movaps   xmm0,xmm2
     pcmpeqd  xmm4,xmm3
     pcmpeqd  xmm0,xmm3
     por      xmm0,xmm4
     movmskps eax,xmm0
     and      eax,111b
     cmp      eax,11b
     jz       .ok1
     cmp      eax,101b
     jz       .ok1
     cmp      eax,110b
     jz       .ok1

   ;  cmp      eax,111b
   ;  jne      .ok1
    ; popcnt   edx,eax
    ; cmp      edx,2
    ; je       .ok1

   @@:
     add      esi,12
     inc      ecx
     cmp      ecx,ebx
     jnz      .lllv

     jmp      .nx
     ; ecx - tri to divide  index
    .ok1:
     bt       eax,0
     jnc      @f
     pshufd   xmm3,xmm3,11001001b
     bt       eax,1
     jnc      @f
     pshufd   xmm3,xmm3,11001001b
    @@:

     movdqa  xmm4,xmm3
     mov     edi,esi

     lodsd
     xchg    ebx,eax
     lodsd
     xchg    ecx,eax
     lodsd
;     push    ebx
;     push    ecx
;     push    eax

;     movdqa  xmm5,[esp]
;     add     esp,.i12
;     movd    eax,xmm4
;     movd    ebx,xmm3
     ;calc norm
     ;cmp     eax,.fst_vi
     ;jne

     mov     edx,.i12
     imul    ebx,edx
     add     ebx,.points_r
     imul    ecx,edx
     add     ecx,.points_r
     imul    eax,edx
     add     eax,.points_r
;     mov     eax,.cur_vi
;     movaps  xmm1,.veca ;[eax]
;     movups  xmm2,[ebx]
;     movaps  xmm3,.vecb ;[ecx]
;     cmp     eax,.fst_vi
;     je      @f
;     movaps  xmm5,xmm1
;     movaps  xmm1,xmm3
;     movaps  xmm3,xmm5
;   @@:
     movups  xmm1,[eax]
     movups  xmm2,[ebx]
     movups  xmm0,[ecx]

     or      eax,-1
     stosd    ; mark
     stosd
     stosd

     subps   xmm0,xmm1
     subps   xmm1,xmm2

     call    cross_reg

 ;    dpps    xmm1,xmm0,01110111b
 ;    sqrtps  xmm1,xmm1
 ;    divps   xmm0,xmm1   ;   maybye just chck sign of 'Z' coorf ??
     movaps  .normVV,xmm0

     ;	3 2 1 xm4 & 1 xm7
     ; tris inds
     ; both tris have  llxm4
     ; lh & hl xm4 indexs - xm6, xm5 verts
     ; llxm4: 3rd index of tri	@ .tri_ptr

     ; chck its senses (whole vec) of norm vects, must like in .normVV

			     ; sec tri v indexes -
			     ; xmm7 lowst and hgst
			     ; and dword on stack

     movdqa    xmm1,xmm4
     movlhps   xmm1,xmm7
     pshufd    xmm1,xmm1,11111000b
     movhps    xmm1,.fst_vi   ; xmm1 - 1b	  1a	 2a	3a
   ;  int3		      ; 	scxm0	 lwxm0	lwxm7  lwst xm6

     movaps    xmm7,xmm1
     pshufd    xmm1,xmm1,11100001b
     pshufd    xmm7,xmm7,10110100b
     movaps    xmm3,xmm1
     movhlps   xmm2,xmm1
     pshufd    xmm1,xmm1,11100001b
	     ; xm1 - xm3 indices
     mov       ecx,2
     cld
     mov	edi,.cur_new_tri_ptr
     movaps	xmm6,.normVV
  ;   movaps	 xmm5,.eps
   .nxx_new_tri:
     movd      eax,xmm1
     mov       ebx,eax
     stosd
     movd      eax,xmm2
     mov       edx,eax
     stosd
     movd      eax,xmm3
     stosd		     ; renew   tris

     imul      ebx,12
     imul      edx,12
     imul      eax,12
     add       ebx,.points_r
     add       edx,.points_r
     add       eax,.points_r

     movups    xmm0,[eax]
     movups    xmm1,[ebx]
     movups    xmm2,[edx]
     subps     xmm0,xmm1
     subps     xmm1,xmm2
     call      cross_reg
  ;   destorys xm0 - xm3
  ;   dpps	xmm2,xmm0,01110111b
  ;   sqrtps	xmm2,xmm2
  ;   divps	xmm0,xmm2
     xorps     xmm0,xmm6

   ;  movaps	xmm1,xmm0  ; check only signs !!
   ;  addps	xmm1,xmm5  ;.eps
   ;  subps	xmm0,xmm5 ;.eps
   ;  cmpltps	xmm1,xmm6 ;.normVV
   ;  cmpltps	xmm0,xmm6 ;.normVV
   ;  xorps	xmm1,xmm0  ;.normVV
     movmskps  eax,xmm0
     and       eax,111b
     cmp       eax,111b
     jne       @f
     mov       edx,[edi-4]
     mov       eax,[edi-8]
     mov       [edi-4],eax  ; swap
     mov       [edi-8],edx
   @@:
     movaps	xmm2,xmm7
     movaps	xmm1,xmm7
     movhlps	xmm3,xmm7
     pshufd	xmm2,xmm2,11100001b
     loop	.nxx_new_tri

     inc	.n_tri_cnt
     inc	.n_tri_cnt
     mov	.cur_new_tri_ptr,edi
     jmp	.nx_ed	;_chck

   .end:

     mov       ebx,.n_tri_cnt
     or        ebx,ebx
     jz        .end22

     invoke    VirtualFree,[triangles_ptr],0 , MEM_RELEASE
     push      .piv
     pop       [triangles_ptr]
     mov       ecx,.n_tri_cnt
     add       [triangles_count_var],ecx
     call      remove_dead_tri
     jmp       .end3

  .end22:
     invoke   VirtualFree,.piv,0 , MEM_RELEASE
  .end3:
     invoke   VirtualFree,.piv2,0 , MEM_RELEASE
     invoke   VirtualFree,.t_ptr,0 , MEM_RELEASE
     cls
     mov      ecx,.n_tri_cnt

     add      esp,200
     pop      ebp
ret

;========================================================================================


call_thread1:
; in eax  - proc-th adress
;    edx -  param bitewise 'and' with param passed to proc_th
;    ecx -  max thread count, if -1 no in use

     push   ebp
     mov    ebp,esp

     push   edx
     push   eax
     push   ecx
 ;    sub    ebp,30

     .par1   equ dword[ebp-4]
     .procTh equ dword[ebp-8]
     .maxTh  equ dword[ebp-12]

     mov    ebx,4
     cmp    ecx,-1
     cmove  ecx,ebx
     mov    .maxTh,ecx

     xor    ebx,ebx
   .th_l:
     push   ebx
     mov    eax,ebx
     or     eax,.par1

     invoke CreateThread,NULL,NULL,.procTh,\
	    eax,NORMAL_PRIORITY_CLASS,\
	    [ThreadID0+ebx*4]
     shl    ebx,2
     add    ebx,hthread0
     mov    [ebx],eax
     invoke SetThreadPriority,ebx,NORMAL_PRIORITY_CLASS
     pop    ebx
     inc    ebx
     cmp    ebx,4
     jne    .th_l

     xor    ebx,ebx
   @@:
     invoke SetThreadAffinityMask,[hthread0+ebx*4],0 ;1
     inc    ebx
     cmp    ebx,4
     jne    @b

     xor    ebx,ebx
   @@:
     invoke ResumeThread,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b

     invoke WaitForMultipleObjectsEx,4,hthread0,1,-1,0

     xor    ebx,ebx
   @@:
     invoke CloseHandle,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b


    mov     esp,ebp
    pop     ebp
ret


;=============================================================================

del_tiv_ie_without:
;   delete triangles with at last one inside vertex,
;   and without intersecting edges.
; in:  esi - ptr to inside vertices mask list
;      ebx - ptr to intersecting edges mask list
; out: corrected triangles list.

   push  ebp
   mov	 ebp,esp

   .in_vr     equ dword[ebp-4]	; ptr to inside vertices list
				; if correspond bit is zeroed ->
				; -> vertex is inside object

   .clidd_ed  equ dword[ebp-8]	; ptr to colidded edges list
				; each bit in list -> edge
   push   esi			; if bit is set->  edge intersect
   push   ebx


   xor	 ecx,ecx
 .main_loop:
   push  ecx
   mov	 esi,ecx
   mov	 ebx,ecx
   shr	 esi,3
   and	 ebx,111b
   add	 esi,.in_vr
   bt	 [esi],ebx
   jc	 .nx_ed

   movd     xmm0,ecx	  ; vert inside, check if tri has edge that intersect
   pshufd   xmm0,xmm0,0
   mov	    esi,[triangles_ptr]
   xor	    edx,edx
  .nx_tri_loop:
   movups   xmm1,[esi]
   pcmpeqd  xmm1,xmm0	; xmm0 - broadcasted vert index
   movmskps eax,xmm1
   and	    eax,111b
   or	    eax,eax
   jnz	    @f
  .ntri:
   inc	    edx
   add	    esi,12
   cmp	    edx,[triangles_count_var]
   jnz	    .nx_tri_loop
   jmp	    .nx_ed

  @@:
   ; tri found

   movdqu   xmm1,[esi]
   movdqa   xmm2,xmm1	;[esi]
   movdqa   xmm3,xmm1
   pshufd   xmm1,xmm1,01000001b
   pshufd   xmm2,xmm2,10000010b
   pshufd   xmm3,xmm3,01101001b

   xor	    ecx,ecx
   mov	    edi,[edges_ptr]
 .check:
   movq     xmm4,[edi]
   pshufd   xmm4,xmm4,01000100b
   movdqa   xmm5,xmm4
   movdqa   xmm6,xmm4
   pcmpeqd  xmm4,xmm1
   pcmpeqd  xmm5,xmm2
   pcmpeqd  xmm6,xmm3

   movmskps eax,xmm4
   mov	    ebx,eax
   and	    eax,11b
   shr	    ebx,2
   cmp	    ebx,11b
   jz	    .ed_found
   cmp	    eax,11b
   jz	    .ed_found
   movmskps eax,xmm5
   mov	    ebx,eax
   and	    eax,11b
   shr	    ebx,2
   cmp	    ebx,11b
   jz	    .ed_found
   cmp	    eax,11b
   jz	    .ed_found
   movmskps eax,xmm6
   mov	    ebx,eax
   and	    eax,11b
   shr	    ebx,2
   cmp	    ebx,11b
   jz	    .ed_found
   cmp	    eax,11b
   jz	    .ed_found

;   popcnt   eax,eax
;   cmp      eax,2
;   jz	     .ed_found
;   movmskps eax,xmm5
;   popcnt   eax,eax
;   cmp      eax,2
;   jz	     .ed_found
;   movmskps eax,xmm6
;   popcnt   eax,eax
;   cmp      eax,2
;   jz	     .ed_found
  .no_int_ed:
   add	    edi,8
   inc	    ecx
   cmp	    ecx,[edges_count]
   jnz	    .check

  ; now all edges was checked no one intersect,so we mark triangle
   movq     [esi],xmm0
   movd     [esi+8],xmm0
 ; no forget about removing dead ris from list in the end of proc !!
   jmp	    .ntri  ; Did any another tri with inside
		  ; vert and without intersect ed exist ?    ;.nx_ed

   .ed_found:
   mov	    ebx,ecx
   mov	    eax,ecx
   and	    ebx,111b
   shr	    eax,3
   add	    eax,.clidd_ed
   bt	    [eax],ebx
   jnc	    .no_int_ed	 ; this ed no intersect

  .nx_ed:
   pop	    ecx
   inc	    ecx
   cmp	    ecx,[points_count_var]
   jnz	    .main_loop

   call     remove_dead_tri

   mov	    esp,ebp
   pop	    ebp
ret

;================================================================================
clip_triangles:
; clipping triangles not beeing in teslate area
; so I am looking into tri rotated list...
   push  ebp
   mov	 ebp,esp
   sub	 esp,16
   .tri_ptr equ dword[ebp-4]
   .cntt    equ dword[ebp-8]
   .ptr     equ dword[ebp-12]


   mov	 eax,[points_rotated_ptr]
   mov	 .ptr,eax


   mov	   eax,[triangles_count_var]
   imul    eax,12
   add	   eax,20
   malloc  eax
   mov	   .tri_ptr,eax

   mov	   edi,eax
   mov	   esi,[triangles_ptr]
   mov	   ecx,[triangles_count_var]
   mov	  .cntt,0
   cld
   movaps  xmm7,[tri_area_x1]
  .l:
   mov	   eax,[esi]
   mov	   ebx,[esi+4]
   mov	   edx,[esi+8]
   imul    eax,12
   imul    ebx,12
   imul    edx,12
   add	   eax,.ptr
   add	   ebx,.ptr
   add	   edx,.ptr
   movlps  xmm0,[eax]
   movlps  xmm1,[ebx]
   movlps  xmm2,[edx]
   movlhps xmm0,xmm0
   movlhps xmm1,xmm1
   movlhps xmm2,xmm2
   cmpltps xmm0,xmm7
   cmpltps xmm1,xmm7
   cmpltps xmm2,xmm7
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   xorps   xmm0,xmm3
   xorps   xmm1,xmm4
   xorps   xmm2,xmm5
   pand    xmm0,xmm1
   pand    xmm0,xmm2
   movmskps eax,xmm0
   and	    eax,11b
   cmp	    eax,11b
   jne	    @f
   movsd
   movsd
   movsd
   inc	   .cntt
   loop    .l
   jecxz   .enl
  @@:
   add	   esi,12
   loop    .l

  .enl:

   mov	   ecx,.cntt
   cmp	   ecx,[triangles_count_var]
   je	   @f
   mov	   [triangles_count_var],ecx
   invoke  VirtualFree,[triangles_ptr],0,MEM_RELEASE
   push    .tri_ptr
   pop	   [triangles_ptr]
   jmp	   .end
  @@:

   invoke  VirtualFree,.tri_ptr,0,MEM_RELEASE

 .end:

   mov	  esp,ebp
   pop	  ebp
ret

;===========================================================
mark_inner_vert:
;  Find vertices inside object,
;  max 16 threads
;  in:	intialised triangles and vertices list
;
;  out:
;	     ecx   - inside vertices number
;	     ebx   - pointer to list, each vertex as bit,
;		     if bit is zeroed, vertex is inside
     push    ebp
     mov     ebp,esp

     .coresc equ dword[ebp-4]

     prompt  prompt_mark_inn_vr

     mov    ebx,[CoresCount]
     and    ebx,0xf

     push   ebx

     xor    ebx,ebx
   .th_l:
     push   ebx
     mov    eax,ebx

     invoke CreateThread,NULL,NULL,mark_inner_vert_th,\
	    eax,NORMAL_PRIORITY_CLASS,\
	    [ThreadID0+ebx*4]
     shl    ebx,2
     add    ebx,hthread0
     mov    [ebx],eax
     invoke SetThreadPriority,ebx,THREAD_PRIORITY_TIME_CRITICAL
     pop    ebx
     inc    ebx
     cmp    ebx,.coresc
     jne   .th_l

     xor    ebx,ebx
   @@:
     invoke SetThreadAffinityMask,[hthread0+ebx*4],0 ;1
     inc    ebx
     cmp    ebx,.coresc
     jne    @b

     xor    ebx,ebx
   @@:
     invoke ResumeThread,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,.coresc
     jne    @b

     invoke WaitForMultipleObjectsEx,.coresc,hthread0,1,-1,0
     xor    ebx,ebx
   @@:
     invoke CloseHandle,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,.coresc
     jne    @b


   xor	  ecx,ecx
   mov	  ebx,.coresc
   dec	  ebx
 .l1:
   mov	  edi,[thread_params]
   push   ecx
   mov	  esi,[thread_params+4+4*ecx]
   mov	  ecx,[points_count_var]
   shr	  ecx,7
   inc	  ecx
 @@:
   movdqa xmm0,[esi]
   por	  xmm0,[edi]
   movdqa [edi],xmm0
   add	  edi,16
   add	  esi,16
   loop   @b
   pop	  ecx
   inc	  ecx
   cmp	  ecx,ebx
   jnz	  .l1



   xor	  ecx,ecx
   mov	  ebx,[points_count_var]
  .cnt:
   push   ecx
   mov	  edx,ecx
   shr	  edx,3
   and	  ecx,111b
   add	  edx,[thread_params]
   bt	  [edx],ecx
   sbb	  ebx,0
   pop	  ecx
   inc	  ecx
   cmp	  ecx,[points_count_var]
   jnz	  .cnt


   mov	  ecx,.coresc
   mov	  edx,ecx
   dec	  ecx
  .free:
   push    ecx
   push    edx
   mov	   edi,[thread_params+edx+ecx*4]
   invoke  VirtualFree ,edi ,0 , MEM_RELEASE
   pop	   edx
   pop	   ecx
   loop    .free

   cls

   mov	  ecx,ebx  ;.in_vert_count
   mov	  ebx,[thread_params]; ptr to list


  mov	  esp,ebp
  pop	  ebp
ret

;=======================================================================
fix_normals:

   push  ebp
   mov	 ebp,esp
   sub	 esp,140

   .z_buff	  equ dword[ebp-4]
   .i12 	  equ dword[ebp-8]  ; ptr to desired list
   .tri_mark	  equ dword[ebp-12]
   .crp3	  equ dword[ebp-16]
   .do_fix	  equ dword[ebp-20]
   .norm_rot	  equ dword[ebp-24]
   .irp3	  equ dword[ebp-28]
   .t_ptr	  equ dword[ebp-32]
   .siny	  equ dword[ebp-36]
   .cosy	  equ dword[ebp-40]
   .sinz	  equ dword[ebp-44]
   .cosz	  equ dword[ebp-48]
   .points_rot	  equ dword[ebp-52]
   .side1	  equ dword[ebp-56]
   .side2	  equ dword[ebp-60]
   .matrixx	  equ [ebp-104]
   .fx_occ     equ dword[ebp-108]   ; at last one fix occured
   .start0     equ dword[ebp-112]
   .start1     equ dword[ebp-116]
   .start2     equ dword[ebp-120]
   .end0       equ dword[ebp-124]
   .end1       equ dword[ebp-128]
   .end2       equ dword[ebp-132]
   .step       equ dword[ebp-136]
   .th_no      equ dword[ebp-140]

 ;  mov   .i12,12
   push  dword[constrecip3]
   pop	 .crp3
   push  [irecipr3]
   pop	 .irp3
   push  [triangles_ptr]
   pop	 .t_ptr

; Alloc 1000x1000  buffs
   mov	   eax,1050*1050*4+65536
   malloc  eax
   mov	   .z_buff,eax


   mov	   eax,[points_count_var]
   imul    eax,12
   add	   eax,30
   malloc  eax
   mov	   .points_rot,eax

   mov	   eax,[triangles_count_var]
   imul    eax,12
   add	   eax,30
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   .norm_rot,eax

   mov	   ebx,[triangles_count_var]
   add	   ebx,150
   shr	   ebx,3
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   .tri_mark,eax

   mov	   edi,.tri_mark
   mov	   ecx,[triangles_count_var]
   shr	   ecx,7
   inc	   ecx
   pxor    xmm0,xmm0
  @@:
   movdqa  [edi],xmm0
   loop    @b

; Do paralell projection.
; Render faces - only z coord


   rdtsc
   movzx     ebx,al

   shr	     eax,8
   movzx     edx,al

   shr	    eax,16
   movzx    eax,al

   lea	   edi,.matrixx
   call    make_matrixX

   mov	   esi,[triangles_normals_ptr]
   mov	   edi,.norm_rot
   mov	   ecx,[triangles_count_var]
   lea	   ecx,[ecx*3]
   inc	   ecx
   rep	   stosd

   mov	  esi,[triangles_normals_ptr]
   mov	  edi,.norm_rot
   mov	  ecx,[triangles_count_var]
   lea	  ebx,.matrixx
   call   rotary

   lea	  esi,.matrixx	  ;esi - pointer to 3x3 matrix
   mov	  ebx,f490x3	  ;ebx - ptr to scale
   call   add_scale_to_matrix

   mov	  esi,[points_r_ptr]  ; vertices to project
   mov	  edi,.points_rot
   mov	  ecx,[points_count_var]
   lea	  ebx,.matrixx
   call   rotary

   mov	    esi,.points_rot
   mov	    ecx,[points_count_var]
 @@:
   movups   xmm0,[esi]
   addps    xmm0,[f500x3]
   movhlps  xmm1,xmm0
   cvtps2dq xmm0,xmm0
   pshufd   xmm0,xmm0,11100001b
   movq     [esi],xmm0
   movss    [esi+8],xmm1      ; z coord still float
   add	    esi,12
   loop     @b

   xor	   eax,eax
   mov	  .fx_occ,eax	       ; at last one fix took place
   mov	  .do_fix,eax

  .sec:

   mov	   ecx,1020*1020
   mov	   edi,.z_buff
   mov	   eax,6000.1
   cld
   rep	   stosd

   mov	  esi,[triangles_ptr]
   xor	  ecx,ecx
   mov	  edx,12
 .rd:  ; render  with writing only to z buff
   push   esi
   push   ecx
   cmp	  .do_fix,0
   je	  @f

   imul    ecx,12	  ; cull face
   add	   ecx,.norm_rot
   bt	   dword[ecx+8],31
   jnc	  .skip  ; no render

 @@:
   mov	  eax,[esi]
   mov	  ebx,[esi+4]
   mov	  ecx,[esi+8]
   imul   eax,12
   imul   ebx,12
   imul   ecx,12
   add	  eax,.points_rot
   add	  ebx,.points_rot
   add	  ecx,.points_rot
   movq   xmm0,[eax]
   movq   xmm1,[ebx]
   movq   xmm2,[ecx]
   xorps  xmm7,xmm7
   movss  xmm3,[eax+8]
   movss  xmm4,[ebx+8]
   movss  xmm5,[ecx+8]

   packssdw xmm0,xmm7
   packssdw xmm1,xmm7
   packssdw xmm2,xmm7
   movd     eax,xmm0
   movd     ebx,xmm1
   movd     ecx,xmm2
   mov	    edx,1000 shl 16 + 1000
   movss    xmm0,xmm3
   shufps   xmm4,xmm4,11110011b
   movlhps  xmm0,xmm5
   orps     xmm0,xmm4

   mov	  esi,.z_buff
   movd   xmm5,[shll]  ; stencil_line
   call   stencil_tri

 .skip:

   pop	  ecx
   pop	  esi
   add	  esi,12

   inc	  ecx
   cmp	  ecx,[triangles_count_var]
   jne	  .rd


   mov	    esi,.t_ptr ;[triangles_ptr]    ; check witch are rendered /at front/
   xor	    ecx,ecx
   mov	    eax,1.3
   movd     xmm7,eax  ;[eps3]  ;		epsilon1]
   shufps   xmm7,xmm7,0
 .check_in:

   push   esi
   mov	  eax,[esi]
   mov	  ebx,[esi+4]
   mov	  edx,[esi+8]
   imul   eax,12
   imul   ebx,12
   imul   edx,12

   add	  eax,.points_rot
   add	  ebx,.points_rot
   add	  edx,.points_rot

   movss  xmm0,[eax+8]
   addss  xmm0,[ebx+8]
   addss  xmm0,[edx+8]
   mulss  xmm0,.crp3
   movq   xmm1,[eax]
   movq   xmm2,[ebx]
   movq   xmm3,[edx]
   paddd  xmm1,xmm2
   paddd  xmm1,xmm3
   movd   eax,xmm1
   psrldq xmm1,4
   movd   esi,xmm1
   mov	  ebx,.irp3
   mul	  ebx
   push   edx	      ; edx - y
   mov	  eax,esi
   mul	  ebx	      ; edx - x
   pop	  eax
   mov	  ebx,1000
   imul   eax,ebx      ; y
   add	  eax,edx
   and	  eax,0xfffff
   shl	  eax,2
   add	  eax,.z_buff
   movss  xmm6,[eax]

   movss    xmm1,xmm0
   addss    xmm1,xmm7
   subss    xmm0,xmm7
   cmpltps  xmm1,xmm6
   cmpltps  xmm0,xmm6
   pxor     xmm0,xmm1
   movd     eax,xmm0
   movd     xmm5,ecx
   mov	    ebx,ecx
   shr	    ebx,3
   and	    ecx,111b
   add	    ebx,.tri_mark
   cmp	    .do_fix,1
   je	    @f
   or	    eax,eax
   jz	    @f
   bts	    word[ebx],cx      ; triangle with appropiate bit set -
  @@:			      ; was rendered /in front/
   cmp	    .do_fix,0
   je	    @f

	; check if rendered now
	; not - skip forward
   bt	    word[ebx],cx   ; was rendered (in z buff) previously ?
   jnc	    @f
   or	    eax,eax	   ; is now ren ?
   jz	    .fix_norm
			   ; yes - fix normal vect

 @@:
 .nxchck:
   movd     ecx,xmm5
   inc	    ecx
   pop	    esi
   add	    esi,12
   cmp	    ecx,[triangles_count_var]
   jnz	    .check_in

   inc	   .do_fix
   cmp	   .do_fix,2
   jne	   .sec 		  ; second rendering
				  ; with enabled backface culling
   jmp	   .done

 .fix_norm:
   cld
   movd    esi,xmm5
   imul    esi,12 ;.i12
   add	   esi,.t_ptr
   mov	   edi,esi
   lodsd	   ;swap
   mov	   ebx,eax
   movsd
   mov	   eax,ebx
   stosd
   inc	   .fx_occ
   jmp	   .nxchck

  .done:

  @@:

   invoke   VirtualFree ,.norm_rot ,0 , MEM_RELEASE
   invoke   VirtualFree ,.points_rot ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.tri_mark ,0 , MEM_RELEASE

   cls
   mov	  esp,ebp
   pop	  ebp
ret

;======================================================================
mark_inner_vert_th:

; in :	ebx - thread No
;
; out:
;      if .do_fix = 0
;	dword[thread_params+thread No*4] -  ptr to list
;	to inside vertices, if vertex is inside, adjacent bit is zeroed.

; Find vertices inside object

   push  ebp
   mov	 ebp,esp
   sub	 esp,180

   .z_buff	  equ dword[ebp-4]
   .inner_vert	  equ dword[ebp-8]  ; ptr to desired list
   .in_vert_count equ dword[ebp-12]
   .side0	  equ dword[ebp-16]
   .do_fix	  equ dword[ebp-20]
   .norm_rot	  equ dword[ebp-24]
   .sinx	  equ dword[ebp-28]
   .cosx	  equ dword[ebp-32]
   .siny	  equ dword[ebp-36]
   .cosy	  equ dword[ebp-40]
   .sinz	  equ dword[ebp-44]
   .cosz	  equ dword[ebp-48]
   .points_rot	  equ dword[ebp-52]
   .side1	  equ dword[ebp-56]
   .side2	  equ dword[ebp-60]
   .end1	  equ dword[ebp-64]
   .end2	  equ dword[ebp-68]
   .step	  equ dword[ebp-72]
   .cntt	  equ dword[ebp-100]
   .norm_to_rev   equ dword[ebp-104]
   .th_no	  equ dword[ebp-108]
   .start0	  equ dword[ebp-112]
   .start1	  equ dword[ebp-116]
   .start2	  equ dword[ebp-120]
   .end0	  equ dword[ebp-124]

   .matrix	  equ [ebp-170]


   mov	 .th_no,ebx

; Alloc 1000x1000  buffs
   mov	   eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
  @@:
   mov	   .z_buff,eax

   mov	   ebx,[points_count_var]
   shr	   ebx,3
   add	   ebx,30
   malloc  ebx
   mov	   .inner_vert,eax

   shl	   ebx,3+2
   lea	   ebx,[ebx*3]
   malloc  ebx
   mov	   .points_rot,eax


   mov	   edi,.inner_vert  ;eax
   mov	   ecx,[points_count_var]
   shr	   ecx,7
   inc	   ecx
   pxor    xmm0,xmm0
  @@:
   movdqa  [edi],xmm0
   loop    @b

   mov	   ecx,[CoresCount]
   and	   ecx,0xf

   mov	   ebx,.th_no
   mov	   eax,256
   cdq
   idiv    ecx

   mov	   .end0,eax
   imul    ebx,eax
   mov	   .start0,ebx
   add	   .end0,ebx

;   shl     ebx,6
;   mov     .start0,ebx
;   mov     .end0,ebx
;   add     .end0,64

;   mov     .start1,0
;   mov     .start2,0
;   mov     .end1,256
;   mov     .end2,256
   mov	   .step,24


; Do paralell projection.
; Render faces - only z coord
  push	  .start0
  pop	  .side0
;  mov	    .side0,0
 .next_side0:
;  push    .start1
;  pop	   .side1
  mov	   .side1,0
 .next_side1:
;  push    .start2
;  pop	   .side2
  mov	   .side2,0
 .next_side2:

   mov	   eax,.side0
   mov	   ebx,.side1
   mov	   edx,.side2
   lea	   edi,.matrix
   call    make_matrixX


   lea	   esi,.matrix	  ;esi - pointer to 3x3 matrix
   mov	   ebx,f490x3	  ;ebx - ptr to scale
   call    add_scale_to_matrix
   mov	   esi,[points_r_ptr]  ; vertices to project
   mov	   edi,.points_rot
   mov	   ecx,[points_count_var]
   lea	   ebx,.matrix
   call    rotary

   mov	   esi,.points_rot
   mov	   ecx,[points_count_var]
 @@:
   movups   xmm0,[esi]
   addps    xmm0,[f500x3]
   movhlps  xmm1,xmm0
   cvtps2dq xmm0,xmm0
   pshufd   xmm0,xmm0,11100001b
   movq     [esi],xmm0
   movss    [esi+8],xmm1
   add	    esi,12
   loop     @b

   mov	   ecx,1020*1020
   mov	   edi,.z_buff
   mov	   eax,6000.1
   cld
   rep	   stosd

   mov	  esi,[triangles_ptr]
   mov	  ecx,[triangles_count_var]
   mov	  edx,12
  .rd:	; render
   push   edx
   push   esi
   push   ecx
   mov	  eax,[esi]
   mov	  ebx,[esi+4]
   mov	  ecx,[esi+8]
   imul   eax,edx
   imul   ebx,edx
   imul   ecx,edx
   add	  eax,.points_rot
   add	  ebx,.points_rot
   add	  ecx,.points_rot
   movq   xmm0,[eax]
   movq   xmm1,[ebx]
   movq   xmm2,[ecx]

   movss  xmm4,[ebx+8]
   movss  xmm5,[ecx+8]
   movss  xmm3,[eax+8]

   packssdw xmm0,xmm0
   packssdw xmm1,xmm1
   packssdw xmm2,xmm2
   movd     eax,xmm0
   movd     ebx,xmm1
   movd     ecx,xmm2
   mov	    edx,1000 shl 16 + 1000

   movss    xmm0,xmm3
   shufps   xmm4,xmm4,11110011b
   movlhps  xmm0,xmm5
   orps     xmm0,xmm4
   movd     xmm5,[shll]  ; stencil_line
   mov	  esi,.z_buff
   call   stencil_tri
   pop	  ecx
   pop	  esi
   pop	  edx
   add	  esi,12
   dec	  ecx
   jne	  .rd



; check if z coord of each vert is  in buff

   mov	    esi,.points_rot
   xor	    ecx,ecx
   movss    xmm7,[eps3]  ;		  epsilon1]
   shufps   xmm7,xmm7,0
 .nxcnt:
   push     ecx
   movss    xmm0,[esi+8]
   shufps   xmm0,xmm0,0
   mov	    eax,[esi+4]  ; x coord
   mov	    ebx,[esi]	 ; y
   dec	    eax
   dec	    ebx
   imul     ebx,[i1000]
   add	    ebx,eax
   shl	    ebx,2
   and	    ebx,0x3FFFFF
   add	    ebx,.z_buff
   ; check adjacent 9 pixels
   movups   xmm1,[ebx]
   movups   xmm2,[ebx]
   add	    ebx,4000
   movups   xmm3,[ebx]
   movups   xmm4,[ebx]
   add	    ebx,4000
   movups   xmm5,[ebx]
   movups   xmm6,[ebx]

   addps    xmm1,xmm7
   subps    xmm2,xmm7
   addps    xmm3,xmm7
   subps    xmm4,xmm7
   addps    xmm5,xmm7
   subps    xmm6,xmm7
   cmpltps  xmm1,xmm0
   cmpltps  xmm2,xmm0
   cmpltps  xmm3,xmm0
   cmpltps  xmm4,xmm0
   cmpltps  xmm5,xmm0
   cmpltps  xmm6,xmm0
   xorps    xmm2,xmm1
   xorps    xmm3,xmm4
   xorps    xmm5,xmm6
   orps     xmm2,xmm3
   orps     xmm5,xmm2
   movmskps eax,xmm5
   and	    eax,111b
   or	    eax,eax
   jz	    @f
   mov	    eax,1
   mov	    edx,ecx
   shr	    edx,3
   and	    ecx,111b
   shl	    eax,cl
   add	    edx,.inner_vert
   or	    [edx],eax  ; if bit is set vertex is not inside
 @@:
   pop	    ecx
   add	    esi,12
   inc	    ecx
   cmp	    ecx,[points_count_var]
   jnz	    .nxcnt

  .end_steps:

   mov	   ecx,.step
   add	  .side2,ecx
;   mov     ebx,.end2
   cmp	  .side2,256 ;ebx
   jng	  .next_side2

   add	  .side1,ecx
;   mov     ebx,.end1
   cmp	  .side1,256  ;ebx
   jng	  .next_side1

   add	  .side0,ecx
   mov	   ebx,.end0
   cmp	  .side0,ebx
   jng	  .next_side0

   mov	  ecx,.inner_vert
 @@:
   mov	  ebx,.th_no
   shl	  ebx,2
   add	  ebx,thread_params
   mov	  [ebx],ecx

   invoke   VirtualFree ,.points_rot ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE

   cls
   mov	  esp,ebp
   pop	  ebp
ret




;===============================================================

do_edges_list:
; in:
;  some globals triangles list and whole number
; out:
;  edges list - [edges_ptr]  and edges number -> [edges_count]
    push    ebp
    mov     ebp,esp
    sub     esp,32

    .ed_cnt    equ [ebp-4]
    .ed_ptr    equ [ebp-8]
    .counter   equ [ebp-12]
    .ed1_ptr   equ [ebp-16]
    .ed3_ptr   equ [ebp-20]
    .ed_s_d    equ [ebp-24] ; edge - single / double
    .ed_sd_cnt equ dword[ebp-28]  ; count of double edges

    prompt  prompt_edges


    invoke  VirtualFree ,[edges_ptr],0 , MEM_RELEASE
    invoke  VirtualFree ,[edge_s_d_ptr],0 , MEM_RELEASE


    mov     ebx,[triangles_count_var]
    lea     ebx,[ebx*3]
    shl     ebx,4
    add     ebx,50
    malloc  ebx
    mov     .ed1_ptr,eax

    malloc  ebx
    mov     .ed_ptr,eax
 ;   mov     [edges_ptr],eax


    xchg    ebx,eax
    mov     eax,[triangles_ptr]
    mov     ecx,[triangles_count_var]
  @@:
    movdqu  xmm0,[eax]
    movq    [ebx],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+8],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+16],xmm0
    add     ebx,24
    add     eax,12
    loop    @b


    mov     ebx,.ed_ptr  ;[edges_ptr]
    mov     ecx,[triangles_count_var]
    lea     ecx,[ecx*3]
  .mxd:
    mov     eax,[ebx]
    mov     edx,[ebx+4]
    cmp     eax,[ebx+4]
    cmovg   eax,edx
    cmovg   edx,[ebx]
    mov     [ebx],eax
    mov     [ebx+4],edx
    add     ebx,8
    loop    .mxd

   mov	    esi,.ed_ptr  ;[edges_ptr]
   mov	    edi,.ed1_ptr
   mov	    ecx,[triangles_count_var]
   lea	    ecx,[ecx*3]
   call     sort_hybrid1



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  sort metod make diifference in edges count, whats up?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

   invoke   VirtualFree ,.ed1_ptr ,0 , MEM_RELEASE

  ; insert sort again
   mov	  ebx,.ed_ptr  ;[edges_ptr]
   mov	  ecx,[triangles_count_var]
   lea	  ecx,[ecx*3]
   mov	  esi,ecx
   shl	  esi,3
   add	  esi,ebx

 .count:
   push   ecx
   push   ebx
   xor	  ecx,ecx
   mov	  eax,[ebx]	     ; count
 .aa:
   inc	  ecx
   add	  ebx,8
   cmp	  ebx,esi
   jae	  .br	      ; break
   cmp	  eax,[ebx]
   je	  .aa
   mov	  .counter,ecx
   pop	  ebx
   mov	  edi,ebx
   sub	  edi,8
   mov	  edx,[ebx+8]
 .ccc2:

   cmp	  ebx,esi
   jbe	  @f
   add	  esp,4
   jmp	  .ff
 @@:
   mov	  eax,[ebx+12]
   mov	  edx,[ebx+8]
   cmp	  eax,[ebx+4]
   jge	  .g2
   movq   xmm0,[ebx+8]
   push   ebx
 .c2:
   cmp	  eax,[ebx+4]
   jae	  .done2
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7

   sub	  ebx,8
   cmp	  ebx,edi
   jz	  @f
   cmp	  [ebx+8],edx
   jz	  .c2
 @@:
 .done2:
   add	  ebx,8
   movq   [ebx],xmm0

 .p2:
   pop	  ebx
 .g2:
   add	  ebx,8
   dec	  ecx
   cmp	  ecx,1
   jnz	  .ccc2

   pop	  ecx
   sub	  ecx,.counter
   add	  ebx,8
   ja	  .count

   jmp	  .ff
 .br: ;break
   add	 esp,8
 .ff:


 ;   count edges

   mov	  ecx,[triangles_count_var]
   lea	  ecx,[ecx*3+3]
   mov	  esi,.ed_ptr  ;[edges_ptr]
   xor	  edx,edx
   cld
 .nx:
   lodsd
   mov	  ebx,[esi]
   add	  esi,4
   cmp	  eax,[esi]
   jnz	  .ic
   cmp	  ebx,[esi+4]
   jnz	  .ic
   loop   .nx
   jmp	  .endc
 .ic:

   inc	  edx
   loop   .nx
  .endc:
    mov     .ed_cnt,edx
    mov     ebx,edx


   shl	   ebx,3
   add	   ebx,65536
   malloc  ebx
   mov	   .ed3_ptr,eax

   shr	   ebx,3+3
   malloc  ebx
   mov	   .ed_s_d,eax


 ;  mov     ebx,.ed_cnt
 ;  shr     ebx,1   ; one bit per edge
 ;  add     ebx,100
 ;  malloc  ebx
 ;  mov     .ed_s_d,eax

    mov     edi,eax
    mov     ecx,.ed_cnt
    shr     ecx,5
    inc     ecx
    cld
    xor     eax,eax
    rep     stosd

   mov	    eax,.ed3_ptr
   mov	    ebx,.ed_ptr  ;[edges_ptr]
   mov	    ecx,[triangles_count_var]
   lea	    ecx,[ecx*3]
   add	    ecx,ecx
   xor	    esi,esi ; esi - counter
   mov	    .ed_sd_cnt,esi
  .seek:
   movq     xmm0,[ebx]
   movq     xmm1,[ebx+8]
   pcmpeqd  xmm1,xmm0
   pmovmskb edx,xmm1
   and	    edx,0xff
   cmp	    edx,0xff
   je	    .double
   movq     [eax],xmm0
   add	    eax,8
   inc	    esi
   jmp	    .sin
 .double:
   push     ecx
   push     esi
   inc	    .ed_sd_cnt	  ; count double edges
   mov	    ecx,esi
   shr	    esi,3
   and	    ecx,111b
   add	    esi,.ed_s_d
   bts	    dword[esi],ecx    ; pre bit set
   pop	    esi
   pop	    ecx
 .sin:
   add	    ebx,8
   loop     .seek

   invoke   VirtualFree ,.ed_ptr ,0 , MEM_RELEASE

   mov	    eax,.ed3_ptr
   mov	    ecx,.ed_cnt
   mov	    edx,.ed_s_d
   mov	    ebx,.ed_sd_cnt
   mov	    [edges_ptr],eax
   mov	    [edges_count],ecx
   mov	    [edge_s_d_ptr],edx
   mov	    [edges_d_count],ebx        ; double edges

   cls

   mov	    esp,ebp
   pop	    ebp
ret

;===========================================================================

remove_redundant_vert:	  ; remove redundand vertices
; in:			  ; merge some vertices from teslate area
;     registers:
;	 eax - approximation tolerancy (as dword float)
;	 ebx - mask - if z coord is importand = 111b, if not imp = 11b
;	 ecx - if = 0  check if  merged vertices should be in triangulize area
;	       "standard" verts removing
;	       if = 1  no checking
;
;     globals:
;	 points_r_ptr, triangles_ptr, points_normals_ptr
;	 points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov	ebp,esp
   sub	esp,80
   and	ebp,-16

   .mask		 equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .tri_ch		 equ [ebp-8]
   .t_ptr		 equ [ebp-12]
   .counter		 equ dword[ebp-16]
   .aprox_vert		 equ [ebp-32]	  ; tolerancy
   .aprox_norm		 equ [ebp-48]
   .mask2		 equ dword[ebp-52]
   .msk3		 equ dword[ebp-56]
   .chckk		 equ dword[ebp-60]

    ; set approximation tolerancy

   movd    xmm7,eax
   shufps  xmm7,xmm7,0
   movaps  .aprox_vert,xmm7
   mov	   .msk3,ebx
   mov	   .chckk,ecx

   prompt  prompt_red_vert

   ; alloc mem for mask
   mov	   ebx,[points_count_var]
   shr	   ebx,3
   add	   ebx,120
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
 @@:
   mov	  .mask,eax

   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   call    mem_error
 @@:
   mov	  .mask2,eax

   mov	    edi,.mask	    ; bit mask
   mov	    ecx,[points_count_var]
   shr	    ecx,3+4
   inc	    ecx
   pxor     xmm0,xmm0
 @@:
   movdqa   [edi],xmm0
   add	    edi,16
   loop     @b


   mov	    edi,.mask2	     ; bit mask
   mov	    ecx,[points_count_var]
   shr	    ecx,3+2
   inc	    ecx
   xor	    eax,eax
   cld
   rep	    stosd
;   pxor     xmm0,xmm0
; @@:
;   movdqa   [edi],xmm0
;   add      edi,16
;   loop     @b


   mov	    eax,1	     ; export esi, edi
   mov	    ebx,0x33333333   ; only pivot
   call     detect_chunks
;      esi - tri_ch    ; vertices with triangles list
;      edi - t_ptr     ; pointers to tri_ch list
   mov	    .tri_ch,esi
   mov	    .t_ptr,edi

 ; check if in triangulize(teslate) area

   prompt   prompt_red_vert

   cmp	    .chckk,1
   je	    .nochck

   mov	    esi,[points_rotated_ptr]
   xor	    ecx,ecx
   movlps   xmm7,[tri_area_x1]
   movlps   xmm6,[tri_area_x2]
 .chck:

   movups   xmm0,[esi]
   movups   xmm1,[esi]
   cmpltps  xmm1,xmm7
   cmpltps  xmm0,xmm6
   xorps    xmm0,xmm1
   movmskps eax,xmm0
   and	    eax,11b
   cmp	    eax,11b
   je	    .yes
   mov	    edi,ecx
   mov	    eax,ecx
   shr	    edi,3
   and	    eax,111b
   add	    edi,.mask
   bts	    dword[edi],eax
  .yes:
   add	    esi,12
   inc	    ecx
   cmp	    ecx,[points_count_var]
   jne	    .chck

  .nochck:


   mov	    esi,[points_rotated_ptr]
   mov	    .counter,0
  .nx_a1:
   push     esi

   mov	    edi,.counter
   mov	    eax,.counter
   shr	    edi,3
   and	    eax,111b
   add	    edi,.mask
   bt	    dword[edi],eax
   jc	    .nx_a

   movups   xmm6 ,[esi]
   movaps   xmm7,xmm6
   subps    xmm6,.aprox_vert
   addps    xmm7,.aprox_vert

   mov	    ebx,[points_rotated_ptr]
   xor	    ecx,ecx
;  mov	      ecx,.counter
;  dec	      ecx
;  mov	      ebx,ecx
;  imul       ebx,[12]
;  add	      ebx,[points_rotated_ptr]
 .nx_b1:
   push     ebx
   cmp	    ecx,.counter
   je	    .nx_b
   mov	    edi,ecx
   mov	    eax,ecx
   shr	    edi,3
   and	    eax,111b
   add	    edi,.mask
   bt	    dword[edi],eax
   jc	    .nx_b

   movups   xmm1,[ebx]
   movups   xmm0,[ebx]
   cmpltps  xmm1,xmm6
   cmpltps  xmm0,xmm7
   xorps    xmm0,xmm1
   movmskps eax,xmm0
   and	    eax,.msk3
   cmp	    eax,.msk3
   je	    .rem_v_in

 .nx_b:
   pop	    ebx
   add	    ebx,12
   inc	    ecx
   cmp	    ecx,[points_count_var]
   jne	   .nx_b1

 .nx_a:
   pop	    esi
   inc	    .counter
   add	    esi,12
   mov	    ecx,[points_count_var]
   cmp	    .counter,ecx
   jne	    .nx_a1

   cmp	    .chckk,1
   je	    .done


   jmp	    .rm_v	   ; remove unuse vert via chunks proc

 .rem_v_in:		    ; remove vert index
   push    ecx

   mov	   edi,ecx
   mov	   ebx,ecx
   shl	   edi,2
   add	   edi,.t_ptr
   mov	   edi,[edi]
 .l1:
   mov	   esi,[edi+4]	      ; edi - tri  index
;   cmp     ebx,[edi]	      ; ebx - vert index,

   imul    esi,12
   add	   esi,[triangles_ptr]
   mov	   ecx,3	    ; fix
 @@:
   mov	   eax,[esi]
   cmp	   eax,ebx
   cmove   eax,.counter
   mov	   [esi],eax
   add	   esi,4
   loop    @b
   add	   edi,8
   cmp	   [edi],ebx
   je	   .l1
   pop	   ecx
   mov	   ebx,ecx
   mov	   edx,ecx
   and	   ebx,111b
   shr	   edx,3
   push    edx
   add	   edx,.mask
   bts	   dword[edx],ebx
   pop	   edx
   add	   edx,.mask2
   bts	   dword[edx],ebx
   jmp	   .nx_b


if 0
 .rm_unu_vert:

; remove verts that was removed
  xor	  ecx,ecx
 .nx1:
  mov	  eax,ecx
  mov	  ebx,ecx
  shr	  ebx,3
  and	  eax,111b
  add	  ebx,.mask2
  bt	  dword[ebx],eax
  jc	  .rm

 .nx2:
  inc	  ecx
  cmp	  ecx,[points_count_var]
  jne	  .nx1

  jmp	  .done


 .rm:		; fix lists
  push	  ecx

  mov	  ebx,ecx
  inc	   ecx

  mov	  esi,ecx
  imul	  esi,12
  add	  esi,[points_r_ptr]
  lea	  edi,[esi-12]
 @@:
  movsd
  movsd
  movsd
  inc	  ecx
  cmp	  ecx,[points_count_var]
  jne	  @b

  mov	  esi,[triangles_ptr]
  mov	  ecx,[triangles_count_var]
  lea	  ecx,[ecx*3]
 .fixx:
  cmp	  [esi],ebx
  jng	  @f
  dec	  dword[esi]
  @@:
  add	  esi,4
  loop	  .fixx


  pop	  ecx
  dec	  [points_count_var]
  jmp	  .nx2
end if

 .rm_v: 		   ; fix

    mov    eax,[triangles_ptr]
    mov    ebx,[points_r_ptr]
    mov    ecx,[triangles_count_var]
    mov    edx,[points_count_var]
    call   remove_unused_vertices
    mov   [points_count_var],ecx

 .done:

  invoke   VirtualFree ,.mask2 ,0 , MEM_RELEASE
  invoke   VirtualFree ,.mask ,0 , MEM_RELEASE
  invoke   VirtualFree ,.tri_ch ,0 , MEM_RELEASE
  invoke   VirtualFree ,.t_ptr ,0 , MEM_RELEASE

  cls	   ;macro
  add	   esp,80
  pop	   ebp
ret


;===========================================================================
draw_triangulize_rect:
    ;at 1st clear teslate area buff
    xor    eax,eax	    ; clear
    mov    edi,[edit_tri_area_ptr]
    movzx  ebx,[xres_var]
    movzx  ecx,[yres_var]
    imul   ecx,ebx
    shr    ecx,4
    cld
    rep    stosd


    movups    xmm0,dqword[tri_area_x1]
    cvtps2dq  xmm0,xmm0
    shufps    xmm0,xmm0,11011000b
    packssdw  xmm0,xmm0
    movd      eax,xmm0
    psrldq    xmm0,4
    movd      ebx,xmm0

    movd      xmm1,[screen_ptr]
    pxor      xmm6,xmm6
   ;  movd     mm0,[Zbuffer_ptr]
    movzx     ecx,[xres_var]
    movd      xmm2,ecx
    mov       ecx,0x0000ff00
    movd      xmm3,ecx
    movd      xmm7,[xres_vard]
    punpcklwd xmm7,xmm6
    call      write_frame

    mov       ecx,1	    ; other const mark
    movlps    xmm0,qword[tri_area_x1]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area

    xor       ecx,ecx
    movlps    xmm0,qword[tri_area_x2]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area
ret

;============================================================
bar_tri_area:
 ;  ecx - signature - 0 / 1
 ;  xmm0 - coordinates
 ;  edx  - yresm4
 ;  esi  - xresm4

    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .add_tb   equ ebp-16
    .add      equ ebp-20

    push     edx
    push     esi
    push     ecx
    movzx    eax,[xres_var]
    sub      eax,6
;    shl      eax,2
    push     eax
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,5
    jle      .skip
    cmp      ebx,5
    jle      .skip
    cmp      ebx,dword[.yresm4]
    jge      .skip
    cmp      eax,dword[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    mov      eax,ebx
    shl      eax,2
    mov      edi,eax
    add      edi,[screen_ptr]
    and      dword[.ed],1b
  ;  draw bar 6x6
    mov      eax,6

 .oop_ed:
    push     eax
    mov      eax,6
  .oop1:
    push     ebx
    mov      ecx,ebx
    shr      ebx,2
    and      ecx,11b
    add      ebx,[edit_tri_area_ptr]
    mov      dword[edi],0x00ffff00
    add      ecx,ecx
    inc      ecx
    cmp      dword[.ed],0
    jne      @f
    bts      [ebx],ecx
    jmp      .f
  @@:
    inc      ecx
    bts      [ebx],ecx
  .f:
    pop      ebx
    add      ebx,1
    add      edi,4
    dec      eax
    jnz      .oop1
    add      edi,[.add]
    add      ebx,[.add_tb]
    pop      eax
    dec      eax
    jnz     .oop_ed
  .skip:
   mov	     esp,ebp
   pop	     ebp
ret
;==========================================================

calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
  
 push	ebp

 movups xmm1,[plane_equation]
 movaps xmm7,xmm1
 movups xmm0,[esi]
 andps	xmm0,[zero_hgst]
 orps	xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps	xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
 movaps xmm3,xmm7 ;[plane_equation]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx],xmm3
 addss	xmm3,xmm4
 movss	[ebx],xmm3

 movaps xmm3,xmm7 ;[plane_equation+4]
 shufps xmm3,xmm3,01010101b
 mulps	xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss	xmm3,xmm4
 movss	[ebx+20],xmm3

 movaps xmm3,xmm7  ;[plane_equation+8]
 shufps xmm3,xmm3,10101010b
 mulps	xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss	xmm3,xmm4
 movss	[ebx+40],xmm3

 movaps  xmm3,xmm7  ;[plane_equation+12]
 shufps xmm3,xmm3,11111111b
 mulps	xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss	xmm3,xmm4
 movss	[ebx+60],xmm3	   ; finaly matrix don
 pop	ebp
ret
;=================================================================
xy_in_rect:

 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes
  movd	   xmm0,eax
  movd	   xmm1,ecx
  movd	   xmm2,edx
  pcmpgtw  xmm1,xmm0
  pcmpgtw  xmm2,xmm0
  pxor	   xmm2,xmm1
  pmovmskb ebx,xmm2
  cmp	   ebx,1111b
  jne	  .end_no
  mov	  ebx,1
  ret
 .end_no:
  xor	  ebx,ebx
ret


;===========================================================
move_texture:
 ;  eax - move x
 ;  ebx - move y
    push ebp

    .x_tex   equ  [ebp-6]
    .y_tex   equ  [ebp-4]

    mov   ebp,esp
    sub   esp,10
    mov   .x_tex,ax
    mov   .y_tex,bx
    cmp   ebx,0
    je	  .xx
    jl	  .ysub

    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
    cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
    rep   movsd
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
    std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  @@:
    rep   movsd
  .xx:
    cmp   word .x_tex,0
    je	  .end
    jl	  .xadd
    movzx eax,word .x_tex
    lea   edx,[eax*4]
    cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
    cld
    rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x_tex
    neg   eax

    lea   edx,[eax*4]
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
 .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
    std
    rep   movsd
    sub   esi,edx
    sub   edi,edx
    inc   ebx
    cmp   ebx,TEX_Y
    jne   .nextxadd_l;@b

  .end:
   mov	  esp,ebp
   pop	 ebp
ret
;=====================================================

apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
.fact	   equ [ebp-16]

	push  ebp
	mov   ebp,esp
	sub   esp,16

	cvtsi2ss xmm5,[displac_div]
	rcpss	 xmm5,xmm5
	movss	 .fact,xmm5

	prompt prompt_displ
	xor    ecx,ecx
      .next_vert:
	push   ecx			; ecx - vertex counter
	mov    ebx,ecx
	imul   ebx,12
	mov    edi,ebx
	add    edi,[points_normals_rotated_ptr]
	add    ebx,[points_r_ptr]
	movups xmm0,[ebx]
	mov    .vert1_ptr,ebx

	mov    esi,ecx
	mov    eax,ecx
	shl    eax,2
	add    eax,[tex_points_ptr]
	mov    ecx,eax
	movzx  eax,word[eax+2] ; tex y
	mov    edx,TEX_X
	mul    edx
	movzx  ecx,word[ecx]   ; tex x
	add    ecx,eax
	shl    ecx,2
	add    ecx,texmap
	mov    eax,ecx
	mov    ecx,[ecx]
	and    ecx,0x00ffffff
	cmp    ecx,[displ_transparent_col]  ;0x00ffffff
	je     .no  ; no change if transparent - white color
	cmp    [td_wp_flag],0  ; only vertices with positive normal z
			       ; cooficient are computed or all vertices ?
	jz     .whole
	test   dword[edi+8],0x80000000	 ; check sign of z coof
	jz     .no
      .whole:
	movzx  ecx,byte[eax]   ; read R,G,B pixel
	movzx  ebx,byte[eax+1]
	add    ecx,ebx
	movzx  ebx,byte[eax+2]
	add    ecx,ebx



	mov    eax,esi
	imul   eax,12
	add    eax,[points_normals_ptr]
	movups xmm7,[eax]
	cvtsi2ss xmm6,ecx

	mulss	xmm6,.fact
	shufps	xmm6,xmm6,0

	mulps	xmm7,xmm6
	addps	xmm0,xmm7
	mov	ebx,.vert1_ptr
	movlps	[ebx],xmm0
	movhlps xmm0,xmm0
	movss	[ebx+8],xmm0
      .no:

	pop    ecx
	inc    ecx
	cmp    ecx,[points_count_var]
	jnz    .next_vert

	cls
	mov    esp,ebp
	pop    ebp

ret


;===========================================================

load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
  @@:
    movzx eax,word[esi]
    mov   [edi],eax
    add   esi,2
    add   edi,4
    loop  @b


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count
ret

;================================================================
blur_screen:
;blur n times  ; blur or fire
;in - ecx  times count

.counter1 equ dword[esp-8]

	 push	    ebp
	 mov	    ebp,esp
	 movaps     xmm5,[blur_sub]
     .again_blur:
	 push	    ecx
	 mov	    edi,[screen_ptr]
	 movzx	    ecx,[xres_var]  ;SIZE_X
	 xor	    eax,eax
	 rep	    stosd
	 movzx	    ecx,[xres_var]  ;SIZE_X
	 movzx	    ebx,[yres_var]  ;SIZE_X
	 sub	    ebx,4
	 imul	    ecx,ebx
	 shr	    ecx,2
	 movzx	    ebx,[xres_var]  ;SIZE_X
	 mov	    esi,edi
	 mov	    edx,ebx
	 shl	    edx,2
	 sub	    esi,edx
     .blr:
     @@:
	 movaps     xmm0,[edi+ebx*4]
	 movaps     xmm2,[edi-16]

	 pavgb	    xmm0,[esi]
	 pavgb	    xmm2,[edi+16]
	 pavgb	    xmm0,xmm2

	 psubusb    xmm0,xmm5  ; importand if fire

	 movaps     [edi],xmm0
	 add	    edi,16
	 add	    esi,16

	 loop	    .blr

	 xor	    eax,eax
	 movzx	    ecx,[xres_var] ;SIZE_X
	 rep	    stosd
	 pop	    ecx
	 loop	    .again_blur
	 mov	    esp,ebp
	 pop	    ebp
ret
;===========================================================
normalize_object1:  ; procedure don't save registers !!
; do mesh coords in from -1.0 to 1.0
; in:	stack 1 - vertices count to normalise
;	stack 2 - pointer to vertices
; out:	xmm7 - broadcasted reciprocal of maxscale
;	xmm0 - center

	.points_count equ ebp+8
	.points_r     equ ebp+12

	push	      ebp
	mov	      ebp,esp

       .max_scale    equ xmm6

       mov    ebp,esp
       mov    ecx,[.points_count]
       dec    ecx
       mov    edi,[.points_r]

       movups  xmm0,[edi]
       movups  xmm2,[edi]
     @@:
       movups  xmm1,[edi+12]
       maxps   xmm0,xmm1
       minps   xmm2,xmm1
       add     edi,12
       loop    @b
       movaps  xmm3,xmm0   ; scale
       subps   xmm0,xmm2
       divps   xmm0,[f2x4]
       subps   xmm3,xmm0   ; xmm3 - this we sub from all

       movaps  xmm4,xmm0
       movaps  xmm5,xmm0
       shufps  xmm4,xmm4,11100001b
       shufps  xmm5,xmm5,11000110b
       maxss   xmm4,xmm0
       maxss   xmm4,xmm5    ; xmm4 - max scale
       movss   .max_scale,xmm4
       shufps  xmm4,xmm4,0
       rcpps   xmm4,xmm4

       mov     ecx,[.points_count]
       mov     edi,[.points_r]
     @@:
       movups  xmm0,[edi]
       subps   xmm0,xmm3    ; set 0,0,0 in center
       mulps   xmm0,xmm4    ; scale
       movhlps xmm1,xmm0
       movlps  [edi],xmm0
       movss   [edi+8],xmm1
       add     edi,12
       loop    @b

       movaps  xmm7,xmm4
       movaps  xmm0,xmm3

       mov    esp,ebp
       pop    ebp

ret 8
;=========================================================
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret
;================================================================
generate_texture3:

       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax

       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
ret
;=============================================================
generate_texture2:
.const equ 32
	cld
	mov	edi,texmap
	xor	bx,bx
     .next_line:
	xor	dx,dx
     .next2stripes:
	mov	eax,-1
	mov	ecx,(TEX_X/.const)
	rep	stosd
	mov	eax,0x00ff0000
	mov	ecx,(TEX_X/.const)
     @@:
	stosd
	loop	@b
	inc	dx
	cmp	dx,.const/2
	jl	.next2stripes
	inc	bx
	cmp	bx,TEX_Y
	jl	.next_line
ret



;============================================================

calc_bumpmap_coords:	  ; map texture, bump
; in  = eax - scale as dword
      push  ebp
      mov   ebp,esp

      push  eax

      .sc     equ	[ebp-4]
      .off1   equ dword [ebp-8]
      .off2   equ dword [ebp-12]
      .point_rot    equ [ebp-30]

      fninit

      fldpi
      fadd	st,st
      mov	esi,[points_r_ptr]
      mov	edi,[tex_points_ptr]
      mov	edx,[tex_points_f_ptr]
      mov	ecx,[points_count_var]


      cmp	[map_flag],2
      jg	.spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
      mov      eax,8
      mov      ebx,4
   .do_planar:
      push	eax
      push	ebx
      sub	esp,50
      movups	xmm1,[tex_x_div2f]
      movups	xmm2,.sc
      mulps	xmm1,xmm2
      movdqu	xmm3,[tex_x_div2]
      shufps	xmm1,xmm1,0
      pshufd	xmm3,xmm3,0
      cvtdq2ps	xmm3,xmm3

   .do:
      mov	eax,.off1
      mov	ebx,.off2
      movlps	xmm0,[esi+eax]
      movhps	xmm0,[esi+ebx]
      mulps	xmm0,xmm1
      addps	xmm0,xmm3
      shufps	xmm0,xmm0,11111000b
      movlps	[edx],xmm0
      cvtps2dq	xmm0,xmm0
      packssdw	xmm0,xmm0
      movd	[edi],xmm0
      add      esi,12
      add      edi,4
      add      edx,8
      loop     .do  ;.do_planar

      jmp	.end

   .spherical:
;
;      cmp	[map_flag],3
;      jne	@f
;      xor	eax,eax
;      mov	ebx,4
;      jmp	.do_sp
;  @@:
;      cmp	[map_flag],4
;      jne	@f
;      mov	eax,4
;      mov	ebx,8
;      jmp	.do_sp
;  @@:
;;	cmp	 [map_flag],3
;;	jne	 @f
;      mov	eax,8
;      mov	ebx,0
;      ; spherical mapping around y axle

      fninit
      fldpi
      fadd	st,st
   @@:
      fld	dword[esi]     ; x coord
      fld	dword[esi+8]   ; z coord
      fpatan		       ; arctg(st1/st)
      fdiv	st0,st1
      fimul	dword [tex_x_div2]
  ;    fmul	 dword .sc
      fiadd	dword [tex_x_div2]
      fst	dword[edx]
      fistp	word[edi]      ; x

      fld	dword[esi+4]   ; y coord
      fld	dword[esi]     ; x
      fmul	st,st0
      fld	dword[esi+4]   ; y
      fmul	st,st0
      fld	dword[esi+8]   ; z
      fmul	st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
   ;   fmul	dword .sc
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fst      dword[edx+4] 
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      add      edx,8
      loop     @b
   .end:
      ffree    st0

    mov        esp,ebp
    pop  ebp

ret

;================================================================
calc_bumpmap:		 ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

	 pushad

	 mov	 edi, bump_map
	 mov	 esi,texmap
	 mov	 ecx,TEXTURE_SIZE
	 cmp	 [bump_flag],0
	 je	 .random_bump_map
	 ; else bumps according to texture
      @@:
	 movzx	 ax,byte[esi]
	 movzx	 bx,byte[esi+1]
	 movzx	 dx,byte[esi+2]
	 add	 ax,bx
	 add	 ax,dx
	 cwde
	 cdq
	 div	 [i3]
	 stosb
	 add	 esi,4
	 loop	 @b
	 jmp	 .blur_map

  .random_bump_map:

      @@:
	 push	 ecx
	 xor	 ecx,ecx
	 mov	 edx,255
	 call	 random
	 stosb
	 pop	ecx
	 loop	@b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
	 mov	edi, bump_map
	 mov	ecx,4
      .blur:
	 xor	esi,esi
	 mov	edx,TEXTURE_SIZE
	 xor	eax,eax
	 xor	ebx,ebx
      @@:
	 mov	ebp,esi
	 dec	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	al,byte[ebp+edi]

	 mov	ebp,esi
	 inc	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 sub	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 add	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 shr	eax,2
	 mov	byte[esi+edi],al

	 inc	esi
	 dec	edx
	 jnz	@b

	 loop	.blur

	 popad
ret

;================================================================
make_random_lights:
  .temp1  equ [ebp-4]
  .temp2  equ [ebp-8]	  ;  - light vector generate variables
  .temp3  equ [ebp-12]
  .col1   equ ebp-20
  .col2   equ ebp-28
  .col3   equ ebp-32

  .max	equ 800
  .max1 equ 1000

	push	  ebp
	mov	  ebp,esp
	sub	  esp,32

	mov	  edi,lights

	mov	  .temp1 , dword 1000.0
	mov	  dword .temp2,800.0
	mov	  dword .temp3,400.0
	rcpss	  xmm3,.temp3
	rcpss	  xmm2,.temp2

    .again:
	xor	 esi,esi
     @@:
	mov	 edx,.max
	xor	 ecx,ecx
	call	 random
	sub	 eax,.max/2
	cvtsi2ss xmm1,eax
	mulss	 xmm1,xmm3
	movss	 [edi+esi*4],xmm1
	inc	 esi
	cmp	 esi,3
	jne	 @b

	mov	  edx,.max1
	xor	  ecx,ecx
	call	  random
	cvtsi2ss  xmm4,eax
	xorps	  xmm4,[sign_mask]
	mulss	  xmm4,xmm2
	movss	  [edi+8],xmm4
	xor	esi,esi
     @@:
	mov	ecx,220 	   ; max colors and shine  ,
				   ; ecx = 200 - more bright shading
	mov	edx,255
	call	random
	movzx	ax,al
	mov	[edi+28+esi*2],ax
	inc	esi
	cmp	esi,4
	jne	@b


	xor	esi,esi
     @@:
	mov	ecx,100 	     ; orginal colors
	movzx	edx,word[edi+28+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+12+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	xor	esi,esi
     @@:
	mov	ecx,1		    ; min cols
	movzx	edx,word[edi+12+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+20+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	add	edi,LIGHT_SIZE ;22
	cmp	edi,lightsend
	jne	.again



	mov	  esi,lights
	mov	  edi,lights_aligned

	xorps	  xmm5,xmm5
	movaps	  xmm6,[zero_hgst]
	movaps	  xmm7,[z_minus_mask]
     .do_aligned: ; make aligned float lights used
		  ; in all Real Phong rendering models
	movups	  xmm0,[esi]
	orps	  xmm0,xmm7   ;[z_minus_mask]
	movaps	  xmm1,xmm0   ; normalize
	mulps	  xmm1,xmm1
	andps	  xmm1,xmm6   ;[zero_hgst_dd]
	haddps	  xmm1,xmm1
	haddps	  xmm1,xmm1
	rsqrtps   xmm1,xmm1
	mulps	  xmm0,xmm1

	movq	  xmm1,[esi+12]
	movq	  xmm2,[esi+12+8]
	movq	  xmm3,[esi+12+16]

	punpcklwd xmm1,xmm5
	punpcklwd xmm2,xmm5
	punpcklwd xmm3,xmm5
	psrld	  xmm1,1
	psrld	  xmm2,1

	andps	  xmm0,xmm6
	cvtdq2ps  xmm1,xmm1
	cvtdq2ps  xmm2,xmm2
	cvtdq2ps  xmm3,xmm3
	andps	  xmm1,xmm6
	andps	  xmm2,xmm6
	andps	  xmm3,xmm6

	movaps	  [edi],xmm0
	movaps	  [edi+16],xmm1
	movaps	  [edi+32],xmm2
	movaps	  [edi+48],xmm3

	add	  edi,64
	add	  esi,LIGHT_SIZE
	cmp	  esi,lightsend
	jne	  .do_aligned

	mov	esp,ebp
	pop	ebp
ret

;=======================================================
init_point_lights:
	mov	  eax,-1000
	cvtsi2ss  xmm1,eax
	shufps	  xmm1,xmm1,11000000b
	mov	  esi,lights_aligned
	mov	  edi,ppoint_light_coords
	mov	  ecx,3
      @@:
	movaps	  xmm0,[esi]
	addps	  xmm0,[f05x3]
	mulps	  xmm0,xmm1
	addps	  xmm0,xmm1
	movaps	  [edi],xmm0
	add	  esi,64
	add	  edi,16
	loop	  @b
ret
;=============================================================
random:
;  in  - ecx - min
;	 edx - max
;  out - eax - random number
	 mov	bx,[rand_seed]
	 add	bx,0x9248
	 ror	bx,3
	 mov	[rand_seed],bx

	 mov	ax,dx
	 sub	ax,cx
	 mul	bx
	 mov	ax,dx
	 add	ax,cx
	 cwde
ret

;=================================================================
do_color_buffer:	 ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes	; many lights using
.temp  equ dword  [ebp-22]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]
.xx   equ     [ebp-26]
.yy   equ     [ebp-30]
.zz   equ     [ebp-34]
;.colf equ     [ebp-50]

	 push	   ebp
	 mov	   ebp,esp
	 sub	   esp,40
	 mov	   edi,color_map

	 cvtpi2ps xmm3,[tex_x_div2]
	 rcpps	  xmm3,xmm3
	 pshufd   xmm3,xmm3,11100001b
	 movlps   .yy,xmm3

	 mov	   edx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
	 mov	   ecx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:

	 cvtsi2ss  xmm1,ecx
	 cvtsi2ss  xmm2,edx
	 mulss	   xmm1,.yy
	 mulss	   xmm2,.xx
	 movss	   .ny,xmm1
	 movss	   .nx,xmm2
	 mulss	   xmm1,xmm1
	 mulss	   xmm2,xmm2
	 addss	   xmm2,xmm1
	 subss	   xmm2,[the_one]
	 andps	   xmm2,[abs_mask]
	 sqrtss    xmm2,xmm2
	 xorps	   xmm2,[sign_mask]
	 movss	  .nz,xmm2
	 xor	  ebx,ebx
	 mov	  dword .col_b, ebx

     .light:
	 push	  edi	;env_map
	 lea	  esi,[lights+ebx]
	 lea	  edi,.nx
	 call	  dot_product1
	 ; out xmm0 - dot
	 pop	  edi
	 movaps   xmm1,xmm0
	 movaps   xmm2,xmm0
	 cmpnltss xmm1,dword[dot_min]
	 cmpnltss xmm2,dword[dot_max]
	 xorps	  xmm2,xmm1
	 movd	  eax,xmm2
	 or	  eax,eax
	 jz	  .update_counters  ;.env_ok2

      .env_ok2:
;	       [esi+36]   ; -  shines

	 movq	  xmm4,[esi+20]  ;.min_col_r
	 movq	  xmm1,[esi+28]  ;.max_col_r
	 movq	  xmm2,[esi+12]  ;.org_col_r

	 call	  calc_one_col

	      ; eax-0x00rrggbb
	 movd	  xmm0,eax
	 movd	  xmm1,.col_b
	 pmaxub   xmm1,xmm0
	 movd	  .col_b,xmm1

 .update_counters:				    ; update and jump when neccesery

	add	ebx,LIGHT_SIZE
	cmp	bx,[all_lights_size]
	jl	.light	  ; next_light
	mov	 eax,.col_b
	or	 eax,0xff000000
	stosd

	inc	ecx
	cmp	ecx,TEX_X / 2
	jne	.ie_hor

	inc	edx
	cmp	edx,TEX_Y / 2
	jne	.ie_ver

    .env_done:
	 mov	 esp,ebp
	 pop	 ebp
ret

;============================================================
init_envmap2:	      ; do env_map

;env_map 512 x 512 x 4 bytes

.col_r equ	  [ebp-8]
.col_g equ	  [ebp-9]
.col_b equ	  [ebp-10]
.yy    equ	  [ebp-18]
.xx    equ	  [ebp-22]
.cxxx  equ	  [ebp-26]
.dxxx  equ	  [ebp-30]


	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,34

	 mov	  edi,envmap
	 cvtpi2ps xmm3,[tex_x_div2]
	 movlps   .xx,xmm3

	 mov	  edx,- TEX_Y / 2 ;256	 ; dx - vertical coordinate = y
    .ie_ver:
	 push	  edx
	 mov	  ecx,- TEX_X / 2 ;256	 ; cx - horizontal coord = x
    .ie_hor:
	 push	  ecx
	 xor	  ebx,ebx
	 mov	  dword .col_b,ebx

     .light:
	 push	  ebx
	 lea	  esi,[lights+ebx]
	 mov	  .cxxx,edx
	 mov	  .dxxx,ecx
	 movlps   xmm0,[esi]
	 movlps   xmm2,.xx
	 cvtpi2ps xmm3,.dxxx
	 mulps	  xmm0,xmm2
	 subps	  xmm3,xmm0

	 mulps	  xmm3,xmm3
	 haddps   xmm3,xmm3
	 movss	  xmm0,[f255d]
	 sqrtss   xmm3,xmm3
	 rcpss	  xmm5,xmm0
	 subss	  xmm0,xmm3

	 mulss	  xmm0,[env_const]
	 mulss	  xmm0,xmm5
	 xorps	  xmm1,xmm1
	 maxss	  xmm0,xmm1
	 minss	  xmm0,[the_one]

;	 push	  word[esi+36]	 ; -  shines

	 movq	  xmm4,[esi+20]  ;.min_col_r
	 movq	  xmm1,[esi+28]  ;.max_col_r
	 movq	  xmm2,[esi+12]  ;.org_col_r
	 call	   calc_one_col

	 movd	  xmm0,eax
	 movd	  xmm1,.col_b
	 pmaxub   xmm1,xmm0
	 movd	  .col_b,xmm1

   .update_counters:			 ; update and jump when neccesery
	 pop	  ebx
	 add	  ebx,LIGHT_SIZE
	 cmp	  bx,[all_lights_size]
	 jl	  .light    ; next_light

	 mov	  eax,.col_b
	 or	  eax,0xff000000
	 stosd
	 pop	  ecx
	 inc	  ecx
	 cmp	  ecx,TEX_X / 2 ;256
	 jne	  .ie_hor
	 pop	  edx
	 inc	  edx
	 cmp	  edx,TEX_Y / 2 ;256
	 jne	 .ie_ver

	 mov	 esp,ebp
	 pop	 ebp
ret

;=========================================================
 calc_one_col:

; procedure don't save registers !!!
; in -	 xmm0	- dot_product
;	 xmm4, - .min_col bgr  - words	    ; minimum color - ambient
;	 xmm1, - .max_col bgr		    ; maximum color - specular
;	 xmm2, - .org_col bgr		    ; orginal color - diffuse

					    ; shines - not implemented
 ; out -  eax - 0x00rrggbb

; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular

	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,18

	 movaps   xmm5,xmm4
	 paddw	  xmm4,xmm1
	 paddw	  xmm4,xmm2


	 shufps   xmm0,xmm0,0
	 movaps   xmm7,xmm0
	 mulps	  xmm0,xmm0
	 xorps	  xmm3,xmm3
	 mulps	  xmm0,xmm0
	 mulps	  xmm0,xmm0
	 mulps	  xmm0,xmm0

	 punpcklwd xmm5,xmm3	 ; min
	 punpcklwd xmm1,xmm3	 ; max
	 punpcklwd xmm2,xmm3	 ; org
	 punpcklwd xmm4,xmm3	 ; sum

	 cvtdq2ps  xmm5,xmm5
	 cvtdq2ps  xmm1,xmm1
	 cvtdq2ps  xmm2,xmm2
	 cvtdq2ps  xmm4,xmm4

	 movaps    xmm6,xmm1
	 mulps	   xmm1,xmm0  ; max * dot^n
	 mulps	   xmm2,xmm7  ; org * dot

	 addps	   xmm1,xmm2
	 rcpps	   xmm4,xmm4
	 addps	   xmm1,xmm5  ; + min
	 mulps	   xmm1,xmm6  ; * max
	 mulps	   xmm1,xmm4 ; / sum
	 cvtps2dq  xmm1,xmm1
	 packssdw  xmm1,xmm1
	 packuswb  xmm1,xmm1
	 movd	   eax,xmm1

	 mov	 esp,ebp
	 pop	 ebp

ret
