
;====================================================================



mirror_chunk:
; in : eax - chunk no to mirror


  push	 ebp
  mov	 ebp,esp

  .cur_ch     equ dword[ebp-4]
  .pcv	      equ dword[ebp-8]
  .tri_in_ch  equ dword[ebp-12]
  .tri_offset equ dword[ebp-16]

  .new_ptsI2  equ dword[ebp-20]
  .new_ptsI   equ dword[ebp-24]
  .vert_cnt   equ dword[ebp-28]
  .new_vert   equ dword[ebp-32]
  .new_tris   equ dword[ebp-36]
  .mxx	      equ [ebp-80]

  push	eax	   ; cur ch
  push	[points_count_var]

  mov	esi,[chunks_ptr]
  mov	ecx,[triangles_count_var]
  cld
  xor	edx,edx
  xchg	ebx,eax
 .lab1:
  lodsw
  cmp	bx,ax
  je	@f
  loop	.lab1
 @@:
  inc	edx
  mov	edi,esi
  sub	edi,[chunks_ptr]

 .lab2:
  lodsw
  cmp	bx,ax
  je	@f
  loop	.lab2
  jmp	.en1
 @@:
  inc	edx
  loop	.lab2

  .en1:


if 0

 ; push   ecx	    ; tcv
  xor	 edx,edx
  cld
  int3
  repne  scasw
;  sub	  edi,2
  mov	 ebx,edi   ; ebx - offset
  sub	 ebx,2
  sub	 ebx,[chunks_ptr]
  inc	 edx
  jecxz  .ff1	   ; at least one tri in ch


 @@:
  repne scasw
  inc	edx
 ; sub	 edi,2
  or	ecx,ecx
  jnz	@b

end if

  push	 edx	 ; tri in ch
  inc	 edx

;  (edi-2)/2 - tris cnt to skip

  sub	 edi,2
  add	 edi,edi
  lea	 edi,[edi*3]
  add	 edi,[triangles_ptr]

  push	 edi	    ;  ebx - triangles offset in triangles list

  mov	 ebx,edx ;ecx
  imul	 ebx,12     ;  ebx - max vertices (size in mem) used in current chunk
  add	 ebx,200

  malloc ebx	    ; vert index1
  push	 eax
  malloc ebx
  push	 eax	    ; vert index2

  cld
  mov	 ecx,.tri_in_ch
  mov	 esi,.tri_offset
  mov	 edi,.new_ptsI2
  lea	 ecx,[ecx*3]
  push	 ecx
  rep	 movsd


   mov	    esi,.new_ptsI2
   mov	    edi,.new_ptsI
   pop	    ecx
   call     sort_hybrid_dd

 ;  dbg_ptr .new_ptsI
 ;  dbg_ptr .new_ptsI2


   ; calc distinc verts count in cur chun
   mov	    esi,.new_ptsI2
   mov	    edi,.new_ptsI
   mov	    ecx,.tri_in_ch
   lea	    ecx,[ecx*3]
   xor	    edx,edx
   mov	    edx,1
   cld
  .bb1a:
   lodsd
   mov	    ebx,[esi]
   cmp	    ebx,eax
   jne	    @f
   loop     .bb1a
   jmp	    .fin1a
  @@:
   stosd
   inc	    edx
   loop     .bb1a

 .fin1a:
 ;  inc      edx
   or	    eax,-1
   stosd    ; end mark
   push     edx

 ;  edx - uniqe verts count in chunk
 ; .new_ptsI - sorted uniqe verts

    add      edx,.pcv  ;[points_count_var]
    imul     edx,12
    add      edx,128
    malloc   edx
    push     eax   ;new verts  whole list


 ;   dbg_ptr .new_ptsI
 ;   dbg_ptr .new_ptsI2


	cvtdq2ps xmm3,[xxadd]
	andps	 xmm3,[zero_hgst]
	mov	 esi,[points_rotated_ptr]
	mov	 edi,eax
	mov	 ecx,.pcv  ;[points_count_var]
     @@:
	movups	 xmm0,[esi]
	subps	 xmm0,xmm3
	movups	 [edi],xmm0
	add	 esi,12
	add	 edi,12
	loop	 @b

   cld
   ;compute new tri list, fill new verts list with new positions
   mov	  eax,1 shl 31
   movd   xmm2,eax	; x axis related mirror
			; it easy posible do y and z
;   pshufd xmm2,xmm2,11110011b

   mov	  esi,.tri_offset  ;.new_ptsI ;.tri_in_ch
   mov	  ecx,.tri_in_ch
   lea	  ecx,[ecx*3]
   mov	  edi,.new_ptsI2
  .bbc:
   push   ecx
   lodsd
   cmp	  eax,.pcv  ;[points_count_var]
   jnbe   .nxc
   push   edi
   mov	  edx,eax
   imul   edx,12
   add	  edx,.new_vert    ; [points_rotated_ptr]
   movups xmm0,[edx]
   xorps  xmm0,xmm2	   ; negate x cooef
   mov	  edi,.new_ptsI
   or	  ecx,-1	   ;.vert_cnt  ;.tri_in_ch  ;  -1
   repne  scasd

;     int3
;     mov     eax,edi
;     sub     eax,4
;     dbg_ptr eax  ;.new_ptsI
;     dbg_ptr .new_ptsI
;     sub    edi,4

   sub	  edi,.new_ptsI
   shr	  edi,2
   dec	  edi
   mov	  eax,edi
   pop	  edi
   add	  eax,.pcv  ;[points_count_var]
   mov	  edx,eax
   imul   edx,12
   add	  edx,.new_vert
   movlps [edx],xmm0	; new vertex in new_vert lst
   movhlps xmm0,xmm0
   movss  [edx+8],xmm0
   stosd	; new vert index in .new_ptsI2 list
  .nxc:
   pop	  ecx
;   dec    ecx
;   jnz    .bbc
   loop   .bbc

;   dbg_ptr .new_ptsI
;   dbg_ptr .new_ptsI2

    ; new_ptsI2 - new chunk triangles
    invoke  VirtualFree, .new_ptsI , 0,  MEM_RELEASE

    mov     ebx,.tri_in_ch
    add     ebx,[triangles_count_var]

    imul    ebx,12
    add     ebx,120
    malloc  ebx
    push    eax   ; new_tris - whole list of triangles

    cld
    mov     edi,eax
    mov     ecx,[triangles_count_var]
    mov     esi,[triangles_ptr]
    lea     ecx,[ecx*3]
    rep     movsd

    mov     esi,.new_ptsI2
    mov     ecx,.tri_in_ch
    lea     ecx,[ecx*3]
    rep     movsd

    invoke  VirtualFree, .new_ptsI2 , 0,  MEM_RELEASE
    invoke  VirtualFree, [points_r_ptr] , 0,  MEM_RELEASE
    invoke  VirtualFree, [triangles_ptr] , 0,  MEM_RELEASE

    mov     eax,.tri_in_ch
    mov     ebx,.vert_cnt
    add     [triangles_count_var],eax
    add     [points_count_var],ebx
    push    .new_tris
    pop     [triangles_ptr]

	sub	 esp,60
	mov	 esi,matrix   ;_scaled
	lea	 edi,.mxx
	call	 reverse_mx_3x3

	mov	 esi,.new_vert
	mov	 edi,.new_vert
	mov	 ecx,[points_count_var]
	lea	 ebx,.mxx
	call	 rotary

	push	 .new_vert
	pop	 [points_r_ptr]

    mov     esp,ebp
    pop     ebp

ret

;====================================================================================

make_series:
;  clone/copy current  object
    push	ebp
    mov 	ebp,esp

    .pots_ptr	equ [ebp-4]
    .tris_ptr	equ [ebp-8]

    mov 	ebx,[points_count_var]
    lea 	ebx,[ebx*3]
    shl 	ebx,3
    add 	ebx,1000
    malloc	ebx
    push	eax

    mov 	ebx,[triangles_count_var]
    lea 	ebx,[ebx*3]
    shl 	ebx,3
    add 	ebx,1000
    malloc	ebx
    push	eax

    mov 	edi,eax
    mov 	esi,[triangles_ptr]
    mov 	ecx,[triangles_count_var]
    lea 	ecx,[ecx*3]

    push	ecx
    push	esi
    cld
    rep 	movsd

    pop 	esi
    pop 	ecx

    mov 	edx,[points_count_var]	  ; make tris copy
   @@:
    lodsd
    add 	eax,edx
    stosd
    loop	@b


    movzx	ebx,[tolerancy_flag]
    cvtsi2ss	xmm6,ebx
    mulss	xmm6,[scale]
    mov 	eax,0.3
    movd	xmm7,eax
    mulss	xmm7,xmm6
    mov 	ecx,[points_count_var]
    push	ecx

    lea 	ecx,[ecx*3]
    mov 	esi,[points_rotated_ptr]
    push	esi


    mov 	edi,.pots_ptr
    rep 	movsd
    pop 	esi
    pop 	ecx
  @@:
    lodsd
    movd	xmm0,eax
    addps	xmm0,xmm7
    movd	eax,xmm0
    stosd
    movsd
    movsd
    loop	@b

    invoke	VirtualFree, [points_r_ptr] , 0,  MEM_RELEASE
    invoke	VirtualFree, [triangles_ptr] , 0,  MEM_RELEASE

    mov 	eax,[points_count_var]
    add 	eax,eax
    mov 	[points_count_var],eax

    mov 	eax,[triangles_count_var]
    add 	eax,eax
    mov 	[triangles_count_var],eax

    mov 	ebx,.pots_ptr
    mov 	edx,.tris_ptr
    mov 	[points_r_ptr],ebx
    mov 	[triangles_ptr],edx

    mov 	esp,ebp
    pop 	ebp
ret

;============================================================



calc_combo:
    push    ebp
    mov     ebp,esp
    ; Calc all parameters - only triangles list and points list are provided as input.
    ; In future I will use it instead preapare_object proc.  ???
    ; I want do some pre calculation (chunks, dead tri rem, normals bumps/texture
    ; calcs, 33 vert rem) quick and simply after all editing routines.
    ; Main goal is unify calculations and prevent bugs, wich causes variety of sub
    ; calculation options.
    .mem_sign equ dword [ebp-4]
    .tri_ch   equ [ebp-8]
    .t_ptr    equ [ebp-12]

    push     eax
  ;  cmp      eax,'memd'   ; free mem and realloc done
  ;  je       @f
    pushad
    call     remove_dead_tri
    popad
    mov      eax,33	  ; not free tri and vert
    call     free_mem_for_tp1
    ; chunks, remove dead tris, unused verts, calc normals for all
  @@:
    invoke   VirtualFree, [chunks_ptr] , 0,  MEM_RELEASE
    mov      eax,1	   ; export  tri_ch and t_ptr
    call     detect_chunks
    mov      [chunks_ptr],ebx
    mov      [chunks_count],ecx
   ;  esi - .tri_ch
   ;  edi - .t_ptr
    push     esi   ; init locals vars
    push     edi

 ;   cmp      .mem_sign,'memd'
 ;   je       @f
    xor      eax,eax ; not alloc for tri and vert
    call     alloc_mem_for_tp1
;  @@:
    push     ebp
    push     dword [points_r_ptr]
    push     [points_count_var]
    call     normalize_object1
    mov      ebx,100
    call     init_triangles_normals
    pop      ebp
    mov      edx,3  ;.edg    ; if edx = 3  use chunks lists to computation
    mov      esi,.tri_ch
    mov      edi,.t_ptr
    call     init_pt_norm_th
    push     ebp
    mov      eax,[tex_scale]
    call     calc_bumpmap_coords
    pop      ebp
    call     do_edges_list
  ;  mov      [edges_count],ecx
  ;  xor      eax,eax
  ;  call     detect_chunks
    call     sort_chunks
  ;  call     write_info
  ;  call     draw_menu

    mov      esp,ebp
    pop      ebp
ret

;========================================================================
if 0
aabb_inter:  ; axis aligned bounding box intersection
; in:
;	xmm0 - ray direction
;	xmm1 - ray origin
;	xmm2 - box min x,y,z
;	xmm3 - box max x,y,z
; out:
;	eax = 0 -> ray intersects box
;	eax = 0xffffff -> no intersection
      push    ebp
      mov     ebp,esp
      and     ebp,-16
      sub     esp,120

       .dir	equ [ebp-16]
       .dirz	equ [ebp-8]
       .origin	equ [ebp-32]
       .box_min equ [ebp-48]
       .box_max equ [ebp-64]

       .tmin	equ [ebp-80]
       .tymin	equ [ebp-76]
       .tzmin	equ [ebp-72]

       .tmax	equ [ebp-96]
       .tymax	equ [ebp-92]
       .tzmax	equ [ebp-88]


       rcpps   xmm7,xmm0
       movaps  .box_min,xmm2
       movaps  .box_max,xmm3
       movaps  .dir,xmm0
       movaps  .origin,xmm1
       movaps  xmm6,xmm2
       movaps  xmm5,xmm3
       subps   xmm6,xmm0
       subps   xmm5,xmm0
       mulps   xmm6,xmm7    ; xmm6 -  min
       mulps   xmm5,xmm7    ; xmm5  - max
       movaps  xmm0,xmm6
       minps   xmm6,xmm5
       maxps   xmm5,xmm0
       movaps  .tmin,xmm6
       movaps  .tmax,xmm5    ;	cmpnltss
       cmpnltss xmm6,.tymax  ;tmin > tymax ; 11 if grt
       cmpless	xmm5,.tymin  ;tmax <= tymin ; 11 if grt
       orps    xmm6,xmm5
;	movd	eax,xmm6
;	or	eax,eax
;	jnz	@f	      ; false

       movss   xmm0,.tmin
       movss   xmm1,.tmax
       maxss   xmm0,.tymin
       minss   xmm1,.tymax

       cmpnltss xmm0,.tzmax  ; tmin >  tzmax
       cmpless	xmm1,.tzmin  ; tmax <= tzmin
       orps    xmm0,xmm1
       orps    xmm0,xmm6
       movd    eax,xmm0

       add     esp,120
       pop     ebp
ret
end if

;==========================================================================

intersect_tri: ; Moeller-Trumbore method
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;	 xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...
      push    ebp
      mov     ebp,esp
      and     ebp,-16
      sub     esp,280
      sub     ebp,128	   ; make shorter locals adreses

       .dir    equ [ebp-16]
       .origin equ [ebp-32]
       .ta     equ [ebp-48]
       .tb     equ [ebp-64]
       .tc     equ [ebp-80]
       .tvec   equ [ebp-96]
       .pvec   equ [ebp-112]
       .qvec   equ [ebp-128]

       .e1     equ [ebp]
       .ift    equ dword[ebp+16]

       .invdet equ [ebp+20]
       .det    equ [ebp+24]
       .ed_l   equ [ebp+28]

       .u      equ [ebp+40]
       .v      equ [ebp+36]
       .t      equ [ebp+32]

       .e2     equ [ebp+48]

       .zero_hgst equ [ebp+64]

      movaps	xmm7,[zero_hgst]
      movaps   .dir,xmm0
      movaps   .origin,xmm1
      movaps   .ta,xmm2
      movaps   .tb,xmm3
      movaps   .tc,xmm4
      movaps	.zero_hgst,xmm7
      mov      .ift,eax
      movss    .ed_l,xmm6
      subps    xmm3,xmm2
      subps    xmm4,xmm2
      andps    xmm3,.zero_hgst
      andps    xmm4,.zero_hgst
      movaps   .e1,xmm3
      movaps   .e2,xmm4

      lea      esi,.dir
      lea      edi,.e2
      lea      ebx,.pvec
      call     cross_aligned

      movaps   xmm0,.e1
      mulps    xmm0,.pvec
 ;     andps	xmm0,[zero_hgst_dd]
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      movss    .det,xmm0
;      cmpnless xmm0,[eps]
;      movd	eax,xmm0
;      or	eax,eax
;      jz	@f
      comiss   xmm0,[eps]
      jl       @f

      rcpss    xmm0,.det
      movss    .invdet,xmm0

      movaps   xmm0,.origin
      subps    xmm0,.ta
      andps    xmm0,.zero_hgst
      movaps   .tvec,xmm0

      mulps    xmm0,.pvec
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      mulss    xmm0,.invdet
      movss    xmm1,xmm0
      movss    .u,xmm0
      cmpnless xmm1,[epsone]
      cmpnless xmm0,[epsminus]
      pxor     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f

      lea      esi,.tvec
      lea      edi,.e1
      lea      ebx,.qvec
      call     cross_aligned

      movaps   xmm0,.dir
      mulps    xmm0,.qvec
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      mulss    xmm0,.invdet
      movss    .v,xmm0
      movss    xmm1,xmm0
      addss    xmm1,.u
      cmpnless xmm1,[epsone]
      cmpnless xmm0,[epsminus]
      pxor     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f

      movaps   xmm1,.e2
      mulps    xmm1,.qvec
      haddps   xmm1,xmm1
      haddps   xmm1,xmm1
      mulss    xmm1,.invdet
      movss    .t,xmm1
   ;   cmpnless xmm1,[eps]
   ;   movmskps eax,xmm1
   ;   test	eax,1
   ;   jz	@f
      comiss   xmm1,[eps]
      jl       @f

      mov      eax,1
      cmp      .ift,0
      je       .end	  ; ok intersect occured, no edge cause

      movss    xmm0,.t	    ; else check with edge lenght

      cmpnless xmm0,[eps]
      cmpnless xmm1,.ed_l
      xorps    xmm0,xmm1
      movd     ebx,xmm0
      or       ebx,ebx
      jz       @f

      jmp      .end
   @@:
      xor      eax,eax
    .end:
      movaps   xmm0,.t
      add      esp,280
      pop      ebp
ret
;====================================================================
mark_colided_edges:
; Proc has function of smothing inside edges also.
;   if eax = 1,2 smooth inside edges chose method

   push    eax

   cmp	   eax,0
   jne	   @f
   prompt  prompt_det_coll_ed  ; macro
   jmp	   .f
  @@:
   prompt  prompt_smooth_in_ed
  .f:
   mov	   [thread_params+4],eax
   mov	   ebx,[points_count_var]
   add	   ebx,80
   imul    ebx,12
   malloc  ebx
;   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;   or	    eax,eax
;   jnz     @f
;   call    mem_error
;  @@:
   mov	   [thread_params],eax
   mov	   edi,eax
   mov	   ecx,[points_count_var]
   lea	   ecx,[ecx*3]
   mov	   eax,-1
   cld
   rep	   stosd


   mov	    eax,mark_colided_edges_th
   xor	    edx,edx
   mov	    ecx,-1
   call     call_thread1


     mov     esi,[thread_params]
     mov     edi,[points_r_ptr]
     cld
     mov     ecx,[points_count_var]
   .update:
     cmp     [esi],dword -1
     je      @f
     movsd
     movsd
     movsd
 ;    movlps  xmm0,[esi]
 ;    movss   xmm1,[esi+8]
 ;    movlps  [edi],xmm0
 ;    movss   [edi+8],xmm1
     loop   .update
     jmp    .en_u
   @@:
     add     esi,12
     add     edi,12
     loop    .update

   .en_u:

     pop    eax
     cmp    eax,1
     je     .skip_cnt  ; smooth ins edges cause

    mov    ecx,[edges_count]
    shr    ecx,3
    inc    ecx
    mov    esi,[edges_intersect_ptr]
    xor    ebx,ebx
   .pop_count:
    push   ecx
    xor    ecx,ecx
   @@:
    mov    eax,[esi]
    shr    eax,cl
    and    eax,1b
    add    ebx,eax
    inc    ecx
    cmp    ecx,8
    jne    @b
    inc    esi
    pop    ecx
    loop   .pop_count
    mov    [edges_coll_count],ebx

   .skip_cnt:
    invoke  VirtualFree ,dword[thread_params],0 , MEM_RELEASE

    cls   ; macro

ret

;==================================================================
mark_colided_edges_th:
;in: - some globals
;      dword[thread_params]   - ptr to modified vertices list
;      dword[thread_params+4] = 1 -> smooth ins ed, = 2 -> smooth ed
;			      inside vertices algo, otherwise mark
;			      collided edges
;      eax - thread No
;      [edges_intersect_ptr] - colided tri list, each tri as bit,
;      each colided edge marked as 1, otherwise -> 0
;      [inner_vert_ptr]- inside vertices mask list, each as bit, if set - outside

   push    ebp
   mov	   ebp,esp
   sub	   esp,300
   and	   ebp,-16

   .ed_coll_ptr equ dword[ebp-4]
   .tri_cnt	 equ dword[ebp-8]
   .msk1	 equ dword[ebp-12]
   .collEdCnt	equ dword[ebp-16]
   .p1t 	 equ [ebp-32]	 ; triangles coords (vertices)
   .p2t 	 equ [ebp-48]
   .p3t 	 equ [ebp-64]
   .vertEd1	 equ [ebp-80]
   .vertEd2	 equ [ebp-96]
   .indexEd1	 equ [ebp-112]
   .indexEd2	 equ [ebp-128]
   .vertEd1new	 equ [ebp-128-16]
   .th_No	 equ dword[ebp-152]
   .edStart	 equ [ebp-156]
   .edEnd	 equ [ebp-160]
   .ed_norm	 equ [ebp-176]
   .tri_norm	 equ [ebp-192]
   .smooth_ed	 equ [ebp-196]
   .EdLen	 equ [ebp-200]
;   .index_vert   equ [ebp-200]  ; ind of new vert (from triang edges)
;   .index_tri	  equ [ebp-204]  ; index of new tris (from triangulated ed)
   .value	 equ [ebp-240]
   .normEd	 equ [ebp-256]
   .vy		 equ [ebp-264]
   .vx		 equ [ebp-268]
   .t		 equ [ebp-272]
;   .ar_rev1	  equ ebp-272-24
;   .ar_rev2	  equ ebp-272-24*2
;   .mxx	  equ [ebp-272-24*2-36]


   mov	   eax,ebx
   mov	   edx,0.008889
   movd    xmm0,edx
   shufps  xmm0,xmm0,0
   movaps  .value,xmm0	  ; margin value


if 0
      ; calc reversed teslate area

   mov	    esi,matrix_scaled		 ; check if in tes area
   lea	    edi,[.mxx]			 ; only using indexes
   call     reverse_mx_3x3		 ; not reverse tes area
   cvtdq2ps xmm3,[xxadd]
   movlhps  xmm3,xmm3
   movaps   xmm0,[tri_area_x1]
   subps    xmm0,xmm3
   movlps   [.ar_rev1],xmm0
   movhps   [.ar_rev1+12],xmm0
   xor	    eax,eax
   mov	    [.ar_rev1+8],eax	; zero 'z'
   mov	    [.ar_rev2+8],eax
   lea	    esi,[.ar_rev1]
   lea	    edi,[.ar_rev2]
   mov	    ecx,2
   call     rotary
   movlps   xmm0,[.ar_rev2]
   movhps   xmm0,[.ar_rev2+12]
    ;.ar_rev2  - reversed tes area

end if



  ;  movzx   eax,word[ebx]
  ;  pop     edi



   mov	   .smooth_ed,ebx
   mov	   .th_No,eax
   mov	   ebx,[edges_count]
   mov	   ecx,[edges_count]
   shr	   ebx,2
   and	   ecx,11b
   imul    eax,ebx
   mov	   .edStart,eax
   add	   eax,ebx
   cmp	   .th_No,3
   jnz	   @f
   add	   eax,ecx
 @@:
   mov	   .edEnd,eax

   mov	   esi,[edges_ptr]
   mov	   ebx,.edStart
   shl	   ebx,3
   add	   esi,ebx
   mov	   ecx,.edStart
 .nx_ed:   ; next edge
   push    esi
   push    ecx
   mov	   eax,[esi]
   mov	   ebx,[esi+4]
   movd    xmm0,[esi]
   movd    xmm1,[esi+4]
   pshufd  xmm0,xmm0,0
   pshufd  xmm1,xmm1,0
   movdqa  .indexEd1,xmm0
   movdqa  .indexEd2,xmm1
   imul    eax,12
   imul    ebx,12
   add	   eax,[points_r_ptr]
   add	   ebx,[points_r_ptr]
   movups  xmm1,[ebx]
   movups  xmm2,[eax]
   andps   xmm2,[zero_hgst_dd]
   andps   xmm1,[zero_hgst_dd]
   movaps  .vertEd1,xmm2
   movaps  .vertEd2,xmm1
   subps   xmm2,xmm1
   movaps  xmm3,xmm2
   mulps   xmm2,xmm2
   haddps  xmm2,xmm2
   haddps  xmm2,xmm2
   sqrtps  xmm2,xmm2
   movss   .EdLen,xmm2
   rcpps   xmm2,xmm2
   mulps   xmm3,xmm2
   andps   xmm3,[zero_hgst_dd]
   movaps  .normEd,xmm3
   mov	   edi,[triangles_ptr]
   mov	   esi,[triangles_normals_ptr]
   mov	   .tri_cnt,0
 .nx_tri:  ; next triangle
   push    edi
   push    esi
   movdqu  xmm0,[edi]
   movdqu  xmm1,[edi]
   pcmpeqd xmm0,.indexEd1
   pcmpeqd xmm1,.indexEd2
   por	   xmm1,xmm0
   movmskps eax,xmm1
   and	   eax,111b
 ;  popcnt  eax,eax
 ;  cmp     eax,2
   or	   eax,eax
   jnz	   .end_l_tri


   ; Check  dot pr of normal vect of tri and
   ; edge (ray), if its near zero - skip - no intersection.

;   movups  xmm1,[esi]
;   mulps   xmm1,.normEd
;   haddps  xmm1,xmm1
;   haddps  xmm1,xmm1
;   andps   xmm1,[abs_mask]
;   comiss  xmm1,[eps]
;   jb	   .end_l_tri

   mov	   eax,[edi]
   mov	   ebx,[edi+4]
   mov	   edx,[edi+8]
   imul    eax,12
   imul    ebx,12
   imul    edx,12
   add	   eax,[points_r_ptr]
   add	   ebx,[points_r_ptr]
   add	   edx,[points_r_ptr]

   movups   xmm2,[eax]
   movups   xmm3,[ebx]
   movups   xmm4,[edx]
   movaps   .p1t,xmm2	  ; .p1t - tri 1st vertex
   movaps   .p2t,xmm3
   movaps   .p3t,xmm4


;intersect_tri: procs header
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;	 xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...
 @@:
   movaps    xmm0,.normEd
   movaps    xmm1,.vertEd2
   movaps    xmm2,.p1t
   movaps    xmm3,.p2t
   movaps    xmm4,.p3t
   movss     xmm6,.EdLen
   mov	     eax,1
   call      intersect_tri

 .skip:
   cmp	   eax,1
   je	  .inter

  .end_l_tri:
   pop	   esi
   pop	   edi
   add	   esi,12
   add	   edi,12
   inc	   .tri_cnt
   mov	   edx,.tri_cnt
   cmp	   edx,[triangles_count_var]
   jnz	   .nx_tri
  .nx_loop_end:
   pop	   ecx
   pop	   esi
   add	   esi,8
   inc	   ecx
   cmp	   ecx,.edEnd
   jne	   .nx_ed
   jmp	   .end


 .inter:
 ;  [edi] - tri
 ;  [esi] - edge
   cmp	  dword[thread_params+4],0  ; no mark
   jne	  @f
   mov	  eax,ecx  ;.tri_cnt
   mov	  ebx,ecx  ;.tri_cnt
   shr	  eax,3
   and	  ebx,111b
   add	  eax,[edges_intersect_ptr]
   mov	  esi,[eax]
   bts	  esi,ebx
   lock   xchg [eax],esi  ; !! may be slow
  @@:

   cmp	  dword[thread_params+4],0
   je	  .nx_end   ; check smooth inside edges cause
   cmp	  dword[thread_params+4],2
   je	  .sm_ins_vert	; check smooth inside edges - inside vertices algo



   mov	  ebx,.tri_cnt
   imul   ebx,12
   add	  ebx,[triangles_normals_ptr]
   movups  xmm5,[ebx]
   movaps  .tri_norm,xmm5
   shufps  xmm0,xmm0,0	; xmm0 - t
   mulps   xmm0,.normEd
   addps   xmm0,.vertEd2
  ; xmm0 -- intersection point coords
   movaps  xmm7,xmm0
   subps   xmm0,.vertEd1
   mulps   xmm0,.tri_norm
   haddps  xmm0,xmm0
   haddps  xmm0,xmm0 ; dot
   movmskps eax,xmm0

   movaps  xmm0,.normEd
   mulps   xmm0,.value ; remains margin value

   cmp	   eax,0xf
   je	   @f
   addps   xmm7,xmm0
   mov	   ebx,.indexEd1
   jmp	   .fix
  @@:
   mov	   ebx,.indexEd2
   subps   xmm7,xmm0
  .fix:
   imul    ebx,12
   movhlps xmm6,xmm7
   add	   ebx,[thread_params]
   movlps  [ebx],xmm7
   movss   [ebx+8],xmm6
   jmp	   .nx_end

 .sm_ins_vert:


   movaps    .t,xmm0

   movss     xmm1,[f1]
   subss     xmm1,.vx
   subss     xmm1,.vy
   movss     xmm5,.vx
   movss     xmm6,.vy
   shufps    xmm1,xmm1,0
   shufps    xmm5,xmm5,0
   shufps    xmm6,xmm6,0
   mulps     xmm1,.p1t
   mulps     xmm5,.p2t
   mulps     xmm6,.p3t
   addps     xmm1,xmm5
   addps     xmm1,xmm6
   mov	     eax,.indexEd1  ; vertices indexes
   mov	     edx,.indexEd2
   mov	     esi,eax
   mov	     edi,edx
   shr	     esi,3
   shr	     edi,3
   and	     eax,111b
   and	     edx,111b
   mov	     ebx,.indexEd2
   add	     esi,[inner_vert_ptr]
   add	     edi,[inner_vert_ptr]
;  check if at last one vertex is inside
; if yes choose its index to ebx
   bt	     [esi],eax
   jc	     @f
   mov	     ebx,.indexEd1
   jmp	     .ddo
 @@:
   bt	     [edi],edx
   jc	     .nx_end
   mov	     ebx,.indexEd2
 .ddo:
   imul      ebx,12
   add	     ebx,[points_r_ptr]

   movd      ecx,xmm1
   lock      xchg [ebx],ecx
   psrldq    xmm1,4		 ; need test !!
   movd      ecx,xmm1
   lock      xchg [ebx+4],ecx
   psrldq    xmm1,4
   movd      ecx,xmm1
   lock      xchg [ebx+8],ecx

;   movlps    [ebx],xmm1
;   movhlps   xmm1,xmm1
;   movss     [ebx+8],xmm1

  .nx_end:
   pop	  esi
   pop	  edi
   jmp	  .nx_loop_end
 .end:

;   mov     ebx,.ed_coll_ptr
;   mov     ecx,.collEdCnt	 ; Colided edges count

   add	   esp,300
   pop	   ebp
ret

;=============================================================

remove_dead_tri:
;  push  ebp
;  mov	 ebp,esp
  mov	  edi,-1
  movd	  xmm7,edi
  pshufd  xmm7,xmm7,0

  mov	  esi,[triangles_ptr]
  mov	  ecx,[triangles_count_var]
 .chck:
;  jecxz   .cop
  mov	  eax,[esi]
  cmp	  eax,[esi+4]
  je	  .tri_fail
  cmp	  eax,[esi+8]
  je	  .tri_fail
  mov	  eax,[esi+4]
  cmp	  eax,[esi+8]
  je	  .tri_fail
  add	  esi,12
  loop	  .chck
  jmp	  .cop
 .tri_fail:
  movq	  [esi],xmm7
  movd	  [esi+8],xmm7
  add	  esi,12
  loop	  .chck
 .cop:
  mov	  esi,[triangles_ptr]
  mov	  edi,[triangles_ptr]
  mov	  ecx,[triangles_count_var]
  xor	  edx,edx
  cls

 .cp:
  cmp	  [esi],dword -1
  je	  @f
  movsd
  movsd
  movsd
;  movdqu  xmm0,[esi]
;  movq    [edi],xmm0
;  movhlps xmm0,xmm0
;  movd    [edi+8],xmm0
;  add	   edi,12
  inc	  edx
  loop	  .cp
  jmp	  .en_cp
 @@:
  add	  esi,12
  loop	  .cp
 .en_cp:
  mov	  [triangles_count_var],edx
ret
;============================================================

triangulize_all_faces:	   ;; teslate all tris from teslate area
; if eax = 'tiv' - teslate tris with at last one edge
; that intersect other tri and at last one inner vertex
;
   .piv 	 equ  [ebp-4]
   .ptr 	 equ  [ebp-8]
   .index3	 equ  [ebp-12]
   .index2	 equ  [ebp-16]
   .index1	 equ  [ebp-20]
   .mx		 equ  [ebp-56]
   .new_vcnt	 equ  dword[ebp-60]
   .new_vert_ptr equ  [ebp-64]
   .new_tri	 equ  [ebp-68]
   .end_new_tri  equ  dword[ebp-72]
   .endt	 equ  [ebp-76]
   .endin	 equ  [ebp-80]
   .n_tri_cnt	 equ  dword[ebp-84]
   .piv2	 equ  dword[ebp-88]
   .tiv 	 equ  dword[ebp-92]

   push     ebp
   mov	    ebp,esp
   sub	    esp,100

   xor	    ebx,ebx
   mov	    edx,1
   cmp	    eax,'tiv'
   cmove    ecx,edx
   cmovne   ecx,ebx
   mov	    .tiv,ecx
   
   cmp	    cl,1
   jne	    @f
   cmp	    [edges_intersect_ptr],ebx
   je	    .end_aa
   cmp	    [inner_vert_ptr],ebx
   je	    .end_aa
  @@:  
 

   mov	    ebx,[edges_count]
   shl	    ebx,4
   add	    ebx,60
   malloc   ebx
;   invoke   VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;   or	     eax,eax
;   jnz      @f
;   call     mem_error
;  @@:
   mov	   .piv,eax
   malloc  ebx
;   invoke   VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;   or	     eax,eax
;   jnz      @f
;   call     mem_error
;  @@:
   mov	   .piv2,eax

  ; make pivot table of edges
   mov	     edi,.piv
   mov	     esi,[edges_ptr]
   xor	     ecx,ecx
   pxor      xmm0,xmm0
  @@:
   mov	     eax,ecx
   movsd
   stosd
   movsd
   stosd

;   movd      xmm0,ecx
;   movq      xmm1,[esi]
;   pshufd    xmm0,xmm0,0
;   punpckldq xmm1,xmm0
;   movdqa    [edi],xmm1
;   add       edi,16
;   add       esi,8
   inc	     ecx
   cmp	     ecx,[edges_count]
   jne	     @b

 ;sort pivot table	     - sort by qsort !!
   mov	  esi,.piv
   mov	  edi,.piv2

   mov	  .endt,esi	     ; calc end of  .piv
   mov	  ecx,[edges_count]
   add	  ecx,ecx
   mov	  eax,ecx
   shl	  eax,3
   add	  .endt,eax

   call   sort_hybrid1	 ; sort.inc
   invoke   VirtualFree ,.piv2,0 , MEM_RELEASE
   mov	    eax,[points_count_var]
   shl	    eax,2
   add	    eax,60
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   call     mem_error
  @@:
   mov	   .ptr,eax


;make _ptr list
   mov	  esi,.piv
   mov	  edi,.ptr
  .bas:
   mov	  ebx,esi    ; base
  .nob: 	     ; no base
   cmp	  esi,.endt
   ja	 .enn
   mov	  eax,[esi]
   cmp	  eax,[esi+8]
   je	  @f
   shl	  eax,2
   add	  eax,.ptr
   mov	  [eax],ebx   ; ptr of vertices, each position point to edges pivot tab
   add	  esi,8
   jne	  .bas
   jmp	  .enn
  @@:
   add	  esi,8
   cmp	  esi,.endt
   jna	  .nob

 .enn:

   mov	  eax,[edges_count]
   add	  eax,[points_count_var]
   mov	  .new_vcnt,eax    ; all vertices count
   add	  eax,10
   shl	  eax,2
   lea	  eax,[eax*3]

   invoke VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	  eax,eax
   jnz	  @f
   call   mem_error
  @@:
   mov	  .new_vert_ptr,eax   ; new vertices and old vertices

   mov	  esi,[points_rotated_ptr]
   mov	  edi,eax
   mov	  ecx,[points_count_var]
   lea	  ecx,[ecx*3]
   push   ecx
   inc	  ecx
   cld
 @@:
   rep	  movsd

   pop	  edi
   shl	  edi,2
   add	  edi,eax

   mov	    esi,[edges_ptr]	; calc all new vertices
   mov	    ecx,[edges_count]
   mov	    eax,0.5
   movd     xmm0,eax
   shufps   xmm0,xmm0,0
   cld
   mov	   edx,[points_rotated_ptr]
 .calc_mid_vert:
   lodsd
   xchg     eax,ebx
   lodsd
   xchg     eax,ebx
   imul     eax,12
   imul     ebx,12
   add	    eax,edx
   add	    ebx,edx
   movups   xmm1,[eax]
   movups   xmm2,[ebx]
   addps    xmm2,xmm1
   mulps    xmm2,xmm0
   movups   [edi],xmm2
   add	    edi,12
   loop     .calc_mid_vert



   mov	    eax,[triangles_count_var]
   lea	    eax,[eax*3]
   shl	    eax,4
   add	    eax,60
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   call     mem_error
  @@:
   mov	    .new_tri,eax


   mov	  esi,[triangles_ptr]
   mov	  edi,eax
   mov	  ecx,[triangles_count_var]
   lea	  ecx,[ecx*3]
   push   ecx
   inc	  ecx
   cld
 @@:
  rep	 movsd

   pop	  ecx
   shl	  ecx,2
   add	  ecx,eax
   mov	  .end_new_tri,ecx
   xor	  esi,esi
   
   mov	    .n_tri_cnt,esi

   mov	    esi,.new_tri
   xor	    ecx,ecx
  .chck:
   push     ecx
   push     esi
   cmp	    [tes_mod_flag],1  ; test if in do test - 'in teslate area'
   je	    .in_area	      ; no ?

   mov	    eax,[esi]
   mov	    ebx,[esi+4]
   mov	    edx,[esi+8]
   imul     eax,12
   imul     ebx,12
   imul     edx,12
   add	    eax,[points_rotated_ptr]
   add	    ebx,[points_rotated_ptr]
   add	    edx,[points_rotated_ptr]
   movlps   xmm0,[eax]
   movlps   xmm1,[ebx]
   movlps   xmm2,[edx]
   movlhps  xmm0,xmm0
   movlhps  xmm1,xmm1
   movlhps  xmm2,xmm2

   cmpltps  xmm0,[tri_area_x1]	  ; check if whole tri in teslate area
   cmpltps  xmm1,[tri_area_x1]
   cmpltps  xmm2,[tri_area_x1]
   movhlps  xmm3,xmm0
   movhlps  xmm4,xmm1
   movhlps  xmm5,xmm2
   xorps    xmm3,xmm0
   xorps    xmm4,xmm1
   xorps    xmm5,xmm2
   andps    xmm3,xmm4
   andps    xmm3,xmm5
   movmskps eax,xmm3
   and	    eax,11b
   cmp	    eax,11b
  
   je	    .in_area

  .chck_nx:
   pop	    esi
   pop	    ecx
   add	    esi,12
   inc	    ecx
   cmp	    ecx,[triangles_count_var]
   jnz	    .chck

   jmp	    .fin


 .in_area:   ; whole tri in teslate area
   mov	    eax,ecx
   cmp	    .tiv,1
   jne	    .nxxx  ; tiv checking ??
   movdqu   xmm1,[esi]
   mov	    ecx,3
  @@: 
   movd     ebx,xmm1
   mov	    edx,ebx
   shr	    edx,3
   and	    ebx,111b
   add	    edx,[inner_vert_ptr]
   bt	    dword [edx],ebx
   jnc	    .nxxx
   psrldq   xmm1,4
   loop     @b
   jmp	    .chck_nx

  .nxxx:
      

   
   
   cmp	    [td_wp_flag],1  ; positive Z only  ?
   jne	    @f
   imul     eax,12
   add	    eax,[triangles_normals_rotated_ptr]
   bt	    dword[eax+8],31
   jnc	    .chck_nx
 @@:

   ; search for correct ed index
   movd      xmm7,esi
   movdqu    xmm0,[esi]    ;  edges
   movdqu    xmm1,[esi]
   pshufd    xmm1,xmm1,11001001b
   movd      .endin,xmm1       ; end index

   mov	    ecx,3
 .in1:
   push     ecx

 .nxv:
   movd     .endin,xmm1       ; end index
   movd     eax,xmm0
;   mov      eax,[esi]	      ; esi - vert index
   shl	    eax,2
   add	    eax,.ptr	     ; eax -  addr in pivot table
			     ; ptr to all edges with this vert
   mov	    edi,[eax]
 .pi:			     ; search for edge

   mov	    ebx,[edi+4]      ; ebx - ed index
   shl	    ebx,3
   add	    ebx,[edges_ptr]
   mov	    ecx,2
 .cm:
   mov	    edx,[ebx]	     ; ebx - vert index
;   cmp      edx,[esi]	     ; 1st index - first index is for sure
;   je	     .ok1
   cmp	    edx,.endin	 ;[esi+4]      ; 2cond
   je	    .ok1
;   cmp      edx,[esi+8]      ; 3dr
;   je	     .ok1
   add	    ebx,4
   loop     .cm

   mov	    ecx,[edi]	   ;  [edi] - vert index
   add	    edi,8
   cmp	    ecx,[edi]
   je	    .pi 	   ; next pos in pivot table

    int3  ;sth wrong

 .ok1:

   pop	    ecx
   mov	    ebx,ecx
   psrldq   xmm0,4
   psrldq   xmm1,4
   dec	    ebx
   shl	    ebx,2
   lea	    eax,.index3
   sub	    eax,ebx
;		  dword[edi+4]	   -   index   of edge
   mov	    edx,[points_count_var]
   add	    edx,[edi+4]
   mov	    [eax],edx
   loop     .in1


  ; write new triangles - append to list

   mov	    edi,.end_new_tri
   movd     esi,xmm7

 ;  movd     mm4,.index1  ;[edi]  ;   (x)mm4 - (x)mm6	->  indexes
 ;  movd     mm5,.index2  ;[edi+4]
 ;  movd     mm6,.index3  ;[edi+8]

   mov	    eax,[points_count_var]
   
   cmp	    .tiv,1   ; tiv checking ?
   jne	    .yes_inters
   mov	    ecx,3
   movdqu   xmm4,.index1
  @@: 
   movd     edx,xmm4  
   sub	    edx,eax
   mov	    ebx,edx
   shr	    edx,3
   and	    ebx,111b
   add	    edx,[edges_intersect_ptr]
   bt	    dword[edx],ebx
   jc	    .yes_inters
   psrldq   xmm4,4
   loop     @b
   jmp	    .chck_nx
	

  .yes_inters:


   mov	    edi,.end_new_tri
   movd     esi,xmm7
   
 ;  int3
   movd     xmm4,[esi]
   movd     xmm5,[esi+4]
   movd     xmm6,[esi+8]

   cld
   xchg     edi,esi
   
   movd     eax,xmm4 
   stosd
   mov	    eax,.index1
   stosd
   mov	    eax,.index3
   stosd	  
   xchg     edi,esi		  ;		  x4
				  ;		 /  \
				  ;	      in1 -- in3
				  ;	       / \  /  \
    mov      eax,.index1	  ;	      x5-in2 - x6
    stosd						   
    mov      eax,.index2
    stosd
    mov      eax,.index3
    stosd

    mov      eax,.index1
    stosd  
    movd	 eax,xmm5
    stosd
    mov      eax,.index2
    stosd

    mov      eax,.index3
    stosd  
    mov      eax,.index2
    stosd
    movd     eax,xmm6
    stosd
 

;   add      .end_new_tri,36
   mov	    .end_new_tri,edi
   add	    .n_tri_cnt,3
   jmp	    .chck_nx


  .fin:

  ;reverse points_rotated to points_r
   pxor     xmm0,xmm0
   cvtdq2ps xmm3,[xxadd]
   movlhps   xmm3,xmm0 ;[the_zero]
   mov	    edi,.new_vert_ptr
   mov	    ecx,.new_vcnt    ; vert number
 @@:
   movlps   xmm0,[edi]
   subps    xmm0,xmm3
   movlps   [edi],xmm0
   add	    edi,12
   loop     @b


   mov	    esi,matrix_scaled
   lea	    edi,.mx
   call     reverse_mx_3x3


   mov	    esi,.new_vert_ptr  ;[.area] 	 ; reverse transform tri area
   lea	    ebx,.mx
   mov	    edi,esi
   mov	    ecx,.new_vcnt
   call     rotary



   invoke  VirtualFree ,[points_r_ptr],0 , MEM_RELEASE
   invoke  VirtualFree ,[triangles_ptr],0 , MEM_RELEASE
   invoke  VirtualFree ,.piv,0 , MEM_RELEASE
   invoke  VirtualFree ,.ptr,0 , MEM_RELEASE



    mov      esi,.new_tri
    mov      edi,.new_vert_ptr
    mov      [triangles_ptr],esi
    mov      [points_r_ptr],edi
    mov      ecx,.new_vcnt
    mov      ebx,.n_tri_cnt
    mov      [points_count_var],ecx
    add      [triangles_count_var],ebx
    
  .end_aa:

    mov      esp,ebp
    pop      ebp
ret


;====================================================================

do_variable_slices_ptr_buff:
; Procedure match every screen pixel with ptr, wich describes
; its depth history. If dword ptr = byte cnt = 0, not depth
; history, pixel has background color.
; in:  esi - counter buff
;      edi - ptr buff
;      eax - voxels depth history buff
;      ecx - count of all screen pixels
       jecxz  .end
     .again:
       movzx  edx,byte[esi]
       or     edx,edx
       jz     .zero
       mov    [edi],eax
       shl    edx,2
       add    eax,edx
       jmp    .u_cnts
     .zero:
       mov    [edi],dword 0
     .u_cnts:
       inc    esi
       add    edi,4
       loop    .again
    .end:
ret
;================================================
count_transparent_voxels:     ; Thanks Agner Fog for optimiztion
			      ; phaddb on sse2	 :D
; in:
;    edi - ptr to slices_cnt buffer
;	   this buff describes how many
;	   slices has every rendered pixel
;    eax - size x of screen
;    ebx - size y of scr
; out:
;    ecx - count of all transparent voxels

     push     ebp

     mul      ebx

     mov      ecx,eax
     and      eax,1111b
     shr      ecx,4
     xor      ebx,ebx
     pxor     xmm3,xmm3

  @@:
     movups   xmm1,[edi]
     pxor     xmm0,xmm0
     psadbw   xmm1,xmm0
     pshufd   xmm0,xmm1,0x0e
     paddd    xmm0,xmm1
     paddd    xmm3,xmm0
     add      edi,16
     loop     @b
     mov      ecx,eax
     jecxz    .en
   @@:
     movzx   eax,byte[edi]
     add     ebx,eax
     loop    @b
    .en:
     movd   ecx,xmm3
     add    ecx,ebx
     pop    ebp
ret

 ;=========================================================================

remove_unused_vertices:
; in:
;    eax - triangles (faces) ptr
;    ebx - points (vertices) ptr
;    ecx - triangles (faces) count
;    edx - points (vertices) count
; out:
;    changed points_ptr(ebx) list
;    ecx - new vertices count

    push  ebp
    mov   ebp,esp
;    sub   esp,32

  .triangles_ptr	   equ [ebp-4]
  .points_ptr		   equ [ebp-8]
  .triangles_count	   equ [ebp-12]
  .points_count 	   equ dword[ebp-16]
  .nt			   equ [ebp-20]
  .accc 		   equ dword[ebp-24]
  .endt 		   equ [ebp-28]
  .nt1			   equ dword[ebp-32]
  .mrk			   equ word[ebp-34]

  push	eax
  push	ebx
  push	ecx
  push	edx
  sub	esp,30


  prompt  prompt_unused_vert

  mov	  ebx,[triangles_count_var]  ;.triangles_count
  imul	  ebx,12
  add	  ebx,6400
  malloc  ebx
  mov	  .nt,eax

  malloc  ebx
  mov	 .nt1,eax


  mov	   esi,[triangles_ptr]	;.triangles_ptr
  mov	   edi,.nt
  mov	   ecx,[triangles_count_var]
  lea	   ecx,[ecx*3]
  push	   ecx
  cld
  rep	   movsd

       pop	ecx
       mov	esi,.nt
       mov	edi,.nt1
       mov	ecx,[triangles_count_var]  ;.triangles_count
       lea	ecx,[ecx*3]
       call	sort_hybrid_dd

;    sort_hybrid_dd  calling conv
; in:  esi - 1st table
;      edi - sec table
;      ecx - tables_units count - unit 4 bytes
; out:
;      sorted first table



     invoke  VirtualFree,.nt1,0 , MEM_RELEASE



      mov     .accc,0	 ; init accumulator

   mov	   ecx,.points_count
   shl	   ecx,2
   lea	   ecx,[ecx*3]
   add	   ecx,.points_ptr
   mov	   .endt,ecx



 ; search for unused
   xor	   edx,edx
   mov	   esi,.nt

   xor	   eax,eax
   mov	   ebx,[esi]
   mov	  .mrk,1
   cmp	  [esi],dword 0 	; cause, when first isnt '0'
   jne	  .rm1
  .bckrm1:	     ; back
   mov	   .mrk,0    ; mark
   mov	   esi,.nt
   mov	   ecx,[triangles_count_var]  ;.triangles_count
   lea	   ecx,[ecx*3]
   dec	    ecx

   cld
  .ll:
   push    ecx
   lodsd
   cmp	   eax,[esi]
   je	   @f
   inc	   eax
   cmp	   eax,[esi]
   jne	   .fn	   ; found unused
  .nx2:

 @@:
   pop	   ecx
   loop    .ll

   jmp	   .en

 .fn:	; found "hole" in list
   movd    xmm0,[esi]
   push    esi	 ; eax - index
   push    ecx


   mov	   ebx,[esi]
   sub	   ebx,eax	 ; ebx - delta
   mov	   edx,ebx
   sub	   eax,.accc
 .rm1:
   mov	   edx,ebx
   mov	   esi,[triangles_ptr]
   mov	   ecx,[triangles_count_var]
   lea	   ecx,[ecx*3]
 @@:
   xor	   edi,edi
   cmp	   [esi],eax
   cmovae  edi,ebx
   sub	   [esi],edi
   add	   esi,4
   loop    @b


   mov	   edi,eax
   lea	   edi,[edi*3]
   shl	   edi,2
   add	   edi,.points_ptr


   mov	   esi,edi
   shl	   ebx,2
   lea	   ebx,[ebx*3]
   add	   esi,ebx

   cmp	   esi,.endt
   ja	   .ad1
 @@:
   movsd
   movsd
   movsd
   cmp	   esi,.endt
   jbe	   @b

  .ad1:

   add	   .accc,edx	    ; accumulator of "holes" value

   btr	   .mrk,0	    ; check higest
   jc	   .bckrm1



   pop	   ecx
   pop	   esi

   jmp	   .nx2



  .en:

      mov     eax,.accc
      mov     ebx,[points_count_var]
      sub     ebx,eax
      inc     dword[esi]
      cmp     [esi],ebx
      cmovna   ebx,[esi]
      mov     [points_count_var],ebx



   invoke  VirtualFree,.nt,0 , MEM_RELEASE

   mov	   ecx,[points_count_var]

   cls
   mov	   esp,ebp
   pop	   ebp

ret


